/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(Y){for(var e=[],D=0,L=Y.length;D<L;D++)e[D]=te[Y[D]];return e};define(te[90],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[63],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let h in i)D.call(i,h)&&I.push(i[h]);return I}e.values=L;function R(i,I){for(let h in i)if(D.call(i,h)&&I({key:h,value:i[h]},function(){delete i[h]})===!1)return}e.forEach=R;function A(i,I){const h=Object.create(null);for(const p of i){const u=I(p);let f=h[u];f||(f=h[u]=[]),f.push(p)}return h}e.groupBy=A;function k(i){const I=Object.create(null);return i&&i.forEach((h,p)=>{I[p]=h}),I}e.fromMap=k;function P(i,I){const h=[],p=[];for(let u of i)I.has(u)||h.push(u);for(let u of I)i.has(u)||p.push(u);return{removed:h,added:p}}e.diffSets=P;function m(i,I){const h=[],p=[];for(let[u,f]of i)I.has(u)||h.push(f);for(let[u,f]of I)i.has(u)||p.push(f);return{removed:h,added:p}}e.diffMaps=m;class E{constructor(){this.map=new Map}add(I,h){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(h)}delete(I,h){const p=this.map.get(I);!p||(p.delete(h),p.size===0&&this.map.delete(I))}forEach(I,h){const p=this.map.get(I);!p||p.forEach(h)}}e.SetMap=E}),define(te[64],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,m,E)=>{let i=null,I=null;if(typeof E.value=="function"?(i="value",I=E.value):typeof E.get=="function"&&(i="get",I=E.get),!I)throw new Error("not supported");E[i]=k(I,m)}}e.createDecorator=D;function L(k,P,m){let E=null,i=null;if(typeof m.value=="function"?(E="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",i=m.get),!i)throw new Error("not supported");const I=`$memoize$${P}`;m[E]=function(...h){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[I]}}e.memoize=L;function R(k,P,m){return D((E,i)=>{const I=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...p){this[h]||(this[h]=m?m():void 0),clearTimeout(this[I]),P&&(this[h]=P(this[h],...p),p=[this[h]]),this[I]=setTimeout(()=>{E.apply(this,p),this[h]=m?m():void 0},k)}})}e.debounce=R;function A(k,P,m){return D((E,i)=>{const I=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...f){if(this[h]||(this[h]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...f)),this[u])return;const b=this[p]+k;b<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[p]=Date.now(),E.apply(this,[this[h]]),this[h]=m?m():void 0},b-Date.now()))}})}e.throttle=A}),define(te[11],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(a=>{a(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=L;function R(s){m(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=R;function A(s){m(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=A;function k(s){if(s instanceof Error){let{name:t,message:a}=s;const n=s.stacktrace||s.stack;return{$isError:!0,name:t,message:a,stack:n}}return s}e.transformErrorForSerialization=k;const P="Canceled";function m(s){return s instanceof Error&&s.name===P&&s.message===P}e.isPromiseCanceledError=m;class E extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=E;function i(){const s=new Error(P);return s.name=s.message,s}e.canceled=i;function I(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=I;function h(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=h;function p(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function u(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function f(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=f;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class S extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=S;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function v(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function o(s,t=Object.create(null)){const a=new Error(s);return t.actions&&(a.actions=t.actions),a}e.createErrorWithActions=o}),define(te[18],ne([0,1,11]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L($,J=0){return $[$.length-(1+J)]}e.tail=L;function R($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=R;function A($,J,_=(W,K)=>W===K){if($===J)return!0;if(!$||!J||$.length!==J.length)return!1;for(let W=0,K=$.length;W<K;W++)if(!_($[W],J[W]))return!1;return!0}e.equals=A;function k($,J,_){let W=0,K=$.length-1;for(;W<=K;){const Q=(W+K)/2|0,Z=_($[Q],J);if(Z<0)W=Q+1;else if(Z>0)K=Q-1;else return Q}return-(W+1)}e.binarySearch=k;function P($,J){let _=0,W=$.length;if(W===0)return 0;for(;_<W;){const K=Math.floor((_+W)/2);J($[K])?W=K:_=K+1}return _}e.findFirstInSorted=P;function m($,J,_){if($=$|0,$>=J.length)throw new TypeError("invalid index");let W=J[Math.floor(J.length*Math.random())],K=[],Q=[],Z=[];for(let se of J){const le=_(se,W);le<0?K.push(se):le>0?Q.push(se):Z.push(se)}return $<K.length?m($,K,_):$<K.length+Z.length?Z[0]:m($-(K.length+Z.length),Q,_)}e.quickSelect=m;function E($,J){const _=[];let W;for(const K of $.slice(0).sort(J))!W||J(W[0],K)!==0?(W=[K],_.push(W)):W.push(K);return _}e.groupBy=E;function i($,J,_){const W=[];function K(se,le,ce){if(le===0&&ce.length===0)return;const ge=W[W.length-1];ge&&ge.start+ge.deleteCount===se?(ge.deleteCount+=le,ge.toInsert.push(...ce)):W.push({start:se,deleteCount:le,toInsert:ce})}let Q=0,Z=0;for(;;){if(Q===$.length){K(Q,0,J.slice(Z));break}if(Z===J.length){K(Q,$.length-Q,[]);break}const se=$[Q],le=J[Z],ce=_(se,le);ce===0?(Q+=1,Z+=1):ce<0?(K(Q,1,[]),Q+=1):ce>0&&(K(Q,0,[le]),Z+=1)}return W}e.sortedDiff=i;function I($,J,_){const W=i($,J,_),K=[],Q=[];for(const Z of W)K.push(...$.slice(Z.start,Z.start+Z.deleteCount)),Q.push(...Z.toInsert);return{removed:K,added:Q}}e.delta=I;function h($,J,_){if(_===0)return[];const W=$.slice(0,_).sort(J);return u($,J,W,_,$.length),W}e.top=h;function p($,J,_,W,K){return _===0?Promise.resolve([]):new Promise((Q,Z)=>{(async()=>{const se=$.length,le=$.slice(0,_).sort(J);for(let ce=_,ge=Math.min(_+W,se);ce<se;ce=ge,ge=Math.min(ge+W,se)){if(ce>_&&await new Promise(we=>setTimeout(we)),K&&K.isCancellationRequested)throw(0,D.canceled)();u($,J,le,ce,ge)}return le})().then(Q,Z)})}e.topAsync=p;function u($,J,_,W,K){for(const Q=_.length;W<K;W++){const Z=$[W];if(J(Z,_[Q-1])<0){_.pop();const se=P(_,le=>J(Z,le)<0);_.splice(se,0,Z)}}}function f($){return $.filter(J=>!!J)}e.coalesce=f;function b($){let J=0;for(let _=0;_<$.length;_++)$[_]&&($[J]=$[_],J+=1);$.length=J}e.coalesceInPlace=b;function S($,J,_){$.splice(_,0,$.splice(J,1)[0])}e.move=S;function C($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=C;function v($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=v;function o($,J){if(!J)return $.filter((W,K)=>$.indexOf(W)===K);const _=Object.create(null);return $.filter(W=>{const K=J(W);return _[K]?!1:(_[K]=!0,!0)})}e.distinct=o;function s($){const J=new Set;return $.filter(_=>J.has(_)?!1:(J.add(_),!0))}e.distinctES6=s;function t($){const J=Object.create(null);return _=>{const W=$(_);return J[W]?!1:(J[W]=!0,!0)}}e.uniqueFilter=t;function a($,J){for(let _=$.length-1;_>=0;_--){const W=$[_];if(J(W))return _}return-1}e.lastIndex=a;function n($,J){return $.length>0?$[0]:J}e.firstOrDefault=n;function r($,J,_=(W,K)=>W===K){let W=0;for(let K=0,Q=Math.min($.length,J.length);K<Q&&_($[K],J[K]);K++)W++;return W}e.commonPrefixLength=r;function l($){return[].concat(...$)}e.flatten=l;function c($,J){let _=typeof J=="number"?$:0;typeof J=="number"?_=$:(_=0,J=$);const W=[];if(_<=J)for(let K=_;K<J;K++)W.push(K);else for(let K=_;K>J;K--)W.push(K);return W}e.range=c;function d($,J,_){return $.reduce((W,K)=>(W[J(K)]=_?_(K):K,W),Object.create(null))}e.index=d;function g($,J){return $.push(J),()=>w($,J)}e.insert=g;function w($,J){const _=$.indexOf(J);if(_>-1)return $.splice(_,1),J}e.remove=w;function T($,J,_){const W=$.slice(0,J),K=$.slice(J);return W.concat(_,K)}e.arrayInsert=T;function O($,J){let _;if(typeof J=="number"){let W=J;_=()=>{const K=Math.sin(W++)*179426549;return K-Math.floor(K)}}else _=Math.random;for(let W=$.length-1;W>0;W-=1){const K=Math.floor(_()*(W+1)),Q=$[W];$[W]=$[K],$[K]=Q}}e.shuffle=O;function y($,J){const _=$.indexOf(J);_>-1&&($.splice(_,1),$.unshift(J))}e.pushToStart=y;function F($,J){const _=$.indexOf(J);_>-1&&($.splice(_,1),$.push(J))}e.pushToEnd=F;function M($,J){return Array.isArray($)?$.map(J):J($)}e.mapArrayOrNot=M;function q($){return Array.isArray($)?$:[$]}e.asArray=q;function j($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=j;function U($,J){for(const _ of $){const W=J(_);if(W!==void 0)return W}}e.mapFind=U;function z($,J,_){const W=x($,J),K=$.length,Q=_.length;$.length=K+Q;for(let Z=K-1;Z>=W;Z--)$[Z+Q]=$[Z];for(let Z=0;Z<Q;Z++)$[Z+W]=_[Z]}e.insertInto=z;function V($,J,_,W){const K=x($,J),Q=$.splice(K,_);return z($,K,W),Q}e.splice=V;function x($,J){return J<0?Math.max(J+$.length,0):Math.min(J,$.length)}function B($,J){let _=Number.MAX_SAFE_INTEGER,W=0;return $.forEach((K,Q)=>{const Z=J(K);Z<_&&(_=Z,W=Q)}),W}e.minIndex=B;function N($,J){let _=Number.MIN_SAFE_INTEGER,W=0;return $.forEach((K,Q)=>{const Z=J(K);Z>_&&(_=Z,W=Q)}),W}e.maxIndex=N;class G{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let _=this.firstIdx;for(;_<this.items.length&&J(this.items[_]);)_++;const W=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,W}takeFromEndWhile(J){let _=this.lastIdx;for(;_>=0&&J(this.items[_]);)_--;const W=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,W}}e.ArrayQueue=G}),define(te[65],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let A=!1,k;return function(){return A||(A=!0,k=L.apply(R,arguments)),k}}e.once=D}),define(te[55],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}L.is=R;const A=Object.freeze([]);function k(){return A}L.empty=k;function*P(s){yield s}L.single=P;function m(s){return s||A}L.from=m;function E(s){return!s||s[Symbol.iterator]().next().done===!0}L.isEmpty=E;function i(s){return s[Symbol.iterator]().next().value}L.first=i;function I(s,t){for(const a of s)if(t(a))return!0;return!1}L.some=I;function h(s,t){for(const a of s)if(t(a))return a}L.find=h;function*p(s,t){for(const a of s)t(a)&&(yield a)}L.filter=p;function*u(s,t){let a=0;for(const n of s)yield t(n,a++)}L.map=u;function*f(...s){for(const t of s)for(const a of t)yield a}L.concat=f;function*b(s){for(const t of s)for(const a of t)yield a}L.concatNested=b;function S(s,t,a){let n=a;for(const r of s)n=t(n,r);return n}L.reduce=S;function*C(s,t,a=s.length){for(t<0&&(t+=s.length),a<0?a+=s.length:a>s.length&&(a=s.length);t<a;t++)yield s[t]}L.slice=C;function v(s,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,s];const n=s[Symbol.iterator]();for(let r=0;r<t;r++){const l=n.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return n}}]}L.consume=v;function o(s,t,a=(n,r)=>n===r){const n=s[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=n.next(),c=r.next();if(l.done!==c.done)return!1;if(l.done)return!0;if(!a(l.value,c.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(te[33],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function k(t,a=!1){let n=0,r=t.length,l="",c=0,d=16,g=0;function w(j){let U=0,z=0;for(;U<j;){const V=t.charCodeAt(n);if(V>=48&&V<=57)z=z*16+V-48;else if(V>=65&&V<=70)z=z*16+V-65+10;else if(V>=97&&V<=102)z=z*16+V-97+10;else break;n++,U++}return U<j&&(z=-1),z}function T(j){n=j,l="",c=0,d=16,g=0}function O(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&E(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&E(t.charCodeAt(n)))for(n++;n<t.length&&E(t.charCodeAt(n));)n++;else return g=3,t.substring(j,n);let U=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&E(t.charCodeAt(n))){for(n++;n<t.length&&E(t.charCodeAt(n));)n++;U=n}else g=3;return t.substring(j,U)}function y(){let j="",U=n;for(;;){if(n>=r){j+=t.substring(U,n),g=2;break}const z=t.charCodeAt(n);if(z===34){j+=t.substring(U,n),n++;break}if(z===92){if(j+=t.substring(U,n),n++,n>=r){g=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const x=w(4);x>=0?j+=String.fromCharCode(x):g=4;break;default:g=5}U=n;continue}if(z>=0&&z<=31)if(m(z)){j+=t.substring(U,n),g=2;break}else g=6;n++}return j}function F(){if(l="",g=0,c=n,n>=r)return c=r,d=17;let j=t.charCodeAt(n);if(P(j)){do n++,l+=String.fromCharCode(j),j=t.charCodeAt(n);while(P(j));return d=15}if(m(j))return n++,l+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,l+=`
`),d=14;switch(j){case 123:return n++,d=1;case 125:return n++,d=2;case 91:return n++,d=3;case 93:return n++,d=4;case 58:return n++,d=6;case 44:return n++,d=5;case 34:return n++,l=y(),d=10;case 47:const U=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!m(t.charCodeAt(n));)n++;return l=t.substring(U,n),d=12}if(t.charCodeAt(n+1)===42){n+=2;const z=r-1;let V=!1;for(;n<z;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,g=1),l=t.substring(U,n),d=13}return l+=String.fromCharCode(j),n++,d=16;case 45:if(l+=String.fromCharCode(j),n++,n===r||!E(t.charCodeAt(n)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=O(),d=11;default:for(;n<r&&M(j);)n++,j=t.charCodeAt(n);if(c!==n){switch(l=t.substring(c,n),l){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return l+=String.fromCharCode(j),n++,d=16}}function M(j){if(P(j)||m(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:T,getPosition:()=>n,scan:a?q:F,getToken:()=>d,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>g}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,a){const n=[],r=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function g(w,T,O,y){c.value=w,c.offset=T,c.length=O,c.type=y,c.colonOffset=void 0,l=c}try{v(t,{onObjectBegin:(w,T)=>{if(a<=w)throw r;l=void 0,d=a>w,n.push("")},onObjectProperty:(w,T,O)=>{if(a<T||(g(w,T,O,"property"),n[n.length-1]=w,a<=T+O))throw r},onObjectEnd:(w,T)=>{if(a<=w)throw r;l=void 0,n.pop()},onArrayBegin:(w,T)=>{if(a<=w)throw r;l=void 0,n.push(0)},onArrayEnd:(w,T)=>{if(a<=w)throw r;l=void 0,n.pop()},onLiteralValue:(w,T,O)=>{if(a<T||(g(w,T,O,s(w)),a<=T+O))throw r},onSeparator:(w,T,O)=>{if(a<=T)throw r;if(w===":"&&l&&l.type==="property")l.colonOffset=T,d=!1,l=void 0;else if(w===","){const y=n[n.length-1];typeof y=="number"?n[n.length-1]=y+1:(d=!0,n[n.length-1]=""),l=void 0}}})}catch(w){if(w!==r)throw w}return{path:n,previousNode:l,isAtPropertyKey:d,matches:w=>{let T=0;for(let O=0;T<w.length&&O<n.length;O++)if(w[T]===n[O]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}e.getLocation=I;function h(t,a=[],n=A.DEFAULT){let r=null,l=[];const c=[];function d(w){Array.isArray(l)?l.push(w):r!==null&&(l[r]=w)}return v(t,{onObjectBegin:()=>{const w={};d(w),c.push(l),l=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const w=[];d(w),c.push(l),l=w,r=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:d,onError:(w,T,O)=>{a.push({error:w,offset:T,length:O})}},n),l[0]}e.parse=h;function p(t,a=[],n=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function c(w){return r.children.push(w),w}v(t,{onObjectBegin:w=>{r=c({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,T,O)=>{r=c({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:T,length:O,parent:r})},onObjectEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,l(w+T)},onArrayBegin:(w,T)=>{r=c({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,T)=>{r.length=w+T-r.offset,r=r.parent,l(w+T)},onLiteralValue:(w,T,O)=>{c({type:s(w),offset:T,length:O,parent:r,value:w}),l(T+O)},onSeparator:(w,T,O)=>{r.type==="property"&&(w===":"?r.colonOffset=T:w===","&&l(T))},onError:(w,T,O)=>{a.push({error:w,offset:T,length:O})}},n);const g=r.children[0];return g&&delete g.parent,g}e.parseTree=p;function u(t,a){if(!t)return;let n=t;for(let r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===r){n=c.children[1],l=!0;break}if(!l)return}else{const l=r;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=u;function f(t){if(!t.parent||!t.parent.children)return[];const a=f(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;a.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&a.push(n)}return a}e.getNodePath=f;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const a=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(a[n.children[0].value]=b(r))}return a;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function S(t,a,n=!1){return a>=t.offset&&a<t.offset+t.length||n&&a===t.offset+t.length}e.contains=S;function C(t,a,n=!1){if(S(t,a,n)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=a;l++){const c=C(r[l],a,n);if(c)return c}return t}}e.findNodeAtOffset=C;function v(t,a,n=A.DEFAULT){const r=k(t,!1);function l(_){return _?()=>_(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(_){return _?W=>_(W,r.getTokenOffset(),r.getTokenLength()):()=>!0}const d=l(a.onObjectBegin),g=c(a.onObjectProperty),w=l(a.onObjectEnd),T=l(a.onArrayBegin),O=l(a.onArrayEnd),y=c(a.onLiteralValue),F=c(a.onSeparator),M=l(a.onComment),q=c(a.onError),j=n&&n.disallowComments,U=n&&n.allowTrailingComma;function z(){for(;;){const _=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:j||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(_){case 12:case 13:j?V(10):M();break;case 16:V(1);break;case 15:case 14:break;default:return _}}}function V(_,W=[],K=[]){if(q(_),W.length+K.length>0){let Q=r.getToken();for(;Q!==17;){if(W.indexOf(Q)!==-1){z();break}else if(K.indexOf(Q)!==-1)break;Q=z()}}}function x(_){const W=r.getTokenValue();return _?y(W):g(W),z(),!0}function B(){switch(r.getToken()){case 11:let _=0;try{_=JSON.parse(r.getTokenValue()),typeof _!="number"&&(V(2),_=0)}catch(W){V(2)}y(_);break;case 7:y(null);break;case 8:y(!0);break;case 9:y(!1);break;default:return!1}return z(),!0}function N(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(x(!1),r.getToken()===6?(F(":"),z(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function G(){d(),z();let _=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(_||V(4,[],[]),F(","),z(),r.getToken()===2&&U)break}else _&&V(6,[],[]);N()||V(4,[],[2,5]),_=!0}return w(),r.getToken()!==2?V(7,[2],[]):z(),!0}function $(){T(),z();let _=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(_||V(4,[],[]),F(","),z(),r.getToken()===4&&U)break}else _&&V(6,[],[]);J()||V(4,[],[4,5]),_=!0}return O(),r.getToken()!==4?V(8,[4],[]):z(),!0}function J(){switch(r.getToken()){case 3:return $();case 1:return G();case 10:return x(!0);default:return B()}}return z(),r.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=v;function o(t,a){let n=k(t),r=[],l,c=0,d;do switch(d=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:c!==d&&r.push(t.substring(c,d)),a!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,a)),c=n.getPosition();break}while(l!==17);return r.join("")}e.stripComments=o;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(te[48],ne([0,1,33]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(m,E,i){let I,h,p,u,f;if(E){for(u=E.offset,f=u+E.length,p=u;p>0&&!P(m,p-1);)p--;let c=f;for(;c<m.length&&!P(m,c);)c++;h=m.substring(p,c),I=A(h,i)}else h=m,I=0,p=0,u=0,f=m.length;const b=k(i,m);let S=!1,C=0,v;i.insertSpaces?v=R(" ",i.tabSize||4):v="	";const o=(0,D.createScanner)(h,!1);let s=!1;function t(){return b+R(v,I+C)}function a(){let c=o.scan();for(S=!1;c===15||c===14;)S=S||c===14,c=o.scan();return s=c===16||o.getTokenError()!==0,c}const n=[];function r(c,d,g){!s&&d<f&&g>u&&m.substring(d,g)!==c&&n.push({offset:d,length:g-d,content:c})}let l=a();if(l!==17){const c=o.getTokenOffset()+p,d=R(v,I);r(d,p,c)}for(;l!==17;){let c=o.getTokenOffset()+o.getTokenLength()+p,d=a(),g="";for(;!S&&(d===12||d===13);){const T=o.getTokenOffset()+p;r(" ",c,T),c=o.getTokenOffset()+o.getTokenLength()+p,g=d===12?t():"",d=a()}if(d===2)l!==1&&(C--,g=t());else if(d===4)l!==3&&(C--,g=t());else{switch(l){case 3:case 1:C++,g=t();break;case 5:case 12:g=t();break;case 13:S?g=t():g=" ";break;case 6:g=" ";break;case 10:if(d===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?g=" ":d!==5&&d!==17&&(s=!0);break;case 16:s=!0;break}S&&(d===12||d===13)&&(g=t())}const w=o.getTokenOffset()+p;r(g,c,w),l=d}return n}e.format=L;function R(m,E){let i="";for(let I=0;I<E;I++)i+=m;return i}function A(m,E){let i=0,I=0;const h=E.tabSize||4;for(;i<m.length;){const p=m.charAt(i);if(p===" ")I++;else if(p==="	")I+=h;else break;i++}return Math.floor(I/h)}function k(m,E){for(let i=0;i<E.length;i++){const I=E.charAt(i);if(I==="\r")return i+1<E.length&&E.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function P(m,E){return`\r
`.indexOf(m.charAt(E))!==-1}e.isEOL=P}),define(te[43],ne([0,1,33,48]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,i,I){return A(E,i,void 0,I)}e.removeProperty=R;function A(E,i,I,h,p){const u=i.slice(),f=[],b=(0,D.parseTree)(E,f);let S,C;for(;u.length>0&&(C=u.pop(),S=(0,D.findNodeAtLocation)(b,u),S===void 0&&I!==void 0);)typeof C=="string"?I={[C]:I}:I=[I];if(S)if(S.type==="object"&&typeof C=="string"&&Array.isArray(S.children)){const v=(0,D.findNodeAtLocation)(S,[C]);if(v!==void 0)if(I===void 0){if(!v.parent)throw new Error("Malformed AST");const o=S.children.indexOf(v.parent);let s,t=v.parent.offset+v.parent.length;if(o>0){const a=S.children[o-1];s=a.offset+a.length}else s=S.offset+1,S.children.length>1&&(t=S.children[1].offset);return k(E,{offset:s,length:t-s,content:""},h)}else return k(E,{offset:v.offset,length:v.length,content:JSON.stringify(I)},h);else{if(I===void 0)return[];const o=`${JSON.stringify(C)}: ${JSON.stringify(I)}`,s=p?p(S.children.map(a=>a.children[0].value)):S.children.length;let t;if(s>0){const a=S.children[s-1];t={offset:a.offset+a.length,length:0,content:","+o}}else S.children.length===0?t={offset:S.offset+1,length:0,content:o}:t={offset:S.offset+1,length:0,content:o+","};return k(E,t,h)}}else if(S.type==="array"&&typeof C=="number"&&Array.isArray(S.children))if(I!==void 0){const v=`${JSON.stringify(I)}`;let o;if(S.children.length===0||C===0)o={offset:S.offset+1,length:0,content:S.children.length===0?v:v+","};else{const s=C===-1||C>S.children.length?S.children.length:C,t=S.children[s-1];o={offset:t.offset+t.length,length:0,content:","+v}}return k(E,o,h)}else{const v=C,o=S.children[v];let s;if(S.children.length===1)s={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===v){const t=S.children[v-1],a=t.offset+t.length,n=S.offset+S.length;s={offset:a,length:n-2-a,content:""}}else s={offset:o.offset,length:S.children[v+1].offset-o.offset,content:""};return k(E,s,h)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${S.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(E,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},h)}}e.setProperty=A;function k(E,i,I){let h=P(E,i),p=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(h,p-1);)p--;for(;u<h.length&&!(0,L.isEOL)(h,u);)u++}const f=(0,L.format)(h,{offset:p,length:u-p},I);for(let S=f.length-1;S>=0;S--){const C=f[S];h=P(h,C),p=Math.min(p,C.offset),u=Math.max(u,C.offset+C.length),u+=C.content.length-C.length}const b=E.length-(h.length-u)-p;return[{offset:p,length:b,content:h.substring(p,u)}]}e.withFormatting=k;function P(E,i){return E.substring(0,i.offset)+i.content+E.substring(i.offset+i.length)}e.applyEdit=P;function m(E,i){let I=i.slice(0).sort((p,u)=>{const f=p.offset-u.offset;return f===0?p.length-u.length:f}),h=E.length;for(let p=I.length-1;p>=0;p--){let u=I[p];if(u.offset+u.length<=h)E=P(E,u);else throw new Error("Overlapping edit");h=u.offset}return E}e.applyEdits=m}),define(te[2],ne([0,1,65,55]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let A=null;function k(n){A=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==C.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==C.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function P(n){return A?.trackDisposable(n),n}function m(n){A?.markAsDisposed(n)}function E(n,r){A?.setParent(n,r)}function i(n,r){if(!!A)for(const l of n)A.setParent(l,r)}function I(n){return A?.markAsSingleton(n),n}e.markAsSingleton=I;class h extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=h;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function u(n){if(L.Iterable.is(n)){let r=[];for(const l of n)if(l)try{l.dispose()}catch(c){r.push(c)}if(r.length===1)throw r[0];if(r.length>1)throw new h(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=u;function f(...n){const r=b(()=>u(n));return i(n,r),r}e.combinedDisposable=f;function b(n){const r=P({dispose:(0,D.once)(()=>{m(r),n()})});return r}e.toDisposable=b;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return E(r,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new S,P(this),E(this._store,this)}dispose(){m(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&E(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&E(r,null),r}}e.MutableDisposable=v;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class s{constructor(){this.references=new Map}acquire(r,...l){let c=this.references.get(r);c||(c={counter:0,object:this.createReferencedObject(r,...l)},this.references.set(r,c));const{object:d}=c,g=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(r,c.object),this.references.delete(r))});return c.counter++,{object:d,dispose:g}}}e.ReferenceCollection=s;class t{constructor(r){this.referenceCollection=r}async acquire(r,...l){const c=this.referenceCollection.acquire(r,...l);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=t;class a{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=a}),define(te[91],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const k=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,k){const P=new D(A);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),function(){function Y(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function k(m){A.push(m,Date.now())}function P(){const m=[];for(let E=0;E<A.length;E+=2)m.push({name:A[E],startTime:A[E+1]});return m}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(R+k.startTime)});return A}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,A=!1,k=!1,P=!1,m=!1,E=!1,i,I=D,h,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const f=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=f&&u?.sandboxed,typeof navigator=="object"&&!f)p=navigator.userAgent,L=p.indexOf("Windows")>=0,R=p.indexOf("Macintosh")>=0,E=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=p.indexOf("Linux")>=0,m=!0,i=navigator.language,I=i;else if(typeof u=="object"){L=u.platform==="win32",R=u.platform==="darwin",A=u.platform==="linux",k=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=D,I=D;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),l=r.availableLanguages["*"];i=r.locale,I=l||D,h=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var b;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let C=0;R?C=1:L?C=3:A&&(C=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=A,e.isLinuxSnap=k,e.isNative=P,e.isWeb=m,e.isIOS=E,e.platform=C,e.userAgent=p,e.language=I;var v;(function(n){function r(){return e.language}n.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function c(){return e.language==="en"}n.isDefault=c})(v=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let g=0,w=l.length;g<w;g++){const T=l[g];if(T.id===d.data.vscodeSetImmediateId){l.splice(g,1),T.callback();return}}});let c=0;return d=>{const g=++c;l.push({id:g,callback:d}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const r=Promise.resolve();return l=>r.then(l)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:L?1:3;let s=!0,t=!1;function a(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,s=new Uint16Array(n.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a}),define(te[34],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(A){return(0,D.setImmediate)(A)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[8],ne([0,1,34]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,A=90,k=122,P=46,m=47,E=92,i=58,I=63;class h extends Error{constructor(o,s,t){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const n=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${n} ${a} of type ${s}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(v,o){if(typeof v!="string")throw new h(o,"string",v)}function u(v){return v===m||v===E}function f(v){return v===m}function b(v){return v>=L&&v<=A||v>=R&&v<=k}function S(v,o,s,t){let a="",n=0,r=-1,l=0,c=0;for(let d=0;d<=v.length;++d){if(d<v.length)c=v.charCodeAt(d);else{if(t(c))break;c=m}if(t(c)){if(!(r===d-1||l===1))if(l===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==P||a.charCodeAt(a.length-2)!==P){if(a.length>2){const g=a.lastIndexOf(s);g===-1?(a="",n=0):(a=a.slice(0,g),n=a.length-1-a.lastIndexOf(s)),r=d,l=0;continue}else if(a.length!==0){a="",n=0,r=d,l=0;continue}}o&&(a+=a.length>0?`${s}..`:"..",n=2)}else a.length>0?a+=`${s}${v.slice(r+1,d)}`:a=v.slice(r+1,d),n=d-r-1;r=d,l=0}else c===P&&l!==-1?++l:l=-1}return a}function C(v,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${v}${t}`:t}e.win32={resolve(...v){let o="",s="",t=!1;for(let a=v.length-1;a>=-1;a--){let n;if(a>=0){if(n=v[a],p(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${o}\\`));const r=n.length;let l=0,c="",d=!1;const g=n.charCodeAt(0);if(r===1)u(g)&&(l=1,d=!0);else if(u(g))if(d=!0,u(n.charCodeAt(1))){let w=2,T=w;for(;w<r&&!u(n.charCodeAt(w));)w++;if(w<r&&w!==T){const O=n.slice(T,w);for(T=w;w<r&&u(n.charCodeAt(w));)w++;if(w<r&&w!==T){for(T=w;w<r&&!u(n.charCodeAt(w));)w++;(w===r||w!==T)&&(c=`\\\\${O}\\${n.slice(T,w)}`,l=w)}}}else l=1;else b(g)&&n.charCodeAt(1)===i&&(c=n.slice(0,2),l=2,r>2&&u(n.charCodeAt(2))&&(d=!0,l=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(s=`${n.slice(l)}\\${s}`,t=d,d&&o.length>0)break}return s=S(s,!t,"\\",u),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(v){p(v,"path");const o=v.length;if(o===0)return".";let s=0,t,a=!1;const n=v.charCodeAt(0);if(o===1)return f(n)?"\\":v;if(u(n))if(a=!0,u(v.charCodeAt(1))){let l=2,c=l;for(;l<o&&!u(v.charCodeAt(l));)l++;if(l<o&&l!==c){const d=v.slice(c,l);for(c=l;l<o&&u(v.charCodeAt(l));)l++;if(l<o&&l!==c){for(c=l;l<o&&!u(v.charCodeAt(l));)l++;if(l===o)return`\\\\${d}\\${v.slice(c)}\\`;l!==c&&(t=`\\\\${d}\\${v.slice(c,l)}`,s=l)}}}else s=1;else b(n)&&v.charCodeAt(1)===i&&(t=v.slice(0,2),s=2,o>2&&u(v.charCodeAt(2))&&(a=!0,s=3));let r=s<o?S(v.slice(s),!a,"\\",u):"";return r.length===0&&!a&&(r="."),r.length>0&&u(v.charCodeAt(o-1))&&(r+="\\"),t===void 0?a?`\\${r}`:r:a?`${t}\\${r}`:`${t}${r}`},isAbsolute(v){p(v,"path");const o=v.length;if(o===0)return!1;const s=v.charCodeAt(0);return u(s)||o>2&&b(s)&&v.charCodeAt(1)===i&&u(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let o,s;for(let n=0;n<v.length;++n){const r=v[n];p(r,"path"),r.length>0&&(o===void 0?o=s=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,a=0;if(typeof s=="string"&&u(s.charCodeAt(0))){++a;const n=s.length;n>1&&u(s.charCodeAt(1))&&(++a,n>2&&(u(s.charCodeAt(2))?++a:t=!1))}if(t){for(;a<o.length&&u(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(v,o){if(p(v,"from"),p(o,"to"),v===o)return"";const s=e.win32.resolve(v),t=e.win32.resolve(o);if(s===t||(v=s.toLowerCase(),o=t.toLowerCase(),v===o))return"";let a=0;for(;a<v.length&&v.charCodeAt(a)===E;)a++;let n=v.length;for(;n-1>a&&v.charCodeAt(n-1)===E;)n--;const r=n-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===E;)l++;let c=o.length;for(;c-1>l&&o.charCodeAt(c-1)===E;)c--;const d=c-l,g=r<d?r:d;let w=-1,T=0;for(;T<g;T++){const y=v.charCodeAt(a+T);if(y!==o.charCodeAt(l+T))break;y===E&&(w=T)}if(T!==g){if(w===-1)return t}else{if(d>g){if(o.charCodeAt(l+T)===E)return t.slice(l+T+1);if(T===2)return t.slice(l+T)}r>g&&(v.charCodeAt(a+T)===E?w=T:T===2&&(w=3)),w===-1&&(w=0)}let O="";for(T=a+w+1;T<=n;++T)(T===n||v.charCodeAt(T)===E)&&(O+=O.length===0?"..":"\\..");return l+=w,O.length>0?`${O}${t.slice(l,c)}`:(t.charCodeAt(l)===E&&++l,t.slice(l,c))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const o=e.win32.resolve(v);if(o.length<=2)return v;if(o.charCodeAt(0)===E){if(o.charCodeAt(1)===E){const s=o.charCodeAt(2);if(s!==I&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===E)return`\\\\?\\${o}`;return v},dirname(v){p(v,"path");const o=v.length;if(o===0)return".";let s=-1,t=0;const a=v.charCodeAt(0);if(o===1)return u(a)?v:".";if(u(a)){if(s=t=1,u(v.charCodeAt(1))){let l=2,c=l;for(;l<o&&!u(v.charCodeAt(l));)l++;if(l<o&&l!==c){for(c=l;l<o&&u(v.charCodeAt(l));)l++;if(l<o&&l!==c){for(c=l;l<o&&!u(v.charCodeAt(l));)l++;if(l===o)return v;l!==c&&(s=t=l+1)}}}}else b(a)&&v.charCodeAt(1)===i&&(s=o>2&&u(v.charCodeAt(2))?3:2,t=s);let n=-1,r=!0;for(let l=o-1;l>=t;--l)if(u(v.charCodeAt(l))){if(!r){n=l;break}}else r=!1;if(n===-1){if(s===-1)return".";n=s}return v.slice(0,n)},basename(v,o){o!==void 0&&p(o,"ext"),p(v,"path");let s=0,t=-1,a=!0,n;if(v.length>=2&&b(v.charCodeAt(0))&&v.charCodeAt(1)===i&&(s=2),o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let r=o.length-1,l=-1;for(n=v.length-1;n>=s;--n){const c=v.charCodeAt(n);if(u(c)){if(!a){s=n+1;break}}else l===-1&&(a=!1,l=n+1),r>=0&&(c===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=v.length),v.slice(s,t)}for(n=v.length-1;n>=s;--n)if(u(v.charCodeAt(n))){if(!a){s=n+1;break}}else t===-1&&(a=!1,t=n+1);return t===-1?"":v.slice(s,t)},extname(v){p(v,"path");let o=0,s=-1,t=0,a=-1,n=!0,r=0;v.length>=2&&v.charCodeAt(1)===i&&b(v.charCodeAt(0))&&(o=t=2);for(let l=v.length-1;l>=o;--l){const c=v.charCodeAt(l);if(u(c)){if(!n){t=l+1;break}continue}a===-1&&(n=!1,a=l+1),c===P?s===-1?s=l:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||a===-1||r===0||r===1&&s===a-1&&s===t+1?"":v.slice(s,a)},format:C.bind(null,"\\"),parse(v){p(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const s=v.length;let t=0,a=v.charCodeAt(0);if(s===1)return u(a)?(o.root=o.dir=v,o):(o.base=o.name=v,o);if(u(a)){if(t=1,u(v.charCodeAt(1))){let w=2,T=w;for(;w<s&&!u(v.charCodeAt(w));)w++;if(w<s&&w!==T){for(T=w;w<s&&u(v.charCodeAt(w));)w++;if(w<s&&w!==T){for(T=w;w<s&&!u(v.charCodeAt(w));)w++;w===s?t=w:w!==T&&(t=w+1)}}}}else if(b(a)&&v.charCodeAt(1)===i){if(s<=2)return o.root=o.dir=v,o;if(t=2,u(v.charCodeAt(2))){if(s===3)return o.root=o.dir=v,o;t=3}}t>0&&(o.root=v.slice(0,t));let n=-1,r=t,l=-1,c=!0,d=v.length-1,g=0;for(;d>=t;--d){if(a=v.charCodeAt(d),u(a)){if(!c){r=d+1;break}continue}l===-1&&(c=!1,l=d+1),a===P?n===-1?n=d:g!==1&&(g=1):n!==-1&&(g=-1)}return l!==-1&&(n===-1||g===0||g===1&&n===l-1&&n===r+1?o.base=o.name=v.slice(r,l):(o.name=v.slice(r,n),o.base=v.slice(r,l),o.ext=v.slice(n,l))),r>0&&r!==t?o.dir=v.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let o="",s=!1;for(let t=v.length-1;t>=-1&&!s;t--){const a=t>=0?v[t]:D.cwd();p(a,"path"),a.length!==0&&(o=`${a}/${o}`,s=a.charCodeAt(0)===m)}return o=S(o,!s,"/",f),s?`/${o}`:o.length>0?o:"."},normalize(v){if(p(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===m,s=v.charCodeAt(v.length-1)===m;return v=S(v,!o,"/",f),v.length===0?o?"/":s?"./":".":(s&&(v+="/"),o?`/${v}`:v)},isAbsolute(v){return p(v,"path"),v.length>0&&v.charCodeAt(0)===m},join(...v){if(v.length===0)return".";let o;for(let s=0;s<v.length;++s){const t=v[s];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(v,o){if(p(v,"from"),p(o,"to"),v===o||(v=e.posix.resolve(v),o=e.posix.resolve(o),v===o))return"";const s=1,t=v.length,a=t-s,n=1,r=o.length-n,l=a<r?a:r;let c=-1,d=0;for(;d<l;d++){const w=v.charCodeAt(s+d);if(w!==o.charCodeAt(n+d))break;w===m&&(c=d)}if(d===l)if(r>l){if(o.charCodeAt(n+d)===m)return o.slice(n+d+1);if(d===0)return o.slice(n+d)}else a>l&&(v.charCodeAt(s+d)===m?c=d:d===0&&(c=0));let g="";for(d=s+c+1;d<=t;++d)(d===t||v.charCodeAt(d)===m)&&(g+=g.length===0?"..":"/..");return`${g}${o.slice(n+c)}`},toNamespacedPath(v){return v},dirname(v){if(p(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===m;let s=-1,t=!0;for(let a=v.length-1;a>=1;--a)if(v.charCodeAt(a)===m){if(!t){s=a;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":v.slice(0,s)},basename(v,o){o!==void 0&&p(o,"ext"),p(v,"path");let s=0,t=-1,a=!0,n;if(o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let r=o.length-1,l=-1;for(n=v.length-1;n>=0;--n){const c=v.charCodeAt(n);if(c===m){if(!a){s=n+1;break}}else l===-1&&(a=!1,l=n+1),r>=0&&(c===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=l))}return s===t?t=l:t===-1&&(t=v.length),v.slice(s,t)}for(n=v.length-1;n>=0;--n)if(v.charCodeAt(n)===m){if(!a){s=n+1;break}}else t===-1&&(a=!1,t=n+1);return t===-1?"":v.slice(s,t)},extname(v){p(v,"path");let o=-1,s=0,t=-1,a=!0,n=0;for(let r=v.length-1;r>=0;--r){const l=v.charCodeAt(r);if(l===m){if(!a){s=r+1;break}continue}t===-1&&(a=!1,t=r+1),l===P?o===-1?o=r:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===s+1?"":v.slice(o,t)},format:C.bind(null,"/"),parse(v){p(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const s=v.charCodeAt(0)===m;let t;s?(o.root="/",t=1):t=0;let a=-1,n=0,r=-1,l=!0,c=v.length-1,d=0;for(;c>=t;--c){const g=v.charCodeAt(c);if(g===m){if(!l){n=c+1;break}continue}r===-1&&(l=!1,r=c+1),g===P?a===-1?a=c:d!==1&&(d=1):a!==-1&&(d=-1)}if(r!==-1){const g=n===0&&s?1:n;a===-1||d===0||d===1&&a===r-1&&a===n+1?o.base=o.name=v.slice(g,r):(o.name=v.slice(g,a),o.base=v.slice(g,r),o.ext=v.slice(a,r))}return n>0?o.dir=v.slice(0,n-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:Y)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return Y[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Y,D.c=e,D.d=function(L,R,A){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:A})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var k in L)D.d(A,k,function(P){return L[P]}.bind(null,k));return A},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(Y,e,D){(function(L){var R;e=Y.exports=K,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],E=0,i=E++;m[i]="0|[1-9]\\d*";var I=E++;m[I]="[0-9]+";var h=E++;m[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;m[p]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var u=E++;m[u]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var f=E++;m[f]="(?:"+m[i]+"|"+m[h]+")";var b=E++;m[b]="(?:"+m[I]+"|"+m[h]+")";var S=E++;m[S]="(?:-("+m[f]+"(?:\\."+m[f]+")*))";var C=E++;m[C]="(?:-?("+m[b]+"(?:\\."+m[b]+")*))";var v=E++;m[v]="[0-9A-Za-z-]+";var o=E++;m[o]="(?:\\+("+m[v]+"(?:\\."+m[v]+")*))";var s=E++,t="v?"+m[p]+m[S]+"?"+m[o]+"?";m[s]="^"+t+"$";var a="[v=\\s]*"+m[u]+m[C]+"?"+m[o]+"?",n=E++;m[n]="^"+a+"$";var r=E++;m[r]="((?:<|>)?=?)";var l=E++;m[l]=m[I]+"|x|X|\\*";var c=E++;m[c]=m[i]+"|x|X|\\*";var d=E++;m[d]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[S]+")?"+m[o]+"?)?)?";var g=E++;m[g]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[C]+")?"+m[o]+"?)?)?";var w=E++;m[w]="^"+m[r]+"\\s*"+m[d]+"$";var T=E++;m[T]="^"+m[r]+"\\s*"+m[g]+"$";var O=E++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var y=E++;m[y]="(?:~>?)";var F=E++;m[F]="(\\s*)"+m[y]+"\\s+",P[F]=new RegExp(m[F],"g");var M=E++;m[M]="^"+m[y]+m[d]+"$";var q=E++;m[q]="^"+m[y]+m[g]+"$";var j=E++;m[j]="(?:\\^)";var U=E++;m[U]="(\\s*)"+m[j]+"\\s+",P[U]=new RegExp(m[U],"g");var z=E++;m[z]="^"+m[j]+m[d]+"$";var V=E++;m[V]="^"+m[j]+m[g]+"$";var x=E++;m[x]="^"+m[r]+"\\s*("+a+")$|^$";var B=E++;m[B]="^"+m[r]+"\\s*("+t+")$|^$";var N=E++;m[N]="(\\s*)"+m[r]+"\\s*("+a+"|"+m[d]+")",P[N]=new RegExp(m[N],"g");var G=E++;m[G]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var $=E++;m[$]="^\\s*("+m[g]+")\\s+-\\s+("+m[g]+")\\s*$";var J=E++;m[J]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)R(_,m[_]),P[_]||(P[_]=new RegExp(m[_]));function W(ee,re){if(ee instanceof K)return ee;if(typeof ee!="string"||ee.length>A||!(re?P[n]:P[s]).test(ee))return null;try{return new K(ee,re)}catch(ae){return null}}function K(ee,re){if(ee instanceof K){if(ee.loose===re)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(ee,re);R("SemVer",ee,re),this.loose=re;var ae=ee.trim().match(re?P[n]:P[s]);if(!ae)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var ve=+ye;if(ve>=0&&ve<k)return ve}return ye}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=W,e.valid=function(ee,re){var ae=W(ee,re);return ae?ae.version:null},e.clean=function(ee,re){var ae=W(ee.trim().replace(/^[=v]+/,""),re);return ae?ae.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ee){return R("SemVer.compare",this.version,this.loose,ee),ee instanceof K||(ee=new K(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},K.prototype.compareMain=function(ee){return ee instanceof K||(ee=new K(ee,this.loose)),Z(this.major,ee.major)||Z(this.minor,ee.minor)||Z(this.patch,ee.patch)},K.prototype.comparePre=function(ee){if(ee instanceof K||(ee=new K(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var re=0;do{var ae=this.prerelease[re],ye=ee.prerelease[re];if(R("prerelease compare",re,ae,ye),ae===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ae===void 0)return-1;if(ae!==ye)return Z(ae,ye)}while(++re)},K.prototype.inc=function(ee,re){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,re,ae,ye){typeof ae=="string"&&(ye=ae,ae=void 0);try{return new K(ee,ae).inc(re,ye).version}catch(ve){return null}},e.diff=function(ee,re){if(ge(ee,re))return null;var ae=W(ee),ye=W(re);if(ae.prerelease.length||ye.prerelease.length){for(var ve in ae)if((ve==="major"||ve==="minor"||ve==="patch")&&ae[ve]!==ye[ve])return"pre"+ve;return"prerelease"}for(var ve in ae)if((ve==="major"||ve==="minor"||ve==="patch")&&ae[ve]!==ye[ve])return ve},e.compareIdentifiers=Z;var Q=/^[0-9]+$/;function Z(ee,re){var ae=Q.test(ee),ye=Q.test(re);return ae&&ye&&(ee=+ee,re=+re),ae&&!ye?-1:ye&&!ae?1:ee<re?-1:ee>re?1:0}function se(ee,re,ae){return new K(ee,ae).compare(new K(re,ae))}function le(ee,re,ae){return se(ee,re,ae)>0}function ce(ee,re,ae){return se(ee,re,ae)<0}function ge(ee,re,ae){return se(ee,re,ae)===0}function we(ee,re,ae){return se(ee,re,ae)!==0}function Se(ee,re,ae){return se(ee,re,ae)>=0}function ke(ee,re,ae){return se(ee,re,ae)<=0}function Re(ee,re,ae,ye){var ve;switch(re){case"===":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ve=ee===ae;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ve=ee!==ae;break;case"":case"=":case"==":ve=ge(ee,ae,ye);break;case"!=":ve=we(ee,ae,ye);break;case">":ve=le(ee,ae,ye);break;case">=":ve=Se(ee,ae,ye);break;case"<":ve=ce(ee,ae,ye);break;case"<=":ve=ke(ee,ae,ye);break;default:throw new TypeError("Invalid operator: "+re)}return ve}function Pe(ee,re){if(ee instanceof Pe){if(ee.loose===re)return ee;ee=ee.value}if(!(this instanceof Pe))return new Pe(ee,re);R("comparator",ee,re),this.loose=re,this.parse(ee),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ee,re){return Z(re,ee)},e.major=function(ee,re){return new K(ee,re).major},e.minor=function(ee,re){return new K(ee,re).minor},e.patch=function(ee,re){return new K(ee,re).patch},e.compare=se,e.compareLoose=function(ee,re){return se(ee,re,!0)},e.rcompare=function(ee,re,ae){return se(re,ee,ae)},e.sort=function(ee,re){return ee.sort(function(ae,ye){return e.compare(ae,ye,re)})},e.rsort=function(ee,re){return ee.sort(function(ae,ye){return e.rcompare(ae,ye,re)})},e.gt=le,e.lt=ce,e.eq=ge,e.neq=we,e.gte=Se,e.lte=ke,e.cmp=Re,e.Comparator=Pe;var Fe={};function De(ee,re){if(ee instanceof De)return ee.loose===re?ee:new De(ee.raw,re);if(ee instanceof Pe)return new De(ee.value,re);if(!(this instanceof De))return new De(ee,re);if(this.loose=re,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ae(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function We(ee,re,ae,ye,ve,Te,Ce,Oe,Le,H,ie,oe,ue){return((re=Ae(ae)?"":Ae(ye)?">="+ae+".0.0":Ae(ve)?">="+ae+"."+ye+".0":">="+re)+" "+(Oe=Ae(Le)?"":Ae(H)?"<"+(+Le+1)+".0.0":Ae(ie)?"<"+Le+"."+(+H+1)+".0":oe?"<="+Le+"."+H+"."+ie+"-"+oe:"<="+Oe)).trim()}function Je(ee,re){for(var ae=0;ae<ee.length;ae++)if(!ee[ae].test(re))return!1;if(re.prerelease.length){for(ae=0;ae<ee.length;ae++)if(R(ee[ae].semver),ee[ae].semver!==Fe&&ee[ae].semver.prerelease.length>0){var ye=ee[ae].semver;if(ye.major===re.major&&ye.minor===re.minor&&ye.patch===re.patch)return!0}return!1}return!0}function xe(ee,re,ae){try{re=new De(re,ae)}catch(ye){return!1}return re.test(ee)}function qe(ee,re,ae,ye){var ve,Te,Ce,Oe,Le;switch(ee=new K(ee,ye),re=new De(re,ye),ae){case">":ve=le,Te=ke,Ce=ce,Oe=">",Le=">=";break;case"<":ve=ce,Te=Se,Ce=le,Oe="<",Le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(ee,re,ye))return!1;for(var H=0;H<re.set.length;++H){var ie=re.set[H],oe=null,ue=null;if(ie.forEach(function(de){de.semver===Fe&&(de=new Pe(">=0.0.0")),oe=oe||de,ue=ue||de,ve(de.semver,oe.semver,ye)?oe=de:Ce(de.semver,ue.semver,ye)&&(ue=de)}),oe.operator===Oe||oe.operator===Le||(!ue.operator||ue.operator===Oe)&&Te(ee,ue.semver)||ue.operator===Le&&Ce(ee,ue.semver))return!1}return!0}Pe.prototype.parse=function(ee){var re=this.loose?P[x]:P[B],ae=ee.match(re);if(!ae)throw new TypeError("Invalid comparator: "+ee);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new K(ae[2],this.loose):this.semver=Fe},Pe.prototype.toString=function(){return this.value},Pe.prototype.test=function(ee){return R("Comparator.test",ee,this.loose),this.semver===Fe||(typeof ee=="string"&&(ee=new K(ee,this.loose)),Re(ee,this.operator,this.semver,this.loose))},Pe.prototype.intersects=function(ee,re){if(!(ee instanceof Pe))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new De(ee.value,re),xe(this.value,ae,re);if(ee.operator==="")return ae=new De(this.value,re),xe(ee.semver,ae,re);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Te=this.semver.version===ee.semver.version,Ce=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Oe=Re(this.semver,"<",ee.semver,re)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Le=Re(this.semver,">",ee.semver,re)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||ve||Te&&Ce||Oe||Le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var re=this.loose;ee=ee.trim(),R("range",ee,re);var ae=re?P[$]:P[G];ee=ee.replace(ae,We),R("hyphen replace",ee),ee=ee.replace(P[N],"$1$2$3"),R("comparator trim",ee,P[N]),ee=(ee=(ee=ee.replace(P[F],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var ye=re?P[x]:P[B],ve=ee.split(" ").map(function(Te){return function(Ce,Oe){return R("comp",Ce),Ce=function(Le,H){return Le.trim().split(/\s+/).map(function(ie){return function(oe,ue){R("caret",oe,ue);var de=ue?P[V]:P[z];return oe.replace(de,function(Ee,me,pe,be,Ie){var he;return R("caret",oe,Ee,me,pe,be,Ie),Ae(me)?he="":Ae(pe)?he=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(be)?he=me==="0"?">="+me+"."+pe+".0 <"+me+"."+(+pe+1)+".0":">="+me+"."+pe+".0 <"+(+me+1)+".0.0":Ie?(R("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),he=me==="0"?pe==="0"?">="+me+"."+pe+"."+be+Ie+" <"+me+"."+pe+"."+(+be+1):">="+me+"."+pe+"."+be+Ie+" <"+me+"."+(+pe+1)+".0":">="+me+"."+pe+"."+be+Ie+" <"+(+me+1)+".0.0"):(R("no pr"),he=me==="0"?pe==="0"?">="+me+"."+pe+"."+be+" <"+me+"."+pe+"."+(+be+1):">="+me+"."+pe+"."+be+" <"+me+"."+(+pe+1)+".0":">="+me+"."+pe+"."+be+" <"+(+me+1)+".0.0"),R("caret return",he),he})}(ie,H)}).join(" ")}(Ce,Oe),R("caret",Ce),Ce=function(Le,H){return Le.trim().split(/\s+/).map(function(ie){return function(oe,ue){var de=ue?P[q]:P[M];return oe.replace(de,function(Ee,me,pe,be,Ie){var he;return R("tilde",oe,Ee,me,pe,be,Ie),Ae(me)?he="":Ae(pe)?he=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(be)?he=">="+me+"."+pe+".0 <"+me+"."+(+pe+1)+".0":Ie?(R("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),he=">="+me+"."+pe+"."+be+Ie+" <"+me+"."+(+pe+1)+".0"):he=">="+me+"."+pe+"."+be+" <"+me+"."+(+pe+1)+".0",R("tilde return",he),he})}(ie,H)}).join(" ")}(Ce,Oe),R("tildes",Ce),Ce=function(Le,H){return R("replaceXRanges",Le,H),Le.split(/\s+/).map(function(ie){return function(oe,ue){oe=oe.trim();var de=ue?P[T]:P[w];return oe.replace(de,function(Ee,me,pe,be,Ie,he){R("xRange",oe,Ee,me,pe,be,Ie,he);var Ue=Ae(pe),Me=Ue||Ae(be),Ne=Me||Ae(Ie);return me==="="&&Ne&&(me=""),Ue?Ee=me===">"||me==="<"?"<0.0.0":"*":me&&Ne?(Me&&(be=0),Ne&&(Ie=0),me===">"?(me=">=",Me?(pe=+pe+1,be=0,Ie=0):Ne&&(be=+be+1,Ie=0)):me==="<="&&(me="<",Me?pe=+pe+1:be=+be+1),Ee=me+pe+"."+be+"."+Ie):Me?Ee=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ne&&(Ee=">="+pe+"."+be+".0 <"+pe+"."+(+be+1)+".0"),R("xRange return",Ee),Ee})}(ie,H)}).join(" ")}(Ce,Oe),R("xrange",Ce),Ce=function(Le,H){return R("replaceStars",Le,H),Le.trim().replace(P[J],"")}(Ce,Oe),R("stars",Ce),Ce}(Te,re)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Te){return!!Te.match(ye)})),ve=ve.map(function(Te){return new Pe(Te,re)})},De.prototype.intersects=function(ee,re){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(ye){return ee.set.some(function(ve){return ve.every(function(Te){return ye.intersects(Te,re)})})})})},e.toComparators=function(ee,re){return new De(ee,re).set.map(function(ae){return ae.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new K(ee,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],ee))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(ee,re,ae){var ye=null,ve=null;try{var Te=new De(re,ae)}catch(Ce){return null}return ee.forEach(function(Ce){Te.test(Ce)&&(ye&&ve.compare(Ce)!==-1||(ve=new K(ye=Ce,ae)))}),ye},e.minSatisfying=function(ee,re,ae){var ye=null,ve=null;try{var Te=new De(re,ae)}catch(Ce){return null}return ee.forEach(function(Ce){Te.test(Ce)&&(ye&&ve.compare(Ce)!==1||(ve=new K(ye=Ce,ae)))}),ye},e.validRange=function(ee,re){try{return new De(ee,re).range||"*"}catch(ae){return null}},e.ltr=function(ee,re,ae){return qe(ee,re,"<",ae)},e.gtr=function(ee,re,ae){return qe(ee,re,">",ae)},e.outside=qe,e.prerelease=function(ee,re){var ae=W(ee,re);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(ee,re,ae){return ee=new De(ee,ae),re=new De(re,ae),ee.intersects(re)},e.coerce=function(ee){if(ee instanceof K)return ee;if(typeof ee!="string")return null;var re=ee.match(P[O]);return re==null?null:W((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,D(1))},function(Y,e){var D,L,R=Y.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(b){if(D===setTimeout)return setTimeout(b,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(b,0);try{return D(b,0)}catch(S){try{return D.call(null,b,0)}catch(C){return D.call(this,b,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch(b){D=A}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(b){L=k}})();var m,E=[],i=!1,I=-1;function h(){i&&m&&(i=!1,m.length?E=m.concat(E):I=-1,E.length&&p())}function p(){if(!i){var b=P(h);i=!0;for(var S=E.length;S;){for(m=E,E=[];++I<S;)m&&m[I].run();I=-1,S=E.length}m=null,i=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(v){try{return L.call(null,C)}catch(o){return L.call(this,C)}}}(b)}}function u(b,S){this.fun=b,this.array=S}function f(){}R.nextTick=function(b){var S=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)S[C-1]=arguments[C];E.push(new u(b,S)),E.length!==1||i||P(p)},u.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=f,R.addListener=f,R.once=f,R.off=f,R.removeListener=f,R.removeAllListeners=f,R.emit=f,R.prependListener=f,R.prependOnceListener=f,R.listeners=function(b){return[]},R.binding=function(b){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(b){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[92],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,11,65,2,91,92]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>R.Disposable.None;function o(j){return(U,z=null,V)=>{let x=!1,B;return B=j(N=>{if(!x)return B?B.dispose():x=!0,U.call(z,N)},null,V),x&&B.dispose(),B}}v.once=o;function s(j,U){return c((z,V=null,x)=>j(B=>z.call(V,U(B)),null,x))}v.map=s;function t(j,U){return c((z,V=null,x)=>j(B=>{U(B),z.call(V,B)},null,x))}v.forEach=t;function a(j,U){return c((z,V=null,x)=>j(B=>U(B)&&z.call(V,B),null,x))}v.filter=a;function n(j){return j}v.signal=n;function r(...j){return(U,z=null,V)=>(0,R.combinedDisposable)(...j.map(x=>x(B=>U.call(z,B),null,V)))}v.any=r;function l(j,U,z){let V=z;return s(j,x=>(V=U(V,x),V))}v.reduce=l;function c(j){let U;const z=new h({onFirstListenerAdd(){U=j(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}function d(j,U,z=100,V=!1,x){let B,N,G,$=0;const J=new h({leakWarningThreshold:x,onFirstListenerAdd(){B=j(_=>{$++,N=U(N,_),V&&!G&&(J.fire(N),N=void 0),clearTimeout(G),G=setTimeout(()=>{const W=N;N=void 0,G=void 0,(!V||$>1)&&J.fire(W),$=0},z)})},onLastListenerRemove(){B.dispose()}});return J.event}v.debounce=d;function g(j,U=(z,V)=>z===V){let z=!0,V;return a(j,x=>{const B=z||!U(x,V);return z=!1,V=x,B})}v.latch=g;function w(j,U){return[v.filter(j,U),v.filter(j,z=>!U(z))]}v.split=w;function T(j,U=!1,z=[]){let V=z.slice(),x=j(G=>{V?V.push(G):N.fire(G)});const B=()=>{V&&V.forEach(G=>N.fire(G)),V=null},N=new h({onFirstListenerAdd(){x||(x=j(G=>N.fire(G)))},onFirstListenerDidAdd(){V&&(U?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return N.event}v.buffer=T;class O{constructor(U){this.event=U}map(U){return new O(s(this.event,U))}forEach(U){return new O(t(this.event,U))}filter(U){return new O(a(this.event,U))}reduce(U,z){return new O(l(this.event,U,z))}latch(){return new O(g(this.event))}debounce(U,z=100,V=!1,x){return new O(d(this.event,U,z,V,x))}on(U,z,V){return this.event(U,z,V)}once(U,z,V){return o(this.event)(U,z,V)}}function y(j){return new O(j)}v.chain=y;function F(j,U,z=V=>V){const V=(...G)=>N.fire(z(...G)),x=()=>j.on(U,V),B=()=>j.removeListener(U,V),N=new h({onFirstListenerAdd:x,onLastListenerRemove:B});return N.event}v.fromNodeEventEmitter=F;function M(j,U,z=V=>V){const V=(...G)=>N.fire(z(...G)),x=()=>j.addEventListener(U,V),B=()=>j.removeEventListener(U,V),N=new h({onFirstListenerAdd:x,onLastListenerRemove:B});return N.event}v.fromDOMEventEmitter=M;function q(j){return new Promise(U=>o(j)(U))}v.toPromise=q})(P=e.Event||(e.Event={}));class m{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${m._idPool++}`}start(o){this._stopWatch=new k.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let E=-1;function i(v){const o=E;return E=v,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(o,s=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let s=E;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||o<s)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(t)||0;if(this._stacks.set(t,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let n,r=0;for(const[l,c]of this._stacks)(!n||r<c)&&(n=l,r=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class h{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(o,s,t)=>{this._listeners||(this._listeners=new A.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(s?[o,s]:o);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,s);const r=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(a){(0,D.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class p extends h{async fireAsync(o,s,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,o]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[a,n]=this._asyncDeliveryQueue.shift(),r=[],l={...n,waitUntil:c=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof a=="function"?a:a[0])),r.push(c)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(r),await Promise.allSettled(r).then(c=>{for(const d of c)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=p;class u extends h{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class f extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=f;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const s={event:o,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const t=()=>{this.hasListeners&&this.unhook(s);const a=this.events.indexOf(s);this.events.splice(a,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(s=>this.emitter.fire(s))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class S{constructor(){this.buffers=[]}wrapEvent(o){return(s,t,a)=>o(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>s.call(t,n)):s.call(t,n)},void 0,a)}bufferEvents(o){const s=[];this.buffers.push(s);const t=o();return this.buffers.pop(),s.forEach(a=>a()),t}}e.EventBufferer=S;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(te[29],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,m){const E=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function m(E){return E===P.None||E===P.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(te[49],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const h=this._icons.get(I.id);h?I.description?h.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function A(i,I){return new P(i,I)}e.registerCodicon=A;function k(i){return i?i.replace(/\$\((.*?)\)/g,(I,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(I,h,p){this.id=I,this.definition=h,this.description=p,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,I){const h=["codicon","codicon-"+i];return I&&h.push("codicon-modifier-"+I),h}e.getClassNamesArray=m;var E;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(f){if(f instanceof P)return["codicon","codicon-"+f.id];const b=I.exec(f.id);if(!b)return h(P.error);let[,S,C]=b;const v=["codicon","codicon-"+S];return C&&v.push("codicon-modifier-"+C.substr(1)),v}i.asClassNameArray=h;function p(f){return h(f).join(" ")}i.asClassName=p;function u(f){return"."+h(f).join(".")}i.asCSSSelector=u})(E=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,11,2]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function A(v){const o=v;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=A;function k(v,o){return new P(v,o)}e.newWriteableStream=k;class P{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const a=t.indexOf(s);a>=0&&t.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(v,o){const s=[];let t;for(;(t=v.read())!==null;)s.push(t);return o(s)}e.consumeReadable=m;function E(v,o,s){const t=[];let a;for(;(a=v.read())!==null&&t.length<s;)t.push(a);return a===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return v.read()}}}e.peekReadable=E;function i(v,o){return new Promise((s,t)=>{const a=[];I(v,{onData:n=>{o&&a.push(n)},onError:n=>{o?t(n):s(void 0)},onEnd:()=>{s(o?o(a):void 0)}})})}e.consumeStream=i;function I(v,o){v.on("error",s=>o.onError(s)),v.on("end",()=>o.onEnd()),v.on("data",s=>o.onData(s))}e.listenStream=I;function h(v,o){return new Promise((s,t)=>{const a=new L.DisposableStore,n=[],r=d=>{if(n.push(d),n.length>o)return a.dispose(),v.pause(),s({stream:v,buffer:n,ended:!1})},l=d=>t(d),c=()=>s({stream:v,buffer:n,ended:!0});a.add((0,L.toDisposable)(()=>v.removeListener("error",l))),v.on("error",l),a.add((0,L.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),a.add((0,L.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=h;function p(v,o){const s=k(o);return s.end(v),s}e.toStream=p;function u(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=u;function f(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}e.toReadable=f;function b(v,o,s){const t=k(s);return I(v,{onData:a=>t.write(o.data(a)),onError:a=>t.error(o.error?o.error(a):a),onEnd:()=>t.end()}),t}e.transform=b;function S(v,o,s){let t=!1;return{read:()=>{const a=o.read();return t?a:(t=!0,a!==null?s([v,a]):v)}}}e.prefixedReadable=S;function C(v,o,s){let t=!1;const a=k(s);return I(o,{onData:n=>t?a.write(n):(t=!0,a.write(s([v,n]))),onError:n=>a.error(n),onEnd:()=>{t||(t=!0,a.write(v)),a.end()}}),a}e.prefixedStream=C}),define(te[25],ne([0,1,50]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,A;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(r)):(R||(R=new TextEncoder),new k(R.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let g=0,w=r.length;g<w;g++)l+=r[g].byteLength}const c=k.alloc(l);let d=0;for(let g=0,w=r.length;g<w;g++){const T=r[g];c.set(T,d),d+=T.byteLength}return c}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,l){return new k(this.buffer.subarray(r,l))}set(r,l){r instanceof k?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return E(this.buffer,r)}writeUInt32BE(r,l){i(this.buffer,r,l)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,l){h(this.buffer,r,l)}readUInt8(r){return p(this.buffer,r)}writeUInt8(r,l){u(this.buffer,r,l)}}e.VSBuffer=k;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=P;function m(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255}e.writeUInt16LE=m;function E(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=E;function i(n,r,l){n[l+3]=r,r=r>>>8,n[l+2]=r,r=r>>>8,n[l+1]=r,r=r>>>8,n[l]=r}e.writeUInt32BE=i;function I(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=I;function h(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255,r=r>>>8,n[l+2]=r&255,r=r>>>8,n[l+3]=r&255}e.writeUInt32LE=h;function p(n,r){return n[r]}e.readUInt8=p;function u(n,r,l){n[l]=r}e.writeUInt8=u;function f(n){return D.consumeReadable(n,r=>k.concat(r))}e.readableToBuffer=f;function b(n){return D.toReadable(n)}e.bufferToReadable=b;function S(n){return D.consumeStream(n,r=>k.concat(r))}e.streamToBuffer=S;async function C(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await S(n.stream)])}e.bufferedStreamToBuffer=C;function v(n){return D.toStream(n,r=>k.concat(r))}e.bufferToStream=v;function o(n){return D.transform(n,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=o;function s(n){return D.newWriteableStream(r=>k.concat(r),n)}e.newWriteableBufferStream=s;function t(n,r){return D.prefixedReadable(n,r,l=>k.concat(l))}e.prefixedBufferReadable=t;function a(n,r){return D.prefixedStream(n,r,l=>k.concat(l))}e.prefixedBufferStream=a}),define(te[24],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(H,...ie){return ie.length===0?H:H.replace(L,function(oe,ue){const de=parseInt(ue,10);return isNaN(de)||de<0||de>=ie.length?oe:ie[de]})}e.format=R;const A=/{([^}]+)}/g;function k(H,ie){return H.replace(A,(oe,ue)=>ie[ue]??oe)}e.format2=k;function P(H){return H.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function m(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function E(H,ie){let oe=0;const ue=ie.charCodeAt(0);for(let de=H.length-1;de>=0;de--)H.charCodeAt(de)===ue&&oe++;return oe}e.count=E;function i(H,ie,oe="\u2026"){return H.length<=ie?H:`${H.substr(0,ie)}${oe}`}e.truncate=i;function I(H,ie=" "){const oe=h(H,ie);return p(oe,ie)}e.trim=I;function h(H,ie){if(!H||!ie)return H;const oe=ie.length;if(oe===0||H.length===0)return H;let ue=0;for(;H.indexOf(ie,ue)===ue;)ue=ue+oe;return H.substring(ue)}e.ltrim=h;function p(H,ie){if(!H||!ie)return H;const oe=ie.length,ue=H.length;if(oe===0||ue===0)return H;let de=ue,Ee=-1;for(;Ee=H.lastIndexOf(ie,de-1),!(Ee===-1||Ee+oe!==de);){if(Ee===0)return"";de=Ee}return H.substring(0,de)}e.rtrim=p;function u(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function b(H,ie,oe={}){if(!H)throw new Error("Cannot create regex from empty string");ie||(H=m(H)),oe.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let ue="";return oe.global&&(ue+="g"),oe.matchCase||(ue+="i"),oe.multiline&&(ue+="m"),oe.unicode&&(ue+="u"),new RegExp(H,ue)}e.createRegExp=b;function S(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function C(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function v(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=v;function o(H){return H.split(/\r\n|\r|\n/)}e.splitLines=o;function s(H){for(let ie=0,oe=H.length;ie<oe;ie++){const ue=H.charCodeAt(ie);if(ue!==32&&ue!==9)return ie}return-1}e.firstNonWhitespaceIndex=s;function t(H,ie=0,oe=H.length){for(let ue=ie;ue<oe;ue++){const de=H.charCodeAt(ue);if(de!==32&&de!==9)return H.substring(ie,ue)}return H.substring(ie,oe)}e.getLeadingWhitespace=t;function a(H,ie=H.length-1){for(let oe=ie;oe>=0;oe--){const ue=H.charCodeAt(oe);if(ue!==32&&ue!==9)return oe}return-1}e.lastNonWhitespaceIndex=a;function n(H,ie){return H<ie?-1:H>ie?1:0}e.compare=n;function r(H,ie,oe=0,ue=H.length,de=0,Ee=ie.length){for(;oe<ue&&de<Ee;oe++,de++){let be=H.charCodeAt(oe),Ie=ie.charCodeAt(de);if(be<Ie)return-1;if(be>Ie)return 1}const me=ue-oe,pe=Ee-de;return me<pe?-1:me>pe?1:0}e.compareSubstring=r;function l(H,ie){return c(H,ie,0,H.length,0,ie.length)}e.compareIgnoreCase=l;function c(H,ie,oe=0,ue=H.length,de=0,Ee=ie.length){for(;oe<ue&&de<Ee;oe++,de++){let be=H.charCodeAt(oe),Ie=ie.charCodeAt(de);if(be===Ie)continue;const he=be-Ie;if(!(he===32&&g(Ie))&&!(he===-32&&g(be)))return d(be)&&d(Ie)?he:r(H.toLowerCase(),ie.toLowerCase(),oe,ue,de,Ee)}const me=ue-oe,pe=Ee-de;return me<pe?-1:me>pe?1:0}e.compareSubstringIgnoreCase=c;function d(H){return H>=97&&H<=122}e.isLowerAsciiLetter=d;function g(H){return H>=65&&H<=90}e.isUpperAsciiLetter=g;function w(H){return d(H)||g(H)}function T(H,ie){return H.length===ie.length&&O(H,ie)}e.equalsIgnoreCase=T;function O(H,ie,oe=H.length){for(let ue=0;ue<oe;ue++){const de=H.charCodeAt(ue),Ee=ie.charCodeAt(ue);if(de!==Ee){if(w(de)&&w(Ee)){const me=Math.abs(de-Ee);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(Ee).toLowerCase())return!1}}return!0}function y(H,ie){const oe=ie.length;return ie.length>H.length?!1:O(H,ie,oe)}e.startsWithIgnoreCase=y;function F(H,ie){let oe,ue=Math.min(H.length,ie.length);for(oe=0;oe<ue;oe++)if(H.charCodeAt(oe)!==ie.charCodeAt(oe))return oe;return ue}e.commonPrefixLength=F;function M(H,ie){let oe,ue=Math.min(H.length,ie.length);const de=H.length-1,Ee=ie.length-1;for(oe=0;oe<ue;oe++)if(H.charCodeAt(de-oe)!==ie.charCodeAt(Ee-oe))return oe;return ue}e.commonSuffixLength=M;function q(H){return 55296<=H&&H<=56319}e.isHighSurrogate=q;function j(H){return 56320<=H&&H<=57343}e.isLowSurrogate=j;function U(H,ie){return(H-55296<<10)+(ie-56320)+65536}e.computeCodePoint=U;function z(H,ie,oe){const ue=H.charCodeAt(oe);if(q(ue)&&oe+1<ie){const de=H.charCodeAt(oe+1);if(j(de))return U(ue,de)}return ue}e.getNextCodePoint=z;function V(H,ie){const oe=H.charCodeAt(ie-1);if(j(oe)&&ie>1){const ue=H.charCodeAt(ie-2);if(q(ue))return U(ue,oe)}return oe}function x(H,ie){const oe=ae.getInstance(),ue=ie,de=H.length,Ee=z(H,de,ie);ie+=Ee>=65536?2:1;let me=oe.getGraphemeBreakType(Ee);for(;ie<de;){const pe=z(H,de,ie),be=oe.getGraphemeBreakType(pe);if(ee(me,be))break;ie+=pe>=65536?2:1,me=be}return ie-ue}e.nextCharLength=x;function B(H,ie){const oe=ae.getInstance(),ue=ie,de=V(H,ie);ie-=de>=65536?2:1;let Ee=oe.getGraphemeBreakType(de);for(;ie>0;){const me=V(H,ie),pe=oe.getGraphemeBreakType(me);if(ee(pe,Ee))break;ie-=me>=65536?2:1,Ee=pe}return ue-ie}e.prevCharLength=B;function N(H,ie){const oe=ae.getInstance(),ue=H.length,de=ie,Ee=z(H,ue,ie),me=oe.getGraphemeBreakType(Ee);ie+=Ee>=65536?2:1;let pe=me;for(;ie<ue;){const Ie=z(H,ue,ie),he=oe.getGraphemeBreakType(Ie);if(ee(pe,he))break;ie+=Ie>=65536?2:1,pe=he}const be=ie;for(ie=de,pe=me;ie>0;){const Ie=V(H,ie),he=oe.getGraphemeBreakType(Ie);if(ee(he,pe))break;ie-=Ie>=65536?2:1,pe=he}return[ie,be]}function G(H,ie){return ie>0&&j(H.charCodeAt(ie))?N(H,ie-1):N(H,ie)}e.getCharContainingOffset=G;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(H){return $.test(H)}e.containsRTL=J;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function W(H){return _.test(H)}e.containsEmoji=W;const K=/^[\t\n\r\x20-\x7E]*$/;function Q(H){return K.test(H)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Z;function se(H){for(let ie=0,oe=H.length;ie<oe;ie++)if(le(H.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=se;function le(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=le;function ce(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ce;function ge(H,ie){if(H.length<ie)return H;const oe=/\b/g;let ue=0;for(;oe.test(H)&&!(H.length-oe.lastIndex<ie);)ue=oe.lastIndex,oe.lastIndex+=1;return H.substring(ue).replace(/^\s/,"")}e.lcut=ge;const we=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function Re(H){return H&&(H=H.replace(we,""),H=H.replace(Se,""),H=H.replace(ke,"")),H}e.removeAnsiEscapeCodes=Re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Fe(H){return Pe(H)?H.substr(1):H}e.stripUTF8BOM=Fe;function De(H,ie){if(!H||!ie||H.length<ie.length)return!1;const oe=ie.length,ue=H.toLowerCase();let de=0,Ee=-1;for(;de<oe;){const me=ue.indexOf(ie[de],Ee+1);if(me<0)return!1;Ee=me,de++}return!0}e.fuzzyContains=De;function Ae(H,ie=!1){return H?(ie&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=Ae;function We(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=We;function Je(H,ie=1){if(ie===0)return"";let oe=-1;do oe=H.indexOf(`
`,oe+1),ie--;while(ie>0&&oe>=0);return oe===-1?H:(H[oe-1]==="\r"&&oe--,H.substr(0,oe))}e.getNLines=Je;function xe(H){const ie=90-65+1;return H=H%(2*ie),H<ie?String.fromCharCode(97+H):String.fromCharCode(65+H-ie)}e.singleLetterHash=xe;function qe(H){return ae.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=qe;function ee(H,ie){return H===0?ie!==5&&ie!==7:H===2&&ie===3?!1:H===4||H===2||H===3||ie===4||ie===2||ie===3?!0:!(H===8&&(ie===8||ie===9||ie===11||ie===12)||(H===11||H===9)&&(ie===9||ie===10)||(H===12||H===10)&&ie===10||ie===5||ie===13||ie===7||H===1||H===13&&ie===14||H===6&&ie===6)}e.breakBetweenGraphemeBreakType=ee;var re;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ye()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const oe=this._data,ue=oe.length/3;let de=1;for(;de<=ue;)if(ie<oe[3*de])de=2*de;else if(ie>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}ae._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ve(H,ie){if(H===0)return 0;const oe=Te(H,ie);if(oe!==void 0)return oe;const ue=V(ie,H);return H-=Ce(ue),H}e.getLeftDeleteOffset=ve;function Te(H,ie){let oe=V(ie,H);for(H-=Ce(oe);Oe(oe)||oe===65039||oe===8419;){if(H===0)return;oe=V(ie,H),H-=Ce(oe)}if(!!ce(oe)){if(H>=0){const ue=V(ie,H);ue===8205&&(H-=Ce(ue))}return H}}function Ce(H){return H>=65536?2:1}function Oe(H){return 127995<=H&&H<=127999}var Le;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),define(te[16],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(g){return Array.isArray(g)}e.isArray=D;function L(g){return typeof g=="string"}e.isString=L;function R(g){return Array.isArray(g)&&g.every(w=>L(w))}e.isStringArray=R;function A(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=A;function k(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=k;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function m(g){return g===!0||g===!1}e.isBoolean=m;function E(g){return typeof g=="undefined"}e.isUndefined=E;function i(g){return!I(g)}e.isDefined=i;function I(g){return E(g)||g===null}e.isUndefinedOrNull=I;function h(g,w){if(!g)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=h;function p(g){if(I(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function u(...g){const w=[];for(let T=0;T<g.length;T++){const O=g[T];if(I(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);w.push(O)}return w}e.assertAllDefined=u;const f=Object.prototype.hasOwnProperty;function b(g){if(!A(g))return!1;for(let w in g)if(f.call(g,w))return!1;return!0}e.isEmptyObject=b;function S(g){return typeof g=="function"}e.isFunction=S;function C(...g){return g.length>0&&g.every(S)}e.areFunctions=C;function v(g,w){const T=Math.min(g.length,w.length);for(let O=0;O<T;O++)o(g[O],w[O])}e.validateConstraints=v;function o(g,w){if(L(w)){if(typeof g!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(S(w)){try{if(g instanceof w)return}catch{}if(!I(g)&&g.constructor===w||w.length===1&&w.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function s(g){let w=[],T=Object.getPrototypeOf(g);for(;Object.prototype!==T;)w=w.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return w}e.getAllPropertyNames=s;function t(g){const w=[];for(const T of s(g))typeof g[T]=="function"&&w.push(T);return w}e.getAllMethodNames=t;function a(g,w){const T=y=>function(){const F=Array.prototype.slice.call(arguments,0);return w(y,F)};let O={};for(const y of g)O[y]=T(y);return O}e.createProxyObject=a;function n(g){return g===null?void 0:g}e.withNullAsUndefined=n;function r(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=r;function l(g){return class{constructor(){return new Proxy({},{get(w,T){if(w[T])return w[T];throw new Error(`Not Implemented: ${g}->${String(T)}`)}})}}}e.NotImplementedProxy=l;function c(g,w="Unreachable"){throw new Error(w)}e.assertNever=c;function d(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=d}),define(te[39],ne([0,1,8,4,24,16]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function E(n,r=D.posix.sep){if(!n)return"";const l=n.length,c=n.charCodeAt(0);if(k(c)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let g=3;const w=g;for(;g<l&&!k(n.charCodeAt(g));g++);if(w!==g&&!k(n.charCodeAt(g+1))){for(g+=1;g<l;g++)if(k(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,r)}}return r}else if(S(c)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let d=n.indexOf("://");if(d!==-1){for(d+=3;d<l;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1)}return""}e.getRoot=E;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let l=2;const c=l;for(;l<n.length&&(r=n.charCodeAt(l),r!==92);l++);return!(c===l||(r=n.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,r=L.isWindows){const l=r?I:h;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||r&&p.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function f(n,r,l){const c=n===r;return!l||c?c:!n||!r?!1:(0,R.equalsIgnoreCase)(n,r)}e.isEqual=f;function b(n,r,l,c=D.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let g=r.length;return r.charAt(r.length-1)===c&&g--,n.charAt(g)===c}return r.charAt(r.length-1)!==c&&(r+=c),n.indexOf(r)===0}e.isEqualOrParent=b;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function C(n,r){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(r,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=C;function v(n){const r=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(r)&&(n.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=v;function o(n){return L.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function s(n){return o(n)?n[0]:void 0}e.getDriveLetter=s;function t(n,r,l){return r.length>n.length?-1:n===r?0:(l&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function a(n){const r=n.split(":");let l,c,d;if(r.forEach(g=>{const w=Number(g);(0,A.isNumber)(w)?c===void 0?c=w:d===void 0&&(d=w):l=l?[l,g].join(":"):g}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:c!==void 0?c:void 0,column:d!==void 0?d:c!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(te[26],ne([0,1,16]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.keys(f).forEach(S=>{f[S]&&typeof f[S]=="object"?b[S]=L(f[S]):b[S]=f[S]}),b}e.deepClone=L;function R(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const S=b.shift();Object.freeze(S);for(const C in S)if(A.call(S,C)){const v=S[C];typeof v=="object"&&!Object.isFrozen(v)&&b.push(v)}}return f}e.deepFreeze=R;const A=Object.prototype.hasOwnProperty;function k(f,b){return P(f,b,new Set)}e.cloneAndChange=k;function P(f,b,S){if((0,D.isUndefinedOrNull)(f))return f;const C=b(f);if(typeof C!="undefined")return C;if((0,D.isArray)(f)){const v=[];for(const o of f)v.push(P(o,b,S));return v}if((0,D.isObject)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const v={};for(let o in f)A.call(f,o)&&(v[o]=P(f[o],b,S));return S.delete(f),v}return f}function m(f,b,S=!0){return(0,D.isObject)(f)?((0,D.isObject)(b)&&Object.keys(b).forEach(C=>{C in f?S&&((0,D.isObject)(f[C])&&(0,D.isObject)(b[C])?m(f[C],b[C],S):f[C]=b[C]):f[C]=b[C]}),f):b}e.mixin=m;function E(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let S,C;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(S=0;S<f.length;S++)if(!E(f[S],b[S]))return!1}else{const v=[];for(C in f)v.push(C);v.sort();const o=[];for(C in b)o.push(C);if(o.sort(),!E(v,o))return!1;for(S=0;S<v.length;S++)if(!E(f[v[S]],b[v[S]]))return!1}return!0}e.equals=E;function i(f){const b=new Set;return JSON.stringify(f,(S,C)=>{if((0,D.isObject)(C)||Array.isArray(C)){if(b.has(C))return"[Circular]";b.add(C)}return C})}e.safeStringify=i;function I(f,b,S){const C=b(f);return typeof C=="undefined"?S:C}e.getOrDefault=I;function h(f,b){const S=Object.create(null);return!f||!b||Object.keys(b).forEach(v=>{const o=f[v],s=b[v];E(o,s)||(S[v]=s)}),S}e.distinct=h;function p(f,b){const S=b.toLowerCase(),C=Object.keys(f).find(v=>v.toLowerCase()===S);return C?f[C]:f[b]}e.getCaseInsensitive=p;function u(f,b){const S=Object.create(null);for(const C of Object.keys(f))b(C,f[C])&&(S[C]=f[C]);return S}e.filter=u}),define(te[5],ne([0,1,8,4]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function P(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,r){return!n&&!r?"file":n}function E(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,l,c,d,g,w=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=m(r,w),this.authority=l||i,this.path=E(this.scheme,c||i),this.query=d||i,this.fragment=g||i,P(this,w))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return v(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:c,path:d,query:g,fragment:w}=r;return l===void 0?l=this.scheme:l===null&&(l=i),c===void 0?c=this.authority:c===null&&(c=i),d===void 0?d=this.path:d===null&&(d=i),g===void 0?g=this.query:g===null&&(g=i),w===void 0?w=this.fragment:w===null&&(w=i),l===this.scheme&&c===this.authority&&d===this.path&&g===this.query&&w===this.fragment?this:new f(l,c,d,g,w)}static parse(r,l=!1){const c=h.exec(r);return c?new f(c[2]||i,a(c[4]||i),a(c[5]||i),a(c[7]||i),a(c[9]||i),l):new f(i,i,i,i,i)}static file(r){let l=i;if(L.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const c=r.indexOf(I,2);c===-1?(l=r.substring(2),r=I):(l=r.substring(2,c),r=r.substring(c)||I)}return new f("file",l,r,i,i)}static from(r){const l=new f(r.scheme,r.authority,r.path,r.query,r.fragment);return P(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&r.scheme==="file"?c=p.file(D.win32.join(v(r,!0),...l)).path:c=D.posix.join(r.path,...l),r.with({path:c})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const l=new f(r);return l._formatted=r.external,l._fsPath=r._sep===u?r.fsPath:null,l}}else return r}}e.URI=p;const u=L.isWindows?1:void 0;class f extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=u),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(n,r){let l,c=-1;for(let d=0;d<n.length;d++){const g=n.charCodeAt(d);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||r&&g===47)c!==-1&&(l+=encodeURIComponent(n.substring(c,d)),c=-1),l!==void 0&&(l+=n.charAt(d));else{l===void 0&&(l=n.substr(0,d));const w=b[g];w!==void 0?(c!==-1&&(l+=encodeURIComponent(n.substring(c,d)),c=-1),l+=w):c===-1&&(c=d)}}return c!==-1&&(l+=encodeURIComponent(n.substring(c))),l!==void 0?l:n}function C(n){let r;for(let l=0;l<n.length;l++){const c=n.charCodeAt(l);c===35||c===63?(r===void 0&&(r=n.substr(0,l)),r+=b[c]):r!==void 0&&(r+=n[l])}return r!==void 0?r:n}function v(n,r){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=v;function o(n,r){const l=r?C:S;let c="",{scheme:d,authority:g,path:w,query:T,fragment:O}=n;if(d&&(c+=d,c+=":"),(g||d==="file")&&(c+=I,c+=I),g){let y=g.indexOf("@");if(y!==-1){const F=g.substr(0,y);g=g.substr(y+1),y=F.indexOf(":"),y===-1?c+=l(F,!1):(c+=l(F.substr(0,y),!1),c+=":",c+=l(F.substr(y+1),!1)),c+="@"}g=g.toLowerCase(),y=g.indexOf(":"),y===-1?c+=l(g,!1):(c+=l(g.substr(0,y),!1),c+=g.substr(y))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const y=w.charCodeAt(1);y>=65&&y<=90&&(w=`/${String.fromCharCode(y+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const y=w.charCodeAt(0);y>=65&&y<=90&&(w=`${String.fromCharCode(y+32)}:${w.substr(2)}`)}c+=l(w,!0)}return T&&(c+="?",c+=l(T,!1)),O&&(c+="#",c+=r?O:S(O,!1)),c}function s(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+s(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(t)?n.replace(t,r=>s(r)):n}}),define(te[93],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const i=E;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(E){const i=[];let I;try{const h=JSON.parse(E.arguments),p=h[h.length-1];p&&p.__$stack&&(h.pop(),I=p.__$stack),i.push(...h)}catch(h){i.push("Unable to log remote console arguments",E.arguments)}return{args:i,stack:I}}e.parse=R;function A(E){if(typeof E!="string")return A(R(E).stack);const i=E;if(i){const I=k(i),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=A;function k(E){if(!E)return E;const i=E.indexOf(`
`);return i===-1?E:E.substring(0,i)}function P(E,i){const{args:I,stack:h}=R(E),p=typeof I[0]=="string"&&I.length===1;let u=k(h);u&&(u=`(${u.trim()})`);let f=[];if(typeof I[0]=="string"?u&&p?f=[`%c[${i}] %c${I[0]} %c${u}`,m("blue"),m(""),m("grey")]:f=[`%c[${i}] %c${I[0]}`,m("blue"),m(""),...I.slice(1)]:f=[`%c[${i}]%`,m("blue"),...I],u&&!p&&f.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,f)}e.log=P;function m(E){return`color: ${E}`}});var ht=this&&this.__classPrivateFieldSet||function(Y,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(Y,D):R?R.value=D:e.set(Y,D),D},ze=this&&this.__classPrivateFieldGet||function(Y,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(Y):L?L.value:e.get(Y)};define(te[40],ne([0,1,18,24,5]),function(Y,e,D,L,R){"use strict";var A,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function m(a,n,r){let l=a.get(n);return l===void 0&&(l=r,a.set(n,l)),l}e.getOrSet=m;function E(a){const n=[];return a.forEach((r,l)=>{n.push(`${l} => ${r}`)}),`Map(${a.size}) {${n.join(", ")}}`}e.mapToString=E;function i(a){const n=[];return a.forEach(r=>{n.push(r)}),`Set(${a.size}) {${n.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return r-l}value(){return this._value[this._pos]}}e.StringIterator=I;class h{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=h;class p{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var u;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(u||(u={}));class f{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class b{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new f(n))}static forPaths(){return new S(new p)}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new h)}clear(){this._root=void 0}set(n,r){const l=this._iter.reset(n);let c;for(this._root||(this._root=new b,this._root.segment=l.value()),c=this._root;;){const g=l.cmp(c.segment);if(g>0)c.left||(c.left=new b,c.left.segment=l.value()),c=c.left;else if(g<0)c.right||(c.right=new b,c.right.segment=l.value()),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new b,c.mid.segment=l.value()),c=c.mid;else break}const d=c.value;return c.value=r,c.key=n,d}fill(n,r){const l=r.slice(0);(0,D.shuffle)(l);for(let c of l)this.set(c,n)}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let l=this._root;for(;l;){const c=r.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else break}return l}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const l=this._iter.reset(n),c=[];let d=this._root;for(;d;){const g=l.cmp(d.segment);if(g>0)c.push([1,d]),d=d.left;else if(g<0)c.push([-1,d]),d=d.right;else if(l.hasNext())l.next(),c.push([0,d]),d=d.mid;else{for(r?(d.left=void 0,d.mid=void 0,d.right=void 0):d.value=void 0;c.length>0&&d.isEmpty();){let[w,T]=c.pop();switch(w){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}d=T}break}}}findSubstr(n){const r=this._iter.reset(n);let l=this._root,c;for(;l;){const d=r.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(r.hasNext())r.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(n){const r=this._iter.reset(n);let l=this._root;for(;l;){const c=r.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[r,l]of this)n(l,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const r=[n];for(;r.length>0;){const l=r.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&r.push(l.left),l.mid&&r.push(l.mid),l.right&&r.push(l.right))}}}e.TernarySearchTree=S;class C{constructor(n,r){this[A]="ResourceMap",n instanceof C?(this.map=new Map(n.map),this.toKey=r??C.defaultToKey):(this.map=new Map,this.toKey=n??C.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[l,c]of this.map)n(c,R.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=C,C.defaultToKey=a=>a.toString();var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const l=this._map.get(n);if(!!l)return r!==0&&this.touch(l,r),l.value}set(n,r,l=0){let c=this._map.get(n);if(c)c.value=r,l!==0&&this.touch(c,l);else{switch(c={key:n,value:r,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const l=this._state;let c=this._head;for(;c;){if(r?n.bind(r)(c.value,c.key,this):n(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,r=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.key,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return c}values(){const n=this,r=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.value,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return c}entries(){const n=this,r=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:[l.key,l.value],done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return c}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,l=this.size;for(;r&&l>n;)this._map.delete(r.key),r=r.next,l--;this._head=r,this._size=l,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,l=n.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const l=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const l=n.next,c=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,l)=>{n.push([l,r])}),n}fromJSON(n){this.clear();for(const[r,l]of n)this.set(r,l)}}e.LinkedMap=o;class s extends o{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class t{constructor(n){P.set(this,void 0),ht(this,P,n,"f")}get size(){return ze(this,P,"f").size}forEach(n,r){ze(this,P,"f").forEach(n,r)}get(n){return ze(this,P,"f").get(n)}has(n){return ze(this,P,"f").has(n)}entries(){return ze(this,P,"f").entries()}keys(){return ze(this,P,"f").keys()}values(){return ze(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return ze(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(te[94],ne([0,1,25,24,5]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(i){return JSON.stringify(i,m)}e.stringify=A;function k(i){let I=JSON.parse(i);return I=E(I),I}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function E(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let h=0;h<i.length;++h)i[h]=E(i[h],I+1);else for(const h in i)Object.hasOwnProperty.call(i,h)&&(i[h]=E(i[h],I+1))}return i}e.revive=E}),define(te[17],ne([0,1,4,5]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,E,i){this._hosts[m]=E,this._ports[m]=i}setConnectionToken(m,E){this._connectionTokens[m]=E}rewrite(m){if(this._delegate)return this._delegate(m);const E=m.authority;let i=this._hosts[E];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[E],h=this._connectionTokens[E];let p=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(p+=`&tkn=${encodeURIComponent(h)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new A;class k{asBrowserUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,E){const i=this.toUri(m,E);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,E){return L.URI.isUri(m)?m:L.URI.parse(E.toUrl(m))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[66],ne([0,1,40]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(E){return m(E,"NFC",L)}e.normalizeNFC=R;const A=new D.LRUCache(1e4);function k(E){return m(E,"NFD",A)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function m(E,i,I){if(!E)return E;const h=I.get(E);if(h)return h;let p;return P.test(E)?p=E.normalize(i):p=E,I.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(i){return k(i).replace(E,"")}}()}),define(te[15],ne([0,1,39,17,8,4,24,5]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=m;class E{constructor(u){this._ignorePathCasing=u}compare(u,f,b=!1){return u===f?0:(0,k.compare)(this.getComparisonKey(u,b),this.getComparisonKey(f,b))}isEqual(u,f,b=!1){return u===f?!0:!u||!f?!1:this.getComparisonKey(u,b)===this.getComparisonKey(f,b)}getComparisonKey(u,f=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,f,b=!1){if(u.scheme===f.scheme){if(u.scheme===L.Schemas.file)return D.isEqualOrParent(m(u),m(f),this._ignorePathCasing(u))&&u.query===f.query&&(b||u.fragment===f.fragment);if((0,e.isEqualAuthority)(u.authority,f.authority))return D.isEqualOrParent(u.path,f.path,this._ignorePathCasing(u),"/")&&u.query===f.query&&(b||u.fragment===f.fragment)}return!1}joinPath(u,...f){return P.URI.joinPath(u,...f)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let f;return u.scheme===L.Schemas.file?f=P.URI.file(R.dirname(m(u))).path:(f=R.posix.dirname(u.path),u.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),f="/")),u.with({path:f})}normalizePath(u){if(!u.path.length)return u;let f;return u.scheme===L.Schemas.file?f=P.URI.file(R.normalize(m(u))).path:f=R.posix.normalize(u.path),u.with({path:f})}relativePath(u,f){if(u.scheme!==f.scheme||!(0,e.isEqualAuthority)(u.authority,f.authority))return;if(u.scheme===L.Schemas.file){const C=R.relative(m(u),m(f));return A.isWindows?D.toSlashes(C):C}let b=u.path||"/",S=f.path||"/";if(this._ignorePathCasing(u)){let C=0;for(const v=Math.min(b.length,S.length);C<v&&!(b.charCodeAt(C)!==S.charCodeAt(C)&&b.charAt(C).toLowerCase()!==S.charAt(C).toLowerCase());C++);b=S.substr(0,C)+b.substr(C)}return R.posix.relative(b,S)}resolvePath(u,f){if(u.scheme===L.Schemas.file){const b=P.URI.file(R.resolve(m(u),f));return u.with({authority:b.authority,path:b.path})}return f=D.toPosixPath(f),u.with({path:R.posix.resolve(u.path,f)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,f){return u===f||(0,k.equalsIgnoreCase)(u,f)}hasTrailingPathSeparator(u,f=R.sep){if(u.scheme===L.Schemas.file){const b=m(u);return b.length>D.getRoot(b).length&&b[b.length-1]===f}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,f=R.sep){return(0,e.hasTrailingPathSeparator)(u,f)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,f=R.sep){let b=!1;if(u.scheme===L.Schemas.file){const S=m(u);b=S!==void 0&&S.length===D.getRoot(S).length&&S[S.length-1]===f}else{f="/";const S=u.path;b=S.length===1&&S.charCodeAt(S.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,f)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,u){const f=[];for(let b=0;b<p.length;b++){const S=u(p[b]);p.some((C,v)=>v===b?!1:(0,e.isEqualOrParent)(S,u(C)))||f.push(p[b])}return f}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function u(f){const b=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,s]=v.split(":");o&&s&&b.set(o,s)});const C=f.path.substring(0,f.path.indexOf(";"));return C&&b.set(p.META_DATA_MIME,C),b}p.parseMetaData=u})(I=e.DataUri||(e.DataUri={}));function h(p,u,f){if(u){let b=p.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),p.with({scheme:f,authority:u,path:b})}return p.with({scheme:f})}e.toLocalResource=h}),define(te[6],ne([0,1,29,11,3,2,15]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(V){return!!V&&typeof V.then=="function"}e.isThenable=P;function m(V){const x=new D.CancellationTokenSource,B=V(x.token),N=new Promise((G,$)=>{const J=x.token.onCancellationRequested(()=>{J.dispose(),x.dispose(),$((0,L.canceled)())});Promise.resolve(B).then(_=>{J.dispose(),x.dispose(),G(_)},_=>{J.dispose(),x.dispose(),$(_)})});return new class{cancel(){x.cancel()}then(G,$){return N.then(G,$)}catch(G){return this.then(void 0,G)}finally(G){return N.finally(G)}}}e.createCancelablePromise=m;function E(V,x,B){return Promise.race([V,new Promise(N=>x.onCancellationRequested(()=>N(B)))])}e.raceCancellation=E;async function i(V){let x=-1;const B=V.map((G,$)=>G.then(J=>(x=$,J))),N=await Promise.race(B);return V.forEach((G,$)=>{$!==x&&G.cancel()}),N}e.raceCancellablePromises=i;function I(V,x,B){let N;const G=setTimeout(()=>{N?.(void 0),B?.()},x);return Promise.race([V.finally(()=>clearTimeout(G)),new Promise($=>N=$)])}e.raceTimeout=I;function h(V){return new Promise((x,B)=>{const N=V();P(N)?N.then(x,B):x(N)})}e.asPromise=h;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(B,B).then(N)})}return new Promise((B,N)=>{this.queuedPromise.then(B,N)})}return this.activePromise=x(),new Promise((B,N)=>{this.activePromise.then(G=>{this.activePromise=null,B(G)},G=>{this.activePromise=null,N(G)})})}}e.Throttler=p;class u{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=u;class f{constructor(){this.promiseMap=new Map}queue(x,B){const G=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(x)===G&&this.promiseMap.delete(x)});return this.promiseMap.set(x,G),G}}e.SequencerByKey=f;class b{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,B=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,G)=>{this.doResolve=N,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class S{constructor(x){this.delayer=new b(x),this.throttler=new p}trigger(x,B){return this.delayer.trigger(()=>this.throttler.queue(x),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class C{constructor(){this._isOpen=!1,this._promise=new Promise((x,B)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class v extends C{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function o(V,x){return x?new Promise((B,N)=>{const G=setTimeout(()=>{$.dispose(),B()},V),$=x.onCancellationRequested(()=>{clearTimeout(G),$.dispose(),N((0,L.canceled)())})}):m(B=>o(V,B))}e.timeout=o;function s(V,x=0){const B=setTimeout(V,x);return(0,A.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=s;function t(V){const x=[];let B=0;const N=V.length;function G(){return B<N?V[B++]():null}function $(J){J!=null&&x.push(J);const _=G();return _?_.then($):Promise.resolve(x)}return Promise.resolve(null).then($)}e.sequence=t;function a(V,x=N=>!!N,B=null){let N=0;const G=V.length,$=()=>{if(N>=G)return Promise.resolve(B);const J=V[N++];return Promise.resolve(J()).then(W=>x(W)?Promise.resolve(W):$())};return $()}e.first=a;function n(V,x=N=>!!N,B=null){if(V.length===0)return Promise.resolve(B);let N=V.length;const G=()=>{N=-1;for(const $ of V)$.cancel?.()};return new Promise(($,J)=>{for(const _ of V)_.then(W=>{--N>=0&&x(W)?(G(),$(W)):N===0&&$(B)}).catch(W=>{--N>=0&&(G(),J(W))})})}e.firstParallel=n;class r{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((B,N)=>{this.outstandingPromises.push({factory:x,c:B,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const B=x.factory();B.then(x.c,x.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class c{constructor(){this.queues=new Map}queueFor(x,B=k.extUri){const N=B.getComparisonKey(x);let G=this.queues.get(N);return G||(G=new l,R.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(N)}),this.queues.set(N,G)),G}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=c;class d{constructor(x,B){this._token=-1,typeof x=="function"&&typeof B=="number"&&this.setIfNotSet(x,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},B)}setIfNotSet(x,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},B))}}e.TimeoutTimer=d;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setInterval(()=>{x()},B)}}e.IntervalTimer=g;class w{constructor(x,B){this.timeoutToken=-1,this.runner=x,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=w;class T{constructor(x,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends w{constructor(x,B){super(x,B);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class y extends A.Disposable{constructor(x,B,N,G){super();this.maxWorkChunkSize=x,this.maxPendingWork=B,this.throttleDelay=N,this.handler=G,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new w(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=y,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const B=setTimeout(()=>x(V));let N=!1;return{dispose(){N||(N=!0,clearTimeout(B))}}}}else e.runWhenIdle=(V,x)=>{const B=requestIdleCallback(V,typeof x=="number"?{timeout:x}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(B))}}}}();class F{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function M(V,x,B){let N;for(let G=0;G<B;G++)try{return await V()}catch($){N=$,await o(x)}throw N}e.retry=M;class q{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,B,N){return this._pending={taskId:x,cancel:()=>N?.(),promise:B},B.then(()=>this.donePending(x),()=>this.donePending(x)),B}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let B,N;const G=new Promise(($,J)=>{B=$,N=J});this._next={run:x,promise:G,promiseResolve:B,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=q;class j{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,B)=>{this.completeCallback=x,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(B=>{this.completeCallback(x),this.resolved=!0,B()})}error(x){return new Promise(B=>{this.errorCallback(x),this.rejected=!0,B()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=U;var z;(function(V){async function x(B){let N;const G=await Promise.all(B.map($=>$.then(J=>J,J=>{N||(N=J)})));if(typeof N!="undefined")throw N;return G}V.settled=x})(z=e.Promises||(e.Promises={}))}),define(te[67],ne([0,1,6,39,40,8,24]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",E="/",i="[/\\\\]",I="[^/\\\\]",h=/\//g;function p(N){switch(N){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function u(N,G){if(!N)return[];const $=[];let J=!1,_=!1,W="";for(const K of N){switch(K){case G:if(!J&&!_){$.push(W),W="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":_=!0;break;case"]":_=!1;break}W+=K}return W&&$.push(W),$}e.splitGlobAware=u;function f(N){if(!N)return"";let G="";const $=u(N,E);if($.every(J=>J===m))G=".*";else{let J=!1;$.forEach((_,W)=>{if(_===m){J||(G+=p(2),J=!0);return}let K=!1,Q="",Z=!1,se="";for(const le of _){if(le!=="}"&&K){Q+=le;continue}if(Z&&(le!=="]"||!se)){let ce;le==="-"?ce=le:(le==="^"||le==="!")&&!se?ce="^":le===E?ce="":ce=k.escapeRegExpCharacters(le),se+=ce;continue}switch(le){case"{":K=!0;continue;case"[":Z=!0;continue;case"}":G+=`(?:${u(Q,",").map(we=>f(we)).join("|")})`,K=!1,Q="";break;case"]":G+="["+se+"]",Z=!1,se="";break;case"?":G+=I;continue;case"*":G+=p(1);continue;default:G+=k.escapeRegExpCharacters(le)}}W<$.length-1&&($[W+1]!==m||W+2<$.length)&&(G+=i),J=!1})}return G}const b=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),a=function(){return!1},n=function(){return null};function r(N,G){if(!N)return n;let $;typeof N!="string"?$=N.pattern:$=N,$=$.trim();const J=`${$}_${!!G.trimForExclusions}`;let _=t.get(J);if(_)return l(_,N);let W;if(b.test($)){const K=$.substr(4);_=function(Q,Z){return typeof Q=="string"&&Q.endsWith(K)?$:null}}else(W=S.exec(c($,G)))?_=d(W[1],$):(G.trimForExclusions?v:C).test($)?_=g($,G):(W=o.exec(c($,G)))?_=w(W[1].substr(1),$,!0):(W=s.exec(c($,G)))?_=w(W[1],$,!1):_=T($);return t.set(J,_),l(_,N)}function l(N,G){return typeof G=="string"?N:function($,J){return L.isEqualOrParent($,G.base)?N(A.relative(G.base,$),J):null}}function c(N,G){return G.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function d(N,G){const $=`/${N}`,J=`\\${N}`,_=function(K,Q){return typeof K!="string"?null:Q?Q===N?G:null:K===N||K.endsWith($)||K.endsWith(J)?G:null},W=[N];return _.basenames=W,_.patterns=[G],_.allBasenames=W,_}function g(N,G){const $=B(N.slice(1,-1).split(",").map(Q=>r(Q,G)).filter(Q=>Q!==n),N),J=$.length;if(!J)return n;if(J===1)return $[0];const _=function(Q,Z){for(let se=0,le=$.length;se<le;se++)if($[se](Q,Z))return N;return null},W=$.find(Q=>!!Q.allBasenames);W&&(_.allBasenames=W.allBasenames);const K=$.reduce((Q,Z)=>Z.allPaths?Q.concat(Z.allPaths):Q,[]);return K.length&&(_.allPaths=K),_}function w(N,G,$){const J=A.sep===A.posix.sep,_=J?N:N.replace(h,A.sep),W=A.sep+_,K=A.posix.sep+N,Q=$?function(Z,se){return typeof Z=="string"&&(Z===_||Z.endsWith(W)||!J&&(Z===N||Z.endsWith(K)))?G:null}:function(Z,se){return typeof Z=="string"&&(Z===_||!J&&Z===N)?G:null};return Q.allPaths=[($?"*/":"./")+N],Q}function T(N){try{const G=new RegExp(`^${f(N)}$`);return function($){return G.lastIndex=0,typeof $=="string"&&G.test($)?N:null}}catch(G){return n}}function O(N,G,$){return!N||typeof G!="string"?!1:y(N)(G,void 0,$)}e.match=O;function y(N,G={}){if(!N)return a;if(typeof N=="string"||j(N)){const $=r(N,G);if($===n)return a;const J=function(_,W){return!!$(_,W)};return $.allBasenames&&(J.allBasenames=$.allBasenames),$.allPaths&&(J.allPaths=$.allPaths),J}return V(N,G)}e.parse=y;function F(N){if(!N)return;let G;return $=>(G||(G=(N()||Promise.resolve([])).then(J=>J?q(J):{})),G.then(J=>!!J[$]))}e.hasSiblingPromiseFn=F;function M(N){if(!N)return;let G;return $=>{if(!G){const J=N();G=J?q(J):{}}return!!G[$]}}e.hasSiblingFn=M;function q(N){const G={};for(const $ of N)G[$]=!0;return G}function j(N){const G=N;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=j;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function z(N){return N.allPaths||[]}e.getPathTerms=z;function V(N,G){const $=B(Object.getOwnPropertyNames(N).map(Q=>x(Q,N[Q],G)).filter(Q=>Q!==n)),J=$.length;if(!J)return n;if(!$.some(Q=>!!Q.requiresSiblings)){if(J===1)return $[0];const Q=function(le,ce){for(let ge=0,we=$.length;ge<we;ge++){const Se=$[ge](le,ce);if(Se)return Se}return null},Z=$.find(le=>!!le.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const se=$.reduce((le,ce)=>ce.allPaths?le.concat(ce.allPaths):le,[]);return se.length&&(Q.allPaths=se),Q}const _=function(Q,Z,se){let le;for(let ce=0,ge=$.length;ce<ge;ce++){const we=$[ce];we.requiresSiblings&&se&&(Z||(Z=A.basename(Q)),le||(le=Z.substr(0,Z.length-A.extname(Q).length)));const Se=we(Q,Z,le,se);if(Se)return Se}return null},W=$.find(Q=>!!Q.allBasenames);W&&(_.allBasenames=W.allBasenames);const K=$.reduce((Q,Z)=>Z.allPaths?Q.concat(Z.allPaths):Q,[]);return K.length&&(_.allPaths=K),_}function x(N,G,$){if(G===!1)return n;const J=r(N,$);if(J===n)return n;if(typeof G=="boolean")return J;if(G){const _=G.when;if(typeof _=="string"){const W=(K,Q,Z,se)=>{if(!se||!J(K,Q))return null;const le=_.replace("$(basename)",Z),ce=se(le);return(0,D.isThenable)(ce)?ce.then(ge=>ge?N:null):ce?N:null};return W.requiresSiblings=!0,W}}return J}function B(N,G){const $=N.filter(Q=>!!Q.basenames);if($.length<2)return N;const J=$.reduce((Q,Z)=>{const se=Z.basenames;return se?Q.concat(se):Q},[]);let _;if(G){_=[];for(let Q=0,Z=J.length;Q<Z;Q++)_.push(G)}else _=$.reduce((Q,Z)=>{const se=Z.patterns;return se?Q.concat(se):Q},[]);const W=function(Q,Z){if(typeof Q!="string")return null;if(!Z){let le;for(le=Q.length;le>0;le--){const ce=Q.charCodeAt(le-1);if(ce===47||ce===92)break}Z=Q.substr(le)}const se=J.indexOf(Z);return se!==-1?_[se]:null};W.basenames=J,W.patterns=_,W.allBasenames=J;const K=N.filter(Q=>!Q.basenames);return K.push(W),K}}),define(te[95],ne([0,1,67,17,8,15,24]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],E=[],i=[];function I(r,l=!1){const c=h(r);m.push(c),c.userConfigured?i.push(c):E.push(c),l&&!c.userConfigured&&m.forEach(d=>{d.mime===c.mime||d.userConfigured||(c.extension&&d.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&d.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&d.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&d.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=I;function h(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,D.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(R.posix.sep)>=0:!1}}function p(r){r?(m=m.filter(l=>!l.userConfigured),i=[]):(m=[],E=[],i=[])}e.clearTextMimes=p;function u(r,l){let c;if(r)switch(r.scheme){case L.Schemas.file:c=r.fsPath;break;case L.Schemas.data:c=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:c=r.path}if(!c)return[P.unknown];c=c.toLowerCase();const d=(0,R.basename)(c),g=f(c,d,i);if(g)return[g,P.text];const w=f(c,d,E);if(w)return[w,P.text];if(l){const T=b(l);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=u;function f(r,l,c){let d=null,g=null,w=null;for(let T=c.length-1;T>=0;T--){const O=c[T];if(l===O.filenameLowercase){d=O;break}if(O.filepattern&&(!g||O.filepattern.length>g.filepattern.length)){const y=O.filepatternOnPath?r:l;O.filepatternLowercase?.(y)&&(g=O)}O.extension&&(!w||O.extension.length>w.extension.length)&&l.endsWith(O.extensionLowercase)&&(w=O)}return d?d.mime:g?g.mime:w?w.mime:null}function b(r){if((0,k.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let l=m.length-1;l>=0;l--){const c=m[l];if(!c.firstline)continue;const d=r.match(c.firstline);if(d&&d.length>0)return c.mime}return null}function S(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&S(r[0]):!0}e.isUnspecific=S;const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(r){const l=(0,R.extname)(r),c=C[l.toLowerCase()];return c!==void 0?c:s(r)}e.getMediaOrTextMime=o;function s(r){const l=(0,R.extname)(r);return v[l.toLowerCase()]}e.getMediaMime=s;function t(r){for(const l in v)if(v[l]===r)return l}e.getExtensionForMimeType=t;const a=/^(.+)\/(.+?)(;.+)?$/;function n(r,l){const c=a.exec(r);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:l?void 0:r}e.normalizeMimeType=n}),define(te[96],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(I){this._uriTransformer=I}transformIncoming(I){const h=this._uriTransformer.transformIncoming(I);return h===I?I:L(D.URI.from(h))}transformOutgoing(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:L(D.URI.from(h))}transformOutgoingURI(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:D.URI.from(h)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,I,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const u=A(i[p],I,h+1);u!==null&&(i[p]=u)}}return null}function k(i,I){const h=A(i,I,0);return h===null?i:h}e.transformOutgoingURIs=k;function P(i,I,h,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?D.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const f=P(i[u],I,h,p+1);f!==null&&(i[u]=f)}}return null}function m(i,I){const h=P(i,I,!1,0);return h===null?i:h}e.transformIncomingURIs=m;function E(i,I){const h=P(i,I,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=E}),define(te[30],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(m){return D.test(m)}e.isUUID=L;const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+="-",E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E+=A[R[m++]],E}e.generateUuid=P}),define(te[68],ne([0,1,218]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return k;let m=0,E,i=m;for(;i<P.length;)if(E=P.charCodeAt(i),E===13||E===10){if(k.push(P.substring(m,i)),i++,i<P.length){const I=E;E=P.charCodeAt(i),(I===13&&E===10||I===10&&E===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(te[97],ne([0,1,35]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!L.has(m)}function A(){return new Promise(async(P,m)=>{const E=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){m(i)}finally{clearTimeout(E)}})}e.getMac=A;function k(){return new Promise((P,m)=>{try{const E=(0,D.networkInterfaces)();for(let i in E){const I=E[i];if(I){for(const{mac:h}of I)if(R(h))return P(h)}}m("Unable to retrieve mac address (unexpected format)")}catch(E){m(E)}})}}),define(te[98],ne([0,1,35,11,40,30,97]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const h=(0,D.networkInterfaces)();for(let p in h){const u=h[p];if(u)for(const{mac:f,internal:b}of u)b||(I+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let P;async function m(){return P||(P=(async()=>await E()||A.generateUuid())()),P}e.getMachineId=m;async function E(){try{const i=await new Promise((h,p)=>{Y(["crypto"],h,p)}),I=await(0,k.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(te[19],ne([0,1,51,35,219,6,39,66,8,4,15,5,30]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function u(U,z=p.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?b(U):f(U)}async function f(U){try{const z=(0,m.join)((0,L.tmpdir)(),(0,h.generateUuid)());try{await e.Promises.rename(U,z)}catch(V){return b(U)}b(z).catch(V=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function b(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function S(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=S;async function C(U,z){return s(await(z?v(U):(0,R.promisify)(D.readdir)(U)))}async function v(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],V=await C(U);for(const x of V){let B=!1,N=!1,G=!1;try{const $=await e.Promises.lstat((0,m.join)(U,x));B=$.isFile(),N=$.isDirectory(),G=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}z.push({name:x,isFile:()=>B,isDirectory:()=>N,isSymbolicLink:()=>G})}return z}function o(U){return s(D.readdirSync(U))}e.readdirSync=o;function s(U){return U.map(z=>typeof z=="string"?E.isMacintosh?(0,P.normalizeNFC)(z):z:(z.name=E.isMacintosh?(0,P.normalizeNFC)(z.name):z.name,z))}async function t(U){const z=await C(U),V=[];for(const x of z)await n.existsDirectory((0,m.join)(U,x))&&V.push(x);return V}function a(U,z=1e3){return new Promise(V=>{let x=!1;const B=setInterval(()=>{x||(x=!0,D.access(U,N=>{x=!1,N&&(clearInterval(B),V(void 0))}))},z)})}e.whenDeleted=a;var n;(function(U){async function z(B){let N;try{if(N=await e.Promises.lstat(B),!N.isSymbolicLink())return{stat:N}}catch(G){}try{return{stat:await e.Promises.stat(B),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(E.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw $}throw G}}U.stat=z;async function V(B){try{const{stat:N,symbolicLink:G}=await U.stat(B);return N.isFile()&&G?.dangling!==!0}catch(N){}return!1}U.existsFile=V;async function x(B){try{const{stat:N,symbolicLink:G}=await U.stat(B);return N.isDirectory()&&G?.dangling!==!0}catch(N){}return!1}U.existsDirectory=x})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function l(U,z,V){return r.queueFor(I.URI.file(U),i.extUriBiasedIgnorePathCase).queue(()=>{const x=w(V);return new Promise((B,N)=>d(U,z,x,G=>G?N(G):B()))})}let c=!0;function d(U,z,V,x){if(!c)return D.writeFile(U,z,{mode:V.mode,flag:V.flag},x);D.open(U,V.flag,V.mode,(B,N)=>{if(B)return x(B);D.writeFile(N,z,G=>{if(G)return D.close(N,()=>x(G));D.fdatasync(N,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),c=!1),D.close(N,J=>x(J))))})})}function g(U,z,V){const x=w(V);if(!c)return D.writeFileSync(U,z,{mode:x.mode,flag:x.flag});const B=D.openSync(U,x.flag,x.mode);try{D.writeFileSync(B,z);try{D.fdatasyncSync(B)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c=!1}}finally{D.closeSync(B)}}e.writeFileSync=g;function w(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function T(U,z){if(U===z)return;async function V(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,z),await V(z)}catch(x){if(U.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||U.endsWith("."))await O(U,z,{preserveSymlinks:!1}),await u(U,p.MOVE),await V(z);else throw x}}async function O(U,z,V){return F(U,z,{root:{source:U,target:z},options:V,handledSourcePaths:new Set})}const y=511;async function F(U,z,V){if(V.handledSourcePaths.has(U))return;V.handledSourcePaths.add(U);const{stat:x,symbolicLink:B}=await n.stat(U);if(B){if(V.options.preserveSymlinks)try{return await j(U,z,V)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(B.dangling)return}return x.isDirectory()?M(U,z,x.mode&y,V):q(U,z,x.mode&y)}async function M(U,z,V,x){await e.Promises.mkdir(z,{recursive:!0,mode:V});const B=await C(U);for(const N of B)await F((0,m.join)(U,N),(0,m.join)(z,N),x)}async function q(U,z,V){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,V)}async function j(U,z,V){let x=await e.Promises.readlink(U);(0,k.isEqualOrParent)(x,V.root.source,!E.isLinux)&&(x=(0,m.join)(V.root.target,x.substr(V.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return u}get move(){return T}get copy(){return O}}}),define(te[99],ne([0,1,51,8,24,19]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const I=(0,L.dirname)(i);if(i===I)return i;const h=((0,L.basename)(i)||i).toLowerCase();try{const u=(0,A.readdirSync)(I).filter(f=>f.toLowerCase()===h);if(u.length===1){const f=k(I);if(f)return(0,L.join)(f,u[0])}else if(u.length>1){const f=u.indexOf(h);if(f>=0){const b=k(I);if(b)return(0,L.join)(b,u[f])}}}catch(p){}return null}e.realcaseSync=k;async function P(i){try{return await A.Promises.realpath(i)}catch(I){const h=E(i);return await A.Promises.access(h,D.constants.R_OK),h}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(I){const h=E(i);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=m;function E(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(te[69],ne([0,1,35,8,19]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(s,t,a){this.exePath=s,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?E===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:s=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const a=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let n=-1,r=null;for(const d of await R.Promises.readdir(a)){let g=-1;if(s){const T=d.indexOf("-");if(T<0)continue;const O=d.substring(0,T);if(!A.test(O)||d.substring(T+1)!=="preview")continue;g=parseInt(O,10)}else{if(!A.test(d))continue;g=parseInt(d,10)}if(g<=n)continue;const w=L.join(a,d,"pwsh.exe");!await R.SymlinkSupport.existsFile(w)||(r=w,n=g)}if(!r)return null;const l=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new I(r,`PowerShell${c}${l}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(s))if(t.test(n)){const r=L.join(s,n,"pwsh.exe");return new I(r,a)}return null}function f(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function b(){const o=L.join(process.env.windir,E===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*S(){let o=await p();o&&(yield o),o=await p({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=f(),o&&(yield o),o=await p({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await p({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*C(){for await(const o of S())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=C;async function v(){for await(const o of C())return o;return null}e.getFirstAvailablePowerShellInstallation=v}),define(te[100],ne([0,1,41,17]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,m)=>{let E;const i=new Map;function I(p,u,f,b,S){const C=i.get(u);if(p===k||C){const v={name:h(f),cmd:f,pid:p,ppid:u,load:b,mem:S};i.set(p,v),p===k&&(E=v),C&&(C.children||(C.children=[]),C.children.push(v),C.children.length>1&&(C.children=C.children.sort((o,s)=>o.pid-s.pid)))}}function h(p){const u=/--disable-blink-features=Auxclick/,f=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,S=/\\pipe\\winpty-control/,C=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(f.exec(p))return"watcherService ";if(b.exec(p))return"electron-crash-reporter";if(S.exec(p))return"winpty-process";if(C.exec(p))return"console-window-host (Windows internal process)";let o=v.exec(p);if(o&&o.length===2)return o[1]==="renderer"?u.exec(p)?"shared-process":"window":o[1];const s=/[a-zA-Z-]+\.js/g;let t="";do o=s.exec(p),o&&(t+=o+" ");while(o);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,f)=>{Y(["windows-process-tree"],u,f)}).then(u=>{u.getProcessList(k,f=>{u.getProcessCpuUsage(f,b=>{const S=new Map;b.forEach(C=>{const v=p(C.commandLine||"");S.set(C.pid,{name:h(v),cmd:v,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),E=S.get(k),E?(S.forEach(C=>{const v=S.get(C.ppid);v&&(v.children||(v.children=[]),v.children.push(C))}),S.forEach(C=>{C.children&&(C.children=C.children.sort((v,o)=>v.pid-o.pid))}),P(E)):m(new Error(`Root process ${k} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let p=function(){let u=[E];const f=[];for(;u.length;){const S=u.shift();S&&(f.push(S.pid),S.children&&(u=u.concat(S.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);b+=" "+f.join(" "),(0,D.exec)(b,{},(S,C,v)=>{if(S||v)m(S||new Error(v.toString()));else{const o=C.toString().split(`
`);for(let s=0;s<f.length;s++){const t=i.get(f[s]);t.load=parseFloat(o[s])}if(!E){m(new Error(`Root process ${k} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(u,f,b)=>{if(u||b)if(process.platform!=="linux")m(u||new Error(b.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,D.exec)(S,{},(C,v,o)=>{C||o?m(C||new Error(o.toString())):(A(v,I),p())})}else{const S=f.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${S} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,o,s)=>{v||s&&!s.includes("screen size is bogus")?m(v||new Error(s.toString())):(A(o,I),process.platform==="linux"?p():E?P(E):m(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function A(k,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const i of E){const I=m.exec(i.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[101],ne([0,1,51,39,2,66,8,4,19]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function E(h,p,u){return I({path:h,isDirectory:!1},p,u)}e.watchFile=E;function i(h,p,u){return I({path:h,isDirectory:!0},p,u)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function I(h,p,u){if(P.isMacintosh&&(0,L.isEqualOrParent)(h.path,"/Volumes/"))return u(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const f=(0,k.basename)(h.path),b=new Map;let S=!1,C=[(0,R.toDisposable)(()=>{b.forEach(v=>(0,R.dispose)(v)),b.clear()})];try{const v=(0,D.watch)(h.path);C.push((0,R.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const o=new Set;h.isDirectory&&m.Promises.readdir(h.path).then(s=>s.forEach(t=>o.add(t))),v.on("error",(s,t)=>{S||u(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${t})`)}),v.on("change",(s,t)=>{if(S)return;let a="";if(t&&(a=t.toString(),P.isMacintosh&&(a=(0,A.normalizeNFC)(a))),!a||s!=="change"&&s!=="rename")return;const n=h.isDirectory?(0,k.join)(h.path,a):h.path;if(h.isDirectory)if(s==="rename"){const r=b.get(n);r&&(0,R.dispose)(r);const l=setTimeout(async()=>{b.delete(n);const c=await m.Promises.exists(n);if(S)return;let d;c?o.has(a)?d="changed":(d="added",o.add(a)):(o.delete(a),d="deleted"),p(d,n)},e.CHANGE_BUFFER_DELAY);b.set(n,(0,R.toDisposable)(()=>clearTimeout(l)))}else{let r;o.has(a)?r="changed":(r="added",o.add(a)),p(r,n)}else if(s==="rename"||a!==f){const r=setTimeout(async()=>{const l=await m.Promises.exists(n);S||(l?(p("changed",n),C=[I(h,p,u)]):p("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(C),C=[(0,R.toDisposable)(()=>clearTimeout(r))]}else p("changed",n)})}catch(v){m.Promises.exists(h.path).then(o=>{o&&!S&&u(`Failed to watch ${h.path} for changes using fs.watch() (${v.toString()})`)})}return(0,R.toDisposable)(()=>{S=!0,C=(0,R.dispose)(C)})}});var fe=this&&this.__decorate||function(Y,e,D,L){var R=arguments.length,A=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,D,L);else for(var P=Y.length-1;P>=0;P--)(k=Y[P])&&(A=(R<3?k(A):R>3?k(e,D,A):k(e,D))||A);return R>3&&A&&Object.defineProperty(e,D,A),A};define(te[36],ne([0,1,18,6,25,29,64,11,3,2,94,24,16]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function u(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function b(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(S||(S={}));class C{constructor(N){this.buffer=N,this.pos=0}read(N){const G=this.buffer.slice(this.pos,this.pos+N);return this.pos+=G.byteLength,G}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(o||(o={}));function s(B){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(B,0),N}function t(B){return B.read(4).readUInt32BE(0)}function a(B){const N=R.VSBuffer.alloc(1);return N.writeUInt8(B,0),N}const n={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},r=typeof Buffer!="undefined";function l(B,N){if(typeof N=="undefined")B.write(n.Undefined);else if(typeof N=="string"){const G=R.VSBuffer.fromString(N);B.write(n.String),B.write(s(G.byteLength)),B.write(G)}else if(r&&Buffer.isBuffer(N)){const G=R.VSBuffer.wrap(N);B.write(n.Buffer),B.write(s(G.byteLength)),B.write(G)}else if(N instanceof R.VSBuffer)B.write(n.VSBuffer),B.write(s(N.byteLength)),B.write(N);else if(Array.isArray(N)){B.write(n.Array),B.write(s(N.length));for(const G of N)l(B,G)}else{const G=R.VSBuffer.fromString(JSON.stringify(N));B.write(n.Object),B.write(s(G.byteLength)),B.write(G)}}function c(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(t(B)).toString();case o.Buffer:return B.read(t(B)).buffer;case o.VSBuffer:return B.read(t(B));case o.Array:{const G=t(B),$=[];for(let J=0;J<G;J++)$.push(c(B));return $}case o.Object:return JSON.parse(B.read(t(B)).toString())}}class d{constructor(N,G,$=null,J=1e3){this.protocol=N,this.ctx=G,this.logger=$,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(N,G){this.channels.set(N,G),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const G=this.send([N.type]);this.logger&&this.logger.logOutgoing(G,0,1,b(N.type));return}case 201:case 202:case 204:case 203:{const G=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(G,N.id,1,b(N.type),N.data);return}}}send(N,G=void 0){const $=new v;return l($,N),l($,G),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onRawMessage(N){const G=new C(N),$=c(G),J=c(G),_=$[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${u(_)}: ${$[2]}.${$[3]}`,J),this.onPromise({type:_,id:$[1],channelName:$[2],name:$[3],arg:J});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${u(_)}: ${$[2]}.${$[3]}`,J),this.onEventListen({type:_,id:$[1],channelName:$[2],name:$[3],arg:J});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${u(_)}`),this.disposeActiveRequest({type:_,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${u(_)}`),this.disposeActiveRequest({type:_,id:$[1]})}}onPromise(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const $=new A.CancellationTokenSource;let J;try{J=G.call(this.ctx,N.name,N.arg,$.token)}catch(K){J=Promise.reject(K)}const _=N.id;J.then(K=>{this.sendResponse({id:_,data:K,type:201}),this.activeRequests.delete(N.id)},K=>{K instanceof Error?this.sendResponse({id:_,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:_,data:K,type:203}),this.activeRequests.delete(N.id)});const W=(0,E.toDisposable)(()=>$.cancel());this.activeRequests.set(N.id,W)}onEventListen(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const $=N.id,_=G.listen(this.ctx,N.name,N.arg)(W=>this.sendResponse({id:$,data:W,type:204}));this.activeRequests.set(N.id,_)}disposeActiveRequest(N){const G=this.activeRequests.get(N.id);G&&(G.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let G=this.pendingRequests.get(N.channelName);G||(G=[],this.pendingRequests.set(N.channelName,G));const $=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:N,timeoutTimer:$})}flushPendingRequests(N){const G=this.pendingRequests.get(N);if(G){for(const $ of G)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var g;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,G=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=G}getChannel(N){const G=this;return{call($,J,_){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise(N,$,J,_)},listen($,J){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent(N,$,J)}}}requestPromise(N,G,$,J=A.CancellationToken.None){const _=this.lastRequestId++,K={id:_,type:100,channelName:N,name:G,arg:$};if(J.isCancellationRequested)return Promise.reject(P.canceled());let Q;return new Promise((se,le)=>{if(J.isCancellationRequested)return le(P.canceled());const ce=()=>{const ke=Re=>{switch(Re.type){case 201:this.handlers.delete(_),se(Re.data);break;case 202:this.handlers.delete(_);const Pe=new Error(Re.data.message);Pe.stack=Re.data.stack,Pe.name=Re.data.name,le(Pe);break;case 203:this.handlers.delete(_),le(Re.data);break}};this.handlers.set(_,ke),this.sendRequest(K)};let ge=null;this.state===S.Idle?ce():(ge=(0,L.createCancelablePromise)(ke=>this.whenInitialized()),ge.then(()=>{ge=null,ce()}));const we=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:_,type:101}),le(P.canceled())},Se=J.onCancellationRequested(we);Q=(0,E.combinedDisposable)((0,E.toDisposable)(we),Se),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(N,G,$){const J=this.lastRequestId++,W={id:J,type:102,channelName:N,name:G,arg:$};let K=null;const Q=new m.Emitter({onFirstListenerAdd:()=>{K=(0,L.createCancelablePromise)(se=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(Q),this.sendRequest(W)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(Q),this.sendRequest({id:J,type:103}))}}),Z=se=>Q.fire(se.data);return this.handlers.set(J,Z),Q.event}sendRequest(N){switch(N.type){case 100:case 102:{const G=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(G,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const G=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(G,N.id,0,u(N.type));return}}}send(N,G=void 0){const $=new v;return l($,N),l($,G),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onBuffer(N){const G=new C(N),$=c(G),J=c(G),_=$[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,b(_)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],0,b(_),J),this.onResponse({type:$[0],id:$[1],data:J})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(N.id);G&&G(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}fe([k.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class T{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:G,onDidClientDisconnect:$})=>{m.Event.once(G.onMessage)(_=>{const W=new C(_),K=c(W),Q=new d(G,K),Z=new w(G);this.channels.forEach((le,ce)=>Q.registerChannel(ce,le));const se={channelServer:Q,channelClient:Z,ctx:K};this._connections.add(se),this._onDidAddConnection.fire(se),$(()=>{Q.dispose(),Z.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const N=[];return this._connections.forEach(G=>N.push(G)),N}getChannel(N,G){const $=this;return{call(J,_,W){let K;if((0,h.isFunction)(G)){let Z=(0,D.getRandomElement)($.connections.filter(G));K=Z?Promise.resolve(Z):m.Event.toPromise(m.Event.filter($.onDidAddConnection,G))}else K=G.routeCall($,J,_);const Q=K.then(Z=>Z.channelClient.getChannel(N));return y(Q).call(J,_,W)},listen(J,_){if((0,h.isFunction)(G))return $.getMulticastEvent(N,G,J,_);const W=G.routeEvent($,J,_).then(K=>K.channelClient.getChannel(N));return y(W).listen(J,_)}}}getMulticastEvent(N,G,$,J){const _=this;let W=new E.DisposableStore;const K=new m.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const Q=new m.EventMultiplexer,Z=new Map,se=ce=>{const we=ce.channelClient.getChannel(N).listen($,J),Se=Q.add(we);Z.set(ce,Se)},le=ce=>{const ge=Z.get(ce);!ge||(ge.dispose(),Z.delete(ce))};_.connections.filter(G).forEach(se),m.Event.filter(_.onDidAddConnection,G)(se,void 0,W),_.onDidRemoveConnection(le,void 0,W),Q.event(K.fire,K,W),W.add(Q)},onLastListenerRemove:()=>{W.dispose()}});return K.event}registerChannel(N,G){this.channels.set(N,G),this._connections.forEach($=>{$.channelServer.registerChannel(N,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor(N,G,$=null){const J=new v;l(J,G),N.send(J.buffer),this.channelClient=new w(N,$),this.channelServer=new d(N,G,$)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,G){this.channelServer.registerChannel(N,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function y(B){return{call(N,G,$){return B.then(J=>J.call(N,G,$))},listen(N,G){const $=new m.Relay;return B.then(J=>$.input=J.listen(N,G)),$.event}}}e.getDelayedChannel=y;function F(B){let N=!1;return{call(G,$,J){return N?B.call(G,$,J):(0,L.timeout)(0).then(()=>N=!0).then(()=>B.call(G,$,J))},listen(G,$){if(N)return B.listen(G,$);const J=new m.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>J.input=B.listen(G,$)),J.event}}}e.getNextTickChannel=F;class M{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const G of N.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=M;var q;(function(B){function N(J,_){const W=J,K=_&&_.disableMarshalling,Q=new Map;for(const Z in W)$(Z)&&Q.set(Z,m.Event.buffer(W[Z],!0));return new class{listen(Z,se){const le=Q.get(se);if(le)return le;throw new Error(`Event not found: ${se}`)}call(Z,se,le){const ce=W[se];if(typeof ce=="function"){if(!K&&Array.isArray(le))for(let ge=0;ge<le.length;ge++)le[ge]=(0,i.revive)(le[ge]);return ce.apply(W,le)}throw new Error(`Method not found: ${se}`)}}}B.fromService=N;function G(J,_){const W=_&&_.disableMarshalling;return new Proxy({},{get(K,Q){if(typeof Q=="string")return _?.properties?.has(Q)?_.properties.get(Q):$(Q)?J.listen(Q):async function(...Z){let se;_&&!(0,h.isUndefinedOrNull)(_.context)?se=[_.context,...Z]:se=Z;const le=await J.call(Q,se);return W?le:(0,i.revive)(le)};throw new Error(`Property not found: ${String(Q)}`)}})}B.toService=G;function $(J){return J[0]==="o"&&J[1]==="n"&&I.isUpperAsciiLetter(J.charCodeAt(2))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let N=B.toString();if(N!=="[object Object]")return N}return B}function z(B){return Array.isArray(B)?B.map(U):U(B)}function V(B,N,G,$,J,_,W){W=z(W);const K=j[J],Q=K[$%K.length];let Z=[`%c[${B}]%c[${String(N).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String($).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(_)?(Z=Z.concat(W),Z.push(")")):Z.push(W),console.log.apply(console,Z)}e.logWithColors=V;class x{constructor(N,G){this._outgoingPrefix=N,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,G,$,J,_){this._totalOutgoing+=N,V(this._outgoingPrefix,this._totalOutgoing,N,G,$,J,_)}logIncoming(N,G,$,J,_){this._totalIncoming+=N,V(this._incomingPrefix,this._totalIncoming,N,G,$,J,_)}}e.IPCLogger=x}),define(te[102],ne([0,1,25,3,36]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(m){this.port=m,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class k extends R.IPCClient{constructor(m,E){const i=new A(m);super(i,E);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[103],ne([0,1,104,3,36,102]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const m=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,i)=>i);return L.Event.map(m,E=>{const{port1:i,port2:I}=new MessageChannel,p={protocol:new A.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[I]),p})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[105],ne([0,1,25,11]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((i,I)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=h=>I(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=h=>{i({res:{statusCode:E.status,headers:k(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=h=>I(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),m.onCancellationRequested(()=>{E.abort(),I((0,L.canceled)())})})}e.request=R;function A(P,m){if(m.headers){e:for(let E in m.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,m.headers[E])}}}function k(P){const m=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const i=E.indexOf(":");m[E.substr(0,i).trim().toLowerCase()]=E.substr(i+1).trim()}return m}}),define(te[70],ne([0,1,6,3,2,16]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(I){const h=I;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(m||(m={}));class E extends R.Disposable{constructor(h,p=Object.create(null)){super();this.database=h,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((p,u)=>this.accept(u,p)),h.deleted?.forEach(p=>this.accept(p,void 0))}accept(h,p){if(this.state===m.Closed)return;let u=!1;(0,A.isUndefinedOrNull)(p)?u=this.cache.delete(h):this.cache.get(h)!==p&&(this.cache.set(h,p),u=!0),u&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,p){const u=this.cache.get(h);return(0,A.isUndefinedOrNull)(u)?p:u}getBoolean(h,p){const u=this.get(h);return(0,A.isUndefinedOrNull)(u)?p:u==="true"}getNumber(h,p){const u=this.get(h);return(0,A.isUndefinedOrNull)(u)?p:parseInt(u,10)}async set(h,p){if(this.state===m.Closed)return;if((0,A.isUndefinedOrNull)(p))return this.delete(h);const u=String(p);if(this.cache.get(h)!==u)return this.cache.set(h,u),this.pendingInserts.set(h,u),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async delete(h){if(!(this.state===m.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((p,u)=>this.items.set(u,p)),h.delete&&h.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[106],ne([9,10]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[56],ne([0,1,106]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,A=R*24,k=A*7,P=A*30,m=A*365;function E(I,h){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,D.localize)(0,null,E(new Date().getTime()+p*1e3,!1));if(p<30)return(0,D.localize)(1,null);let u;return p<L?(u=p,h?u===1?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):u===1?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u)):p<R?(u=Math.floor(p/L),h?u===1?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):u===1?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):p<A?(u=Math.floor(p/R),h?u===1?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):u===1?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u)):p<k?(u=Math.floor(p/A),h?u===1?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):u===1?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):p<P?(u=Math.floor(p/k),h?u===1?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):u===1?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u)):p<m?(u=Math.floor(p/P),h?u===1?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):u===1?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):(u=Math.floor(p/m),h?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u))}e.fromNow=E;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[107],ne([9,10]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,18,16,107]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,i){return i&&(E.stack||E.stacktrace)?R.localize(0,null,P(E),k(E.stack)||k(E.stacktrace)):P(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function m(E=null,i=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const I=D.coalesce(E),h=m(I[0],i);return I.length>1?R.localize(4,null,h,I.length):h}if(L.isString(E))return E;if(E.detail){const I=E.detail;if(I.error)return A(I.error,i);if(I.exception)return A(I.exception,i)}return E.stack?A(E,i):E.message?E.message:R.localize(5,null)}e.toErrorMessage=m}),define(te[108],ne([9,10]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[71],ne([0,1,41,39,17,26,8,4,34,16,68,19,108]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,s){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const a=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{a.once("error",r=>{n({success:!1,error:r})}),a.once("exit",(r,l)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(a=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,l)=>{a(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=f;class b{constructor(s,t,a,n){if(t!==void 0&&a!==void 0&&n!==void 0)this.cmd=s,this.args=t,this.shell=a,this.options=n;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(m.env).forEach(l=>{r[l]=m.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(k.sep);return t!==-1&&(s=s.substring(t+1)),b.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(m.cwd()))?Promise.reject(new Error(h.localize(0,null))):this.useExec().then(t=>{let a,n;const r=new Promise((l,c)=>{a=l,n=c});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=D.exec(l,this.options,(c,d,g)=>{this.childProcess=null;const w=c;w&&w.killed?n({killed:this.terminateRequested,stdout:d.toString(),stderr:g.toString()}):this.handleExec(a,s,c,d,g)})}else{let l=null;const c=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,a,s,n);const g={terminated:this.terminateRequested};E.isNumber(d)&&(g.cmdCode=d),a(g)};if(this.shell&&P.isWindows){const d=A.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let g=!1,w=!1;const T=[];let O=this.ensureQuotes(this.cmd);T.push(O.value),g=O.quoted,this.args&&this.args.forEach(F=>{O=this.ensureQuotes(F),T.push(O.value),w=w&&O.quoted});const y=["/s","/c"];g?w?y.push('"'+T.join(" ")+'"'):T.length>1?y.push('"'+T[0]+'" '+T.slice(1).join(" ")):y.push('"'+T[0]+'"'):y.push(T.join(" ")),l=D.spawn(f(),y,d)}else this.cmd&&(l=D.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(E.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,n({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",c),this.handleSpawn(l,a,s,n,!0)))}return r})}handleClose(s,t,a,n){}ensureQuotes(s){return b.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,u(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const t=D.spawn(f(),["/s","/c"]);t.on("error",a=>s(!0)),t.on("exit",a=>s(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class S extends b{constructor(s,t,a,n){super(s,t,a,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,a,n,r){[n,r].forEach((l,c)=>{const d=new i.LineDecoder;d.write(l).forEach(T=>{t({line:T,source:c===0?0:1})});const w=d.end();w&&t({line:w,source:c===0?0:1})}),s({terminated:this.terminateRequested,error:a})}handleSpawn(s,t,a,n,r){const l=new i.LineDecoder,c=new i.LineDecoder;s.stdout.on("data",d=>{l.write(d).forEach(w=>a({line:w,source:0}))}),s.stderr.on("data",d=>{c.write(d).forEach(w=>a({line:w,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=c}handleClose(s,t,a,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&a({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=S;function C(o){let s=[],t=!1;const a=function(n){if(t){s.push(n);return}(!o.send(n,l=>{if(l&&console.error(l),t=!1,s.length>0){const c=s.slice(0);s=[],c.forEach(d=>a(d))}})||P.isWindows)&&(t=!0)};return{send:a}}e.createQueuedSender=C;var v;(function(o){async function s(t,a,n){if(k.isAbsolute(t))return t;if(a===void 0&&(a=m.cwd()),k.dirname(t)!=="."||(n===void 0&&E.isString(m.env.PATH)&&(n=m.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(a,t);async function l(c){if(await I.Promises.exists(c)){let d;try{d=await I.Promises.stat(c)}catch(g){g.message.startsWith("EACCES")&&(d=await I.Promises.lstat(c))}return d?!d.isDirectory():!1}return!1}for(let c of n){let d;if(k.isAbsolute(c)?d=k.join(c,t):d=k.join(a,c,t),await l(d))return d;let g=d+".com";if(await l(g)||(g=d+".exe",await l(g)))return g}return k.join(a,t)}o.findExecutable=s})(v=e.win32||(e.win32={}))}),define(te[109],ne([0,1,35,4,69,71]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(p,u){return p===1?L.isWindows?I():A.getWindowsShell(u):E(p,u)}e.getSystemShell=k;function P(p,u){return p===1?L.isWindows?h(u):A.getWindowsShell(u):E(p,u)}e.getSystemShellSync=P;let m=null;function E(p,u){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!m){let f;if(L.isWindows)f="/bin/bash";else{if(f=u.SHELL,!f)try{f=(0,D.userInfo)().shell}catch(b){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}m=f}return m}let i=null;async function I(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function h(p){if(i)return i;const u=L.isWindows&&parseFloat((0,D.release)())>=10,f=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${p.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?b:A.getWindowsShell(p)}}),define(te[52],ne([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends p.ChannelServer{constructor(S){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(v){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",C=>R.VSBuffer.wrap(Buffer.from(C,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=u;class f{constructor(S,C){this.modulePath=S,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(S){const C=this;return{call(v,o,s){return C.requestPromise(S,v,o,s)},listen(v,o){return C.requestEvent(S,v,o)}}}requestPromise(S,C,v,o=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(S),t=(0,L.createCancelablePromise)(r=>s.call(C,v,r)),a=o.onCancellationRequested(()=>t.cancel()),n=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(S,C,v){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const s=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(S).listen(C,v)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),I.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,S,C);const v=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,k.isRemoteConsoleLog)(l)){(0,k.log)(l,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(l,"base64")))});const s=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&s.send(l.buffer.toString("base64")),a=v.event,n={send:t,onMessage:a};this._client=new p.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(d=>(0,E.dispose)(d)),this.activeRequests.clear(),l!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:c})})}return this._client}getCachedChannel(S){let C=this.channels.get(S);return C||(C=this.client.getChannel(S),this.channels.set(S,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=f}),define(te[110],ne([9,10]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[111],ne([9,10]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[112],ne([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(te[113],ne([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(te[114],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[115],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[116],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[117],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[118],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[119],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[120],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[121],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[122],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[123],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[124],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[125],ne([9,10]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[126],ne([9,10]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[127],ne([9,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[128],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[129],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[130],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[131],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[132],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[133],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[134],ne([0,1,56,64,17,8,34,15,5]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(u,f,b){this._args=u,this.paths=f,this.productService=b}get appRoot(){return(0,A.dirname)(R.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=k.env.VSCODE_PORTABLE;return u?m.URI.file((0,A.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,A.resolve)(u):(0,A.normalize)((0,A.join)(R.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,A.resolve)(u):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,A.resolve)(u);const f=k.env.VSCODE_EXTENSIONS;if(f)return f;const b=k.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(f=>/^[^:/?#]+?:\/\//.test(f)?m.URI.parse(f):m.URI.file((0,A.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?m.URI.parse(u):m.URI.file((0,A.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([L.memoize],E.prototype,"appRoot",null),fe([L.memoize],E.prototype,"userHome",null),fe([L.memoize],E.prototype,"userDataPath",null),fe([L.memoize],E.prototype,"appSettingsHome",null),fe([L.memoize],E.prototype,"tmpDir",null),fe([L.memoize],E.prototype,"userRoamingDataHome",null),fe([L.memoize],E.prototype,"settingsResource",null),fe([L.memoize],E.prototype,"userDataSyncHome",null),fe([L.memoize],E.prototype,"userDataSyncLogResource",null),fe([L.memoize],E.prototype,"sync",null),fe([L.memoize],E.prototype,"machineSettingsResource",null),fe([L.memoize],E.prototype,"globalStorageHome",null),fe([L.memoize],E.prototype,"workspaceStorageHome",null),fe([L.memoize],E.prototype,"keybindingsResource",null),fe([L.memoize],E.prototype,"keyboardLayoutResource",null),fe([L.memoize],E.prototype,"argvResource",null),fe([L.memoize],E.prototype,"snippetsHome",null),fe([L.memoize],E.prototype,"isExtensionDevelopment",null),fe([L.memoize],E.prototype,"untitledWorkspacesHome",null),fe([L.memoize],E.prototype,"installSourcePath",null),fe([L.memoize],E.prototype,"builtinExtensionsPath",null),fe([L.memoize],E.prototype,"extensionsPath",null),fe([L.memoize],E.prototype,"extensionDevelopmentLocationURI",null),fe([L.memoize],E.prototype,"extensionDevelopmentKind",null),fe([L.memoize],E.prototype,"extensionTestsLocationURI",null),fe([L.memoize],E.prototype,"debugExtensionHost",null),fe([L.memoize],E.prototype,"serviceMachineIdResource",null),fe([L.memoize],E.prototype,"telemetryLogResource",null),fe([L.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function i(p,u){return h(p["inspect-extensions"],p["inspect-brk-extensions"],5870,u,p.debugId)}e.parseExtensionHostPort=i;function I(p,u){return h(p["inspect-search"],p["inspect-brk-search"],5876,u)}e.parseSearchPort=I;function h(p,u,f,b,S){const v=Number(u||p)||(b?null:f),o=v?Boolean(!!u):!1;return{port:v,break:o,debugId:S}}}),define(te[135],ne([0,1,220,4,112]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,f,b=k){const S={},C=[],v=[];for(let a in f){const n=f[a];n.alias&&(S[a]=n.alias),n.type==="string"||n.type==="string[]"?(C.push(a),n.deprecates&&C.push(n.deprecates)):n.type==="boolean"&&(v.push(a),n.deprecates&&v.push(n.deprecates))}const o=D(u,{string:C,boolean:v,alias:S}),s={},t=o;s._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(let a in f){const n=f[a];n.alias&&delete t[n.alias];let r=t[a];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(a,r)),s[a]=r),delete t[a]}for(let a in t)b.onUnknownOption(a);return s}e.parseArgs=P;function m(u,f){let b="";return f.args&&(Array.isArray(f.args)?b=` <${f.args.join("> <")}>`:b=` <${f.args}>`),f.alias?`-${f.alias} --${u}${b}`:`--${u}${b}`}function E(u,f){let b=0,S=[];for(const s in u){const t=u[s],a=m(s,t);b=Math.max(b,a.length),S.push([a,t.description])}let C=b+2+1;if(f-C<25)return S.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=f-C-1,o=[];for(const s of S){let t=s[0],a=I(s[1],v),n=i(C-t.length-2);o.push("  "+t+n+a[0]);for(let r=1;r<a.length;r++)o.push(i(C)+a[r])}return o}e.formatOptions=E;function i(u){return" ".repeat(u)}function I(u,f){let b=[];for(;u.length;){let S=u.length<f?u.length:u.lastIndexOf(" ",f),C=u.slice(0,S).trim();u=u.slice(S),b.push(C)}return b}function h(u,f,b,S,C=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${b}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${f} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),C&&(L.isWindows?o.push((0,R.localize)(35,null,f)):o.push((0,R.localize)(36,null,f)),o.push(""));const s={};for(const t in S){const a=S[t];if(a.description&&a.cat){let n=s[a.cat];n||(s[a.cat]=n={}),n[t]=a}}for(let t in s){const a=t;let n=s[a];n&&(o.push(A[a]),o.push(...E(n,v)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=h;function p(u,f){return`${u||(0,R.localize)(37,null)}
${f||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function Y(e,D,L,R){function A(P){const m=k(P),E=[m];return e.isAbsolute(m)||E.unshift(R),e.resolve(...E)}function k(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(I,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:A}}if(typeof define=="function")define(te[136],ne([0,137,35,17,15,34]),function(e,D,L,R,A,k){const P=A.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);return Y(D,L,m.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=Y(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[138],ne([0,1,35,134,136]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=A}),define(te[139],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(b){const S=b.match(k);return S?S[1]:null}function i(b){if(b.indexOf("://")===-1){const S=b.match(L);return S?E(S[2]):null}try{const S=D.URI.parse(b);if(S.authority)return E(S.authority)}catch(S){}return null}function I(b,S){const C=new Set;let v;for(;v=P.exec(b);){const s=i(v[1]);s&&C.add(s)}const o=new Set(S);return Array.from(C).map(s=>o.has(s)?s:s.replace(m,"a"))}e.getDomainsOfRemotes=I;function h(b){const S=b.match(A);return S?S[2]:null}function p(b,S,C){return b&&S?(C&&S.endsWith(".git")&&(S=S.substr(0,S.length-4)),S.indexOf("/")===0?`${b}${S}`:`${b}/${S}`):null}function u(b,S){if(b.indexOf("://")===-1){const C=b.match(R);if(C)return p(C[2],C[3],S)}try{const C=D.URI.parse(b);if(C.authority)return p(h(C.authority),C.path,S)}catch(C){}return null}function f(b,S=!1){const C=[];let v;for(;v=P.exec(b);){const o=u(v[1],S);o&&C.push(o)}return C}e.getRemotes=f}),define(te[140],ne([0,1,3,2,26,5,96]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(u,f){return A.URI.revive(f?f.transformIncoming(u):u)}function m(u,f){return f?f.transformOutgoingURI(u):u}function E(u,f){f=f||k.DefaultURITransformer;const b=u.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...u,manifest:void 0},f),manifest:b}}function i(u,f){return f?(0,R.cloneAndChange)(u,b=>b instanceof A.URI?f.transformOutgoingURI(b):void 0):u}class I{constructor(f,b){this.service=f,this.getUriTransformer=b,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,b){const S=this.getUriTransformer(f);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,C=>C.map(v=>({...v,local:v.local?i(v.local,S):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,b,S){const C=this.getUriTransformer(f);switch(b){case"zip":return this.service.zip(E(S[0],C)).then(v=>m(v,C));case"unzip":return this.service.unzip(P(S[0],C));case"install":return this.service.install(P(S[0],C),S[1]);case"getManifest":return this.service.getManifest(P(S[0],C));case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(E(S[0],C),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(E(S[0],C));case"getInstalled":return this.service.getInstalled(S[0]).then(v=>v.map(o=>i(o,C)));case"updateMetadata":return this.service.updateMetadata(E(S[0],C),S[1]).then(v=>i(v,C));case"updateExtensionScope":return this.service.updateExtensionScope(E(S[0],C),S[1]).then(v=>i(v,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=I;class h extends L.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?A.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(S=>({...S,local:S.local?E(S.local,null):S.local,source:this.isUriComponents(S.source)?A.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(b=>A.URI.revive(b)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,b){return Promise.resolve(this.channel.call("install",[f,b])).then(S=>E(S,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}async canInstall(f){return!0}installFromGallery(f,b){return Promise.resolve(this.channel.call("installFromGallery",[f,b])).then(S=>E(S,null))}uninstall(f,b){return Promise.resolve(this.channel.call("uninstall",[f,b]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(b=>b.map(S=>E(S,null)))}updateMetadata(f,b){return Promise.resolve(this.channel.call("updateMetadata",[f,b])).then(S=>E(S,null))}updateExtensionScope(f,b){return Promise.resolve(this.channel.call("updateExtensionScope",[f,b])).then(S=>E(S,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class p{constructor(f){this.service=f}listen(f,b){throw new Error("Invalid listen")}call(f,b,S){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(te[141],ne([0,1,26]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(A,k){const P=m=>{if(typeof m!="string")return;const E=L.exec(m);if(!E)return;const i=k[E[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(A,P)}e.localizeManifest=R}),define(te[142],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,k,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[A,k,P,m])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(A){this.service=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[72],ne([0,1,120]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function A(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=A;function k(h){if(!A(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=h.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function P(h){if(!h)return null;let p=h.majorBase,u=h.majorMustEqual,f=h.minorBase,b=h.minorMustEqual,S=h.patchBase,C=h.patchMustEqual;h.hasCaret&&(p===0||(b=!1),C=!1);let v=0;if(h.preRelease){const o=R.exec(h.preRelease);if(o){const[,s,t,a]=o;v=Date.UTC(Number(s),Number(t)-1,Number(a))}}return{majorBase:p,majorMustEqual:u,minorBase:f,minorMustEqual:b,patchBase:S,patchMustEqual:C,isMinimum:h.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function m(h,p,u){let f;typeof h=="string"?f=P(k(h)):f=h;let b;p instanceof Date?b=p.getTime():typeof p=="string"&&(b=new Date(p).getTime());let S;if(typeof u=="string"?S=P(k(u)):S=u,!f||!S)return!1;let C=f.majorBase,v=f.minorBase,o=f.patchBase,s=S.majorBase,t=S.minorBase,a=S.patchBase,n=S.notBefore,r=S.majorMustEqual,l=S.minorMustEqual,c=S.patchMustEqual;return S.isMinimum?C>s?!0:C<s?!1:v>t?!0:v<t||b&&b<n?!1:o>=a:(C===1&&s===0&&(!r||!l||!c)&&(s=1,t=0,a=0,r=!0,l=!1,c=!1),C<s?!1:C>s?!r:v<t?!1:v>t?!l:o<a?!1:o>a?!c:!(b&&b<n))}e.isValidVersion=m;function E(h,p,u,f){return u.isBuiltin||typeof u.main=="undefined"?!0:I(h,p,u.engines.vscode,f)}e.isValidExtensionVersion=E;function i(h,p,u){return h==="*"||I(p,u,h)}e.isEngineValid=i;function I(h,p,u,f=[]){let b=P(k(u));if(!b)return f.push(D.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(D.localize(1,null,u)),!1}else if(!b.majorMustEqual)return f.push(D.localize(2,null,u)),!1;return m(h,p,b)?!0:(f.push(D.localize(3,null,h,u)),!1)}}),define(te[143],ne([0,1,2,17,36,52]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,E,i,I){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[144],ne([0,1,2,17,36,52]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,E,i,I,h={}){super();this.folders=m,this.onDidFilesChange=E,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new A.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[145],ne([0,1,41,67,17,68]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(m,E,i,I,h){this.watchedFolder=m,this.eventCallback=i,this.logCallback=I,this.verboseLogging=h,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(p=>(0,L.parse)(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Y).fsPath,m);const E=new A.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];for(const h of E.write(i)){const p=h.split("|");if(p.length===2){const u=Number(p[0]),f=p[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(b=>b(f))){this.verboseLogging&&this.log(f);continue}I.push({type:k.changeTypeMap[u],path:f})}else this.log(p[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(m){this.error("process error: "+m.toString())}onExit(m,E){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${E})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(te[146],ne([0,1,8,24,145]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A{constructor(P,m,E,i){this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=A}),define(te[53],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,A=[],k=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(te[147],ne([0,1,53]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(k,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),L.push([k,P])}e.registerSingleton=R;function A(){return L}e.getSingletonServiceDescriptors=A}),define(te[148],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class L{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let k of this._nodes.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const P=this.lookupOrInsertNode(A),m=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),m),m.incoming.set(this._hashFn(A),P)}removeNode(A){const k=this._hashFn(A);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(A){const k=this._hashFn(A);let P=this._nodes.get(k);return P||(P=new D(A),this._nodes.set(k,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[k,P]of this._nodes)A.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,k]of this._nodes){const P=new Set([A]),m=this._findCycle(k,P);if(m)return m}}_findCycle(A,k){for(let[P,m]of A.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const E=this._findCycle(m,k);if(E)return E;k.delete(P)}}}e.Graph=L}),define(te[7],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,m,E,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:E,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:E,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(E,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,E,I,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function A(P){return P}e.refineServiceDecorator=A;function k(P){return function(m,E,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,m,i,!0)}}e.optional=k}),define(te[149],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[150],ne([0,1,4,24,7]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",A.indexOf("Edg/")>=0),k.set("isFirefox",A.indexOf("Firefox")>=0),k.set("isChrome",A.indexOf("Chrome")>=0),k.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return I.INSTANCE}static true(){return h.INSTANCE}static has(y){return p.create(y)}static equals(y,F){return u.create(y,F)}static notEquals(y,F){return S.create(y,F)}static regex(y,F){return a.create(y,F)}static in(y,F){return f.create(y,F)}static not(y){return C.create(y)}static and(...y){return r.create(y,null)}static or(...y){return l.create(y,null,!0)}static greater(y,F){return v.create(y,F)}static less(y,F){return s.create(y,F)}static deserialize(y,F=!1){if(!!y)return this._deserializeOrExpression(y,F)}static _deserializeOrExpression(y,F){let M=y.split("||");return l.create(M.map(q=>this._deserializeAndExpression(q,F)),null,!0)}static _deserializeAndExpression(y,F){let M=y.split("&&");return r.create(M.map(q=>this._deserializeOne(q,F)),null)}static _deserializeOne(y,F){if(y=y.trim(),y.indexOf("!=")>=0){let M=y.split("!=");return S.create(M[0].trim(),this._deserializeValue(M[1],F))}if(y.indexOf("==")>=0){let M=y.split("==");return u.create(M[0].trim(),this._deserializeValue(M[1],F))}if(y.indexOf("=~")>=0){let M=y.split("=~");return a.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(y.indexOf(" in ")>=0){let M=y.split(" in ");return f.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?C.create(y.substr(1).trim()):p.create(y)}static _deserializeValue(y,F){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static _deserializeRegexValue(y,F){if((0,L.isFalsyOrWhitespace)(y)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=y.indexOf("/"),q=y.lastIndexOf("/");if(M===q||M<0){if(F)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let j=y.slice(M+1,q),U=y[q+1]==="i"?"i":"";try{return new RegExp(j,U)}catch(z){if(F)throw new Error(`bad regexp-value '${y}', parse error: ${z}`);return console.warn(`bad regexp-value '${y}', parse error: ${z}`),null}}}e.ContextKeyExpr=E;function i(O,y){return O.cmp(y)}class I{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class h{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class p{constructor(y,F){this.key=y,this.negated=F,this.type=2}static create(y,F=null){const M=k.get(y);return typeof M=="boolean"?M?h.INSTANCE:I.INSTANCE:new p(y,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class u{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=4}static create(y,F,M=null){if(typeof F=="boolean")return F?p.create(y,M):C.create(y,M);const q=k.get(y);return typeof q=="boolean"?F===(q?"true":"false")?h.INSTANCE:I.INSTANCE:new u(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class f{constructor(y,F){this.key=y,this.valueKey=F,this.type=10,this.negated=null}static create(y,F){return new f(y,F)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}evaluate(y){const F=y.getValue(this.valueKey),M=y.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?P.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyInExpr=f;class b{constructor(y){this._actual=y,this.type=11}static create(y){return new b(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new b(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class S{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=5}static create(y,F,M=null){if(typeof F=="boolean")return F?C.create(y,M):p.create(y,M);const q=k.get(y);return typeof q=="boolean"?F===(q?"true":"false")?I.INSTANCE:h.INSTANCE:new S(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class C{constructor(y,F){this.key=y,this.negated=F,this.type=3}static create(y,F=null){const M=k.get(y);return typeof M=="boolean"?M?I.INSTANCE:h.INSTANCE:new C(y,F)}cmp(y){return y.type!==this.type?this.type-y.type:d(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=C;class v{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=12}static create(y,F,M=null){return new v(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class o{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=13}static create(y,F,M=null){return new o(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class s{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=14}static create(y,F,M=null){return new s(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class t{constructor(y,F,M){this.key=y,this.value=F,this.negated=M,this.type=15}static create(y,F,M=null){return new t(y,F,M)}cmp(y){return y.type!==this.type?this.type-y.type:g(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}evaluate(y){return parseFloat(y.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class a{constructor(y,F){this.key=y,this.regexp=F,this.type=7,this.negated=null}static create(y,F){return new a(y,F)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const F=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return F<M?-1:F>M?1:0}equals(y){if(y.type===this.type){const F=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return this.key===y.key&&F===M}return!1}evaluate(y){let F=y.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class n{constructor(y){this._actual=y,this.type=8}static create(y){return new n(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new n(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(y,F){this.expr=y,this.negated=F,this.type=6}static create(y,F){return r._normalizeArr(y,F)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const q=i(this.expr[F],y.expr[F]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(y.expr[F]))return!1;return!0}return!1}evaluate(y){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(y))return!1;return!0}static _normalizeArr(y,F){const M=[];let q=!1;for(const j of y)if(!!j){if(j.type===1){q=!0;continue}if(j.type===0)return I.INSTANCE;if(j.type===6){M.push(...j.expr);continue}M.push(j)}if(M.length===0&&q)return h.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];for(;M.length>1;){const j=M[M.length-1];if(j.type!==9)break;M.pop();const U=M.pop(),z=M.length===0,V=l.create(j.expr.map(x=>r.create([x,U],null)),null,z);V&&(M.push(V),M.sort(i))}return M.length===1?M[0]:new r(M,F)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let F of this.expr)y.push(...F.keys());return y}map(y){return new r(this.expr.map(F=>F.map(y)),null)}negate(){if(!this.negated){const y=[];for(let F of this.expr)y.push(F.negate());this.negated=l.create(y,this,!0)}return this.negated}}class l{constructor(y,F){this.expr=y,this.negated=F,this.type=9}static create(y,F,M){return l._normalizeArr(y,F,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const q=i(this.expr[F],y.expr[F]);if(q!==0)return q}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(y.expr[F]))return!1;return!0}return!1}evaluate(y){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(y))return!0;return!1}static _normalizeArr(y,F,M){let q=[],j=!1;if(y){for(let U=0,z=y.length;U<z;U++){const V=y[U];if(!!V){if(V.type===0){j=!0;continue}if(V.type===1)return h.INSTANCE;if(V.type===9){q=q.concat(V.expr);continue}q.push(V)}}if(q.length===0&&j)return I.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];if(M){for(let U=0;U<q.length;U++)for(let z=U+1;z<q.length;z++)w(q[U],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new l(q,F)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let F of this.expr)y.push(...F.keys());return y}map(y){return new l(this.expr.map(F=>F.map(y)),null)}negate(){if(!this.negated){let y=[];for(let F of this.expr)y.push(F.negate());for(;y.length>1;){const F=y.shift(),M=y.shift(),q=[];for(const U of T(F))for(const z of T(M))q.push(r.create([U,z],null));const j=y.length===0;y.unshift(l.create(q,null,j))}this.negated=y[0]}return this.negated}}class c extends p{constructor(y,F,M){super(y,null);this._defaultValue=F,typeof M=="object"?c._info.push({...M,key:y}):M!==!0&&c._info.push({key:y,description:M,type:F!=null?typeof F:void 0})}static all(){return c._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return u.create(this.key,y)}notEqualsTo(y){return S.create(this.key,y)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(O,y){return O<y?-1:O>y?1:0}function g(O,y,F,M){return O<F?-1:O>F?1:y<M?-1:y>M?1:0}function w(O,y){if(y.type===6&&O.type!==9&&O.type!==6){for(const q of y.expr)if(O.equals(q))return!0}const F=O.negate(),M=T(F).concat(T(y));M.sort(i);for(let q=0;q<M.length;q++){const U=M[q].negate();for(let z=q+1;z<M.length;z++){const V=M[z];if(U.equals(V))return!0}}return!1}e.implies=w;function T(O){return O.type===9?O.expr:[O]}}),define(te[73],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[74],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[12],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ne([0,1,17,4,34,115,7]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var P;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));function m(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=m;function E(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function i(o,s){let t;switch(o){case 1:t=3;break;case 3:t=2;break;case 2:t=1;break}return I(t,s)}e.getTargetPlatformFromOS=i;function I(o,s){switch(o){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":I(L.platform,R.arch);function h(o,s){return s==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=h;function p(o,s,t){if(h(s,t))return!1;if(o==="undefined"||o==="universal")return!0;if(o==="unknown")return!1;if(o===t)return!0;switch(t){case"win32-x64":return o==="win32-ia32";case"win32-arm64":return o==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=p;function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=u;var f;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=5]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(f=e.SortBy||(e.SortBy={}));var b;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var S;(function(o){o.Install="install",o.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var C;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(s,t){super(s);this.code=t,this.name=t}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,A.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(Y,e){return function(D,L){e(D,L,Y)}};define(te[151],ne([0,1,2,27]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=fe([X(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[75],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var A;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[76],ne([0,1,24,7]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,h){if(typeof I=="undefined"||I===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof I=="string"||typeof h=="string"){let p=typeof I=="string"?I:I.value,u=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(p,u)}return I._lower===h._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function E(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,24,76]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:(0,D.compareIgnoreCase)(u.id,f.id)===0}e.areSameExtensions=R;class A{constructor(f,b){this.version=b,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof A?R(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=A;function k(u,f){return`${u}.${f}`}e.getExtensionId=k;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(u,f){return P(k(u,f))}e.getGalleryExtensionId=m;function E(u,f){const b=[],S=C=>{for(const v of b)if(v.some(o=>R(f(o),f(C))))return v;return null};for(const C of u){const v=S(C);v?v.push(C):b.push([C])}return b}e.groupByExtension=E;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(u){const f=new Set;for(const b of u)b.malicious&&f.add(b.id.id);return f}e.getMaliciousExtensionsSet=h;function p(u,f){const b=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const C=S.shift();if(C&&b.every(v=>!R(v.identifier,{id:C}))){const v=u.filter(o=>R(o.identifier,{id:C}));v.length===1&&(b.push(v[0]),S.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=p}),define(te[152],ne([0,1,2,8,19,76]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(m,E){super();this.environmentService=m,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(E.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[13],ne([0,1,40,8,24,16,5,122,7]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var h;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function f(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function b(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=b;var S;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(z,V){super(z);this.code=V}}e.FileSystemProviderError=C;function v(U,z){const V=new C(U.toString(),z);return s(V,z),V}e.createFileSystemProviderError=v;function o(U){return U||v((0,P.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=o;function s(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=s;function t(U){if(!U)return S.Unknown;if(U instanceof C)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return S.Unknown;switch(z[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=t;function a(U){if(U instanceof g)return U.fileOperationResult;switch(t(U)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(z,V,x){this.resource=z,this.operation=V,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=r;var l;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class c{constructor(z,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of z)switch(x.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>V)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>V)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>V)),this.deleted.set(x.resource,x);break}}contains(z,...V){return this.doContains(z,{includeChildren:!1},...V)}affects(z,...V){return this.doContains(z,{includeChildren:!0},...V)}doContains(z,V,...x){if(!z)return!1;const B=x.length>0;return!!((!B||x.includes(1))&&(this.added?.get(z)||V.includeChildren&&this.added?.findSuperstr(z))||(!B||x.includes(0))&&(this.updated?.get(z)||V.includeChildren&&this.updated?.findSuperstr(z))||(!B||x.includes(2))&&(this.deleted?.findSubstr(z)||V.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function d(U,z,V){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),V?(0,R.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=d;class g extends Error{constructor(z,V,x){super(z);this.fileOperationResult=V,this.options=x}}e.FileOperationError=g;class w extends g{constructor(z,V,x){super(z,2,x);this.stat=V}}e.NotModifiedSinceFileOperationError=w;var T;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=y;async function F(U,z){if(!z.canHandleResource(k.URI.from({scheme:U.scheme})))return new Promise(V=>{const x=z.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(x.dispose(),V())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<M.KB?(0,P.localize)(1,null,z.toFixed(0)):z<M.MB?(0,P.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,P.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,P.localize)(4,null,(z/M.GB).toFixed(2)):(0,P.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var q;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function j(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=j}),define(te[153],ne([0,1,154,50,13]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,E)=>{const i=(0,D.createHash)("md5"),I=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(I,{onData:h=>i.update(h.buffer),onError:h=>E(h),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};A=fe([X(0,R.IFileService)],A),e.ChecksumService=A}),define(te[155],ne([0,1,221,113,135,13]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(h,p){const u={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,S)=>{console.warn((0,L.localize)(1,null,b,S))}},f=(0,R.parseArgs)(h,R.OPTIONS,p?u:void 0);return f.goto&&f._.forEach(b=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),f["max-memory"]&&D(parseInt(f["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function P(h){const p=h.findIndex(u=>!/^-/.test(u));if(p>-1)return[...h.slice(0,p),...h.slice(p+1)]}function m(h){let[,...p]=h;process.env.VSCODE_DEV&&(p=P(p)||[]);const u=!I(process.env);return k(p,u)}e.parseMainProcessArgv=m;function E(h){const[,,...p]=h;return k(p,!0)}e.parseCLIProcessArgv=E;function i(h,...p){const u=h.indexOf("--");return u===-1?h.push(...p):h.splice(u,0,...p),h}e.addArg=i;function I(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[156],ne([0,1,41,137,29,37,11,4,30,109,155]),function(Y,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function I(u,f,b){return f["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(b)&&!f["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(b)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=new Promise(async S=>{const C=new R.CancellationTokenSource,v=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),C.dispose(!0),S({})},1e4);try{const o=await p(u,C.token);S(o)}catch(o){(0,k.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),S({})}finally{clearTimeout(v),C.dispose()}})),h)}e.resolveShellEnv=I;let h;async function p(u,f){const b=new Promise(async(S,C)=>{const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const s=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",a);const n=await(0,E.getSystemShell)(P.OS,a);if(u.trace("getUnixShellEnvironment#shell",n),f.isCancellationRequested)return C(k.canceled);const r=L.basename(n);let l,c;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,c=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),l);const d=(0,D.spawn)(n,[...c,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(d.kill(),C(k.canceled))),d.on("error",T=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(T)),S({})});const g=[];d.stdout.on("data",T=>g.push(T));const w=[];d.stderr.on("data",T=>w.push(T)),d.on("close",(T,O)=>{const y=Buffer.concat(g).toString("utf8");u.trace("getUnixShellEnvironment#raw",y);const F=Buffer.concat(w).toString("utf8");if(F.trim()&&u.trace("getUnixShellEnvironment#stderr",F),T||O)return C(new Error(`Failed to get environment (code ${T}, signal ${O})`));const M=t.exec(y),q=M?M[1]:"{}";try{const j=JSON.parse(q);v?j.ELECTRON_RUN_AS_NODE=v:delete j.ELECTRON_RUN_AS_NODE,o?j.ELECTRON_NO_ATTACH_CONSOLE=o:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",j),S(j)}catch(j){u.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(j)),C(j)}})});try{return await b}catch(S){return u.error("getUnixShellEnvironment#error",(0,A.toErrorMessage)(S)),{}}}}),define(te[77],ne([0,1,4,5,13]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function A(m){return m.map(E=>({type:E.type,resource:L.URI.file(E.path)}))}e.toFileChanges=A;function k(m){const E=new P;for(const i of m)E.processEvent(i);return E.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(E){const i=this.mapPathToChange.get(E.path);if(i){const I=i.type,h=E.type;I===1&&h===2?(this.mapPathToChange.delete(E.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&h===1?i.type=0:I===1&&h===0||(i.type=h)}else this.normalized.push(E),this.mapPathToChange.set(E.path,E)}normalize(){const E=[],i=[];return this.normalized.filter(I=>I.type!==2?(E.push(I),!1):!0).sort((I,h)=>I.path.length-h.path.length).filter(I=>i.some(h=>(0,R.isParent)(I.path,h,!D.isLinux))?!1:(i.push(I.path),!0)).concat(E)}}}),define(te[157],ne([0,1,6,2,8,99,19,101,77]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(I,h,p,u){super();this.path=I,this.onDidFilesChange=h,this.onLogMessage=p,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:h}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(h)try{p=await(0,A.realpath)(p)}catch(u){if(this.onError(u),h.dangling)return}I.isDirectory()?this._register((0,P.watchFolder)(p,(u,f)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(f))})},u=>this.onError(u))):this._register((0,P.watchFile)(p,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,m.normalizeFileChanges)(h);if(this.verboseLogging)for(const u of p)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(te[78],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[A,k]of R)this.set(A,k)}set(R,A){const k=this._entries.get(R);return this._entries.set(R,A),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[158],ne([0,1,6,11,53,148,7,78]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class E extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,f=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=f,this._parent=b,this._services.set(k.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...f){let b=h.traceInvocation(u),S=!1;try{return u({get:(v,o)=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(v,b);if(!s&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return s}},...f)}finally{S=!0,b.stop()}}createInstance(u,...f){let b,S;return u instanceof R.SyncDescriptor?(b=h.traceCreation(u.ctor),S=this._createInstance(u.ctor,u.staticArguments.concat(f),b)):(b=h.traceCreation(u),S=this._createInstance(u,f,b)),b.stop(),S}_createInstance(u,f=[],b){let S=k._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),C=[];for(const o of S){let s=this._getOrCreateServiceInstance(o.id,b);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);C.push(s)}let v=S.length>0?S[0].index:f.length;if(f.length!==v){console.warn(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${f.length} static arguments`);let o=v-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,v)}return new u(...[...f,...C])}_setServiceInstance(u,f){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,f);else if(this._parent)this._parent._setServiceInstance(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let f=this._services.get(u);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):f}_getOrCreateServiceInstance(u,f){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,f.branch(u,!0)):(f.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,f,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,f,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,f,b){const S=new A.Graph(o=>o.id.toString());let C=0;const v=[{id:u,desc:f,_trace:b}];for(;v.length;){const o=v.pop();if(S.lookupOrInsertNode(o),C++>1e3)throw new E(S);for(let s of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const a={id:s.id,desc:t,_trace:o._trace.branch(s.id,!0)};S.insertEdge(o,a),v.push(a)}}}for(;;){const o=S.roots();if(o.length===0){if(!S.isEmpty())throw new E(S);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const a=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,a)}S.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,f,b=[],S,C){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(f,b,S,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,f,b,S,C);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(u,f=[],b,S){if(b){const C=new D.IdleValue(()=>this._createInstance(u,f,S));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let s=C.value,t=s[o];return typeof t!="function"||(t=t.bind(s),v[o]=t),t},set(v,o,s){return C.value[o]=s,!0}})}else return this._createInstance(u,f,S)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class h{constructor(u,f){this.type=u,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return m?new h(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(u){return m?new h(0,u.name):h._None}branch(u,f){let b=new h(2,u.toString());return this._dep.push([u,f,b]),b}stop(){let u=Date.now()-this._start;h._totals+=u;let f=!1;function b(C,v){let o=[],s=new Array(C+1).join("	");for(const[t,a,n]of v._dep)if(a&&n){f=!0,o.push(`${s}CREATES -> ${t}`);let r=b(C+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${t}`);return o.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(u>2||f)&&console.log(S.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(te[159],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,A){this.server=R,this.router=A}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,A){this.server.registerChannel(R,A)}}e.MessagePortMainProcessService=D}),define(te[160],ne([0,1,36,53,147,7]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(p,u,f){const b=f.getChannel(p);return P(u)?new u.channelClientCtor(b):D.ProxyChannel.toService(b,u?.proxyOptions)}}function P(h){return!!h?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let m=class extends k{constructor(p,u,f){super(p,u,f)}};m=fe([X(2,e.IMainProcessService)],m);function E(h,p,u){(0,R.registerSingleton)(h,new L.SyncDescriptor(m,[p,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let i=class extends k{constructor(p,u,f){super(p,u,f)}};i=fe([X(2,e.ISharedProcessService)],i);function I(h,p,u){(0,R.registerSingleton)(h,new L.SyncDescriptor(i,[p,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[57],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const A of R.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[161],ne([0,1,2,57]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=fe([X(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[14],ne([0,1,37,3,2,4,7]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class E extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class i extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...a){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...a]))}debug(t,...a){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...a]))}info(t,...a){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...a]))}warn(t,...a){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...a]))}error(t,...a){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...a]))}critical(t,...a){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...a]))}flush(){}format(t){let a="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}a+=(n>0?" ":"")+r}return a}}e.AbstractMessageLogger=i;class I extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...a){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...a):console.log(`[main ${P()}]`,t,...a))}debug(t,...a){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...a):console.log(`[main ${P()}]`,t,...a))}info(t,...a){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...a):console.log(`[main ${P()}]`,t,...a))}warn(t,...a){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...a):console.warn(`[main ${P()}]`,t,...a))}error(t,...a){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...a):console.error(`[main ${P()}]`,t,...a))}critical(t,...a){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...a):console.error(`[main ${P()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class h extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...a){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...a)}critical(t,...a){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends E{constructor(t,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(a)}trace(t,...a){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...a])}debug(t,...a){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...a])}info(t,...a){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...a])}warn(t,...a){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...a])}error(t,...a){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...a])}critical(t,...a){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...a])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class u extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.logServices)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const n of this.logServices)n.trace(t,...a)}debug(t,...a){for(const n of this.logServices)n.debug(t,...a)}info(t,...a){for(const n of this.logServices)n.info(t,...a)}warn(t,...a){for(const n of this.logServices)n.warn(t,...a)}error(t,...a){for(const n of this.logServices)n.error(t,...a)}critical(t,...a){for(const n of this.logServices)n.critical(t,...a)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class f extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...a){this.logger.trace(t,...a)}debug(t,...a){this.logger.debug(t,...a)}info(t,...a){this.logger.info(t,...a)}warn(t,...a){this.logger.warn(t,...a)}error(t,...a){this.logger.error(t,...a)}critical(t,...a){this.logger.critical(t,...a)}flush(){this.logger.flush()}}e.LogService=f;class b extends R.Disposable{constructor(t,a){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,a){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,a?.always?m.Trace:this.logLevel,a),this.loggers.set(t.toString(),n),a?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class S{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogService=S;function C(s){if(s.verbose)return m.Trace;if(typeof s.logLevel=="string"){const t=v(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function v(s){switch(s){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=v;function o(s){switch(s){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(te[162],ne([0,1,6,11,2,8,19,12,14]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(I,h){super();this.environmentService=I,this.logService=h,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,A.basename)(this.environmentService.logsPath),h=(0,A.dirname)(this.environmentService.logsPath),f=(await k.Promises.readdir(h)).filter(S=>/^\d{8}T\d{6}$/.test(S)).sort().filter(S=>S!==I),b=f.slice(0,Math.max(0,f.length-9));b.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${b.join(", ")}'`),await Promise.all(b.map(S=>k.Promises.rm((0,A.join)(h,S)))))}catch(I){(0,L.onUnexpectedError)(I)}}};E=fe([X(0,P.IEnvironmentService),X(1,m.ILogService)],E),e.LogsDataCleaner=E}),define(te[163],ne([0,1,6,11,2,8,19,12,14]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class ut extends R.Disposable{constructor(I,h,p){super();this.backupWorkspacesPath=I,this.environmentService=h,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const I=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(I).emptyWorkspaceInfos.map(f=>f.backupFolder),u=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async f=>{f.length!==ut.NON_EMPTY_WORKSPACE_ID_LENGTH&&p.indexOf(f)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${f}.`),await k.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,f)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=fe([X(1,P.INativeEnvironmentService),X(2,m.ILogService)],E),e.StorageDataCleaner=E}),define(te[164],ne([0,1,6,11,2,4,15,58,5,30,19,12,27,31,13,14]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let S=class extends R.Disposable{constructor(v,o,s,t){super();this.fileService=o,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=m.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const s=this.getName(v),t=(0,k.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const a=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(v,a,o);try{await this.rename(a,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return t}async delete(v){}async rename(v,o,s){try{await i.Promises.rename(v.fsPath,o.fsPath)}catch(t){if(A.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],s=[];for(const n of v.children){const r=this.parse(n.name);r&&s.push([r,n])}const t=(0,p.groupByExtension)(s,([n])=>n),a=[];for(const n of t)n.sort((r,l)=>P.rcompare(r[0].version,l[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),a.push(n[0][1]);a.sort((n,r)=>n.mtime-r.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new p.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(v){const o=b.exec(v);return o&&o[1]&&o[2]?new p.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};S=fe([X(0,I.INativeEnvironmentService),X(1,u.IFileService),X(2,h.IExtensionGalleryService),X(3,f.ILogService)],S),e.ExtensionsDownloader=S}),define(te[165],ne([0,1,41,6,37,3,2,17,8,19,12,14]),function(Y,e,D,L,R,A,k,P,m,E,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends k.Disposable{constructor(u,f){super();this.environmentService=u,this.logService=f,this.processesLimiter=new L.Limiter(5)}async postUninstall(u){const f=this.parseScript(u,"uninstall");return f&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${b}`)))),E.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(u,f){const b=`vscode:${f}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[b]=="string"){const S=u.manifest.scripts[b].split(" ");return S.length<2||S[0]!=="node"||!S[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${b} should be a node script`),null):{script:(0,m.join)(u.location.fsPath,S[1]),args:S.slice(2)||[]}}return null}runLifecycleHook(u,f,b,S,C){return new Promise((v,o)=>{const s=this.start(u,f,b,C);let t;const a=n=>{t&&(clearTimeout(t),t=null),n?o(n):v(void 0)};s.on("error",n=>{a((0,R.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{a(n?`post-${f} process exited with code ${n}`:void 0)}),S&&(t=setTimeout(()=>{t=null,s.kill(),o("timed out")},5e3))})}start(u,f,b,S){const C={silent:!0,execArgv:void 0},v=(0,D.fork)(u,[`--type=extension-post-${f}`,...b],C);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=A.Event.fromNodeEventEmitter(v.stdout,"data"),s=A.Event.fromNodeEventEmitter(v.stderr,"data");o(n=>this.logService.info(S.identifier.id,S.manifest.version,`post-${f}`,n)),s(n=>this.logService.error(S.identifier.id,S.manifest.version,`post-${f}`,n));const t=A.Event.any(A.Event.map(o,n=>({data:`%c${n}`,format:[""]})),A.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(S.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(u){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};h=fe([X(0,i.IEnvironmentService),X(1,I.ILogService)],h),e.ExtensionsLifecycle=h}),define(te[166],ne([0,1,3,2,15,5,12,31,13,14]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(h,p,u,f){super();this.extensionsManagementService=h,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(C=>this.onInstallExtension(C))),this._register(h.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(h.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const b=A.URI.file(u.extensionsPath),S=new R.ExtUri(C=>!p.hasCapability(C,1024));this._register(p.watch(b)),this._register(D.Event.filter(p.onDidChangeFilesRaw,C=>C.changes.some(v=>this.doesChangeAffects(v,b,S)))(()=>this.onDidChange()))}doesChangeAffects(h,p,u){return u.isEqual(u.dirname(h.resource),p)?u.isEqual(h.resource,u.joinPath(p,".obsolete"))?!0:!(h.type!==1&&h.type!==2||u.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const p of h)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(p=>!(0,P.areSameExtensions)(p,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,P.areSameExtensions)(p,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),p=h.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,P.areSameExtensions)(b,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),u=this.installedExtensions.filter(f=>this.installingExtensions.some(b=>(0,P.areSameExtensions)(b,f))?!1:h.every(b=>!(0,P.areSameExtensions)(b.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=h.map(f=>f.identifier),(p.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:u})}}};i=fe([X(1,m.IFileService),X(2,k.INativeEnvironmentService),X(3,E.ILogService)],i),e.ExtensionsWatcher=i}),define(te[167],ne([0,1,154,18,6,2,17,8,19,12,27,31,57,14]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends A.Disposable{constructor(S,C,v){super();this.extensionManagementService=S,this.logService=v,this.cache=this._register(new f(C,v)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const S=await this.cache.getLanguagePacks(),C=["en",...Object.keys(S)];return(0,L.distinct)(C)}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const C=await this.cache.getLanguagePacks();Object.keys(C).some(v=>C[v]&&C[v].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(C);return!(0,L.equals)(Object.keys(S),Object.keys(v))}};u=fe([X(0,i.IExtensionManagementService),X(1,E.INativeEnvironmentService),X(2,p.ILogService)],u),e.LocalizationsService=u;let f=class extends A.Disposable{constructor(S,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(C=>{Object.keys(C).forEach(v=>delete C[v]),this.createLanguagePacksFromExtensions(C,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...C){for(const v of C)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,v);Object.keys(S).forEach(v=>this.updateHash(S[v]))}createLanguagePacksFromExtension(S,C){const v=C.identifier,o=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const s of o)if(C.location.scheme===k.Schemas.file&&(0,h.isValidLocalization)(s)){let t=S[s.languageId];t||(t={hash:"",extensions:[],translations:{}},S[s.languageId]=t);let a=t.extensions.filter(n=>(0,I.areSameExtensions)(n.extensionIdentifier,v))[0];a?a.version=C.manifest.version:t.extensions.push({extensionIdentifier:v,version:C.manifest.version});for(const n of s.translations)t.translations[n.id]=(0,P.join)(C.location.fsPath,n.path)}}updateHash(S){if(S){const C=(0,D.createHash)("md5");for(const v of S.extensions)C.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);S.hash=C.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(o){return{}}}).then(v=>(C=S(v),v)).then(v=>{for(const s of Object.keys(v))v[s]||delete v[s];this.languagePacks=v,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>C,v=>this.logService.error(v))})}};f=fe([X(0,E.INativeEnvironmentService),X(1,p.ILogService)],f)}),define(te[79],ne([0,1,3,5,14]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(h){this.service=h,this.onDidChangeLogLevel=D.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(h,p,u){switch(p){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=A;class k{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){k.setLevel(this.channel,h)}static setLevel(h,p){return h.call("setLevel",p)}}e.LogLevelChannelClient=k;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,p){throw new Error(`Event not found: ${p}`)}async call(h,p,u){switch(p){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${p}`)}createLogger(h,p){this.loggers.set(h.toString(),this.loggerService.createLogger(h,p))}consoleLog(h,p){let u=console.log;switch(h){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...p)}log(h,p){const u=this.loggers.get(h.toString());if(!u)throw new Error("Create the logger before logging");for(const[f,b]of p)switch(f){case R.LogLevel.Trace:u.trace(b);break;case R.LogLevel.Debug:u.debug(b);break;case R.LogLevel.Info:u.info(b);break;case R.LogLevel.Warning:u.warn(b);break;case R.LogLevel.Error:u.error(b);break;case R.LogLevel.Critical:u.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(h,p,u){super(h,p);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(h,p)=>{this.channel.call("consoleLog",[h,p])}})}doCreateLogger(h,p,u){return new E(this.channel,h,p,u)}}e.LoggerChannelClient=m;class E extends R.AbstractMessageLogger{constructor(h,p,u,f){super(f?.always);this.channel=h,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[p,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,p){const u=[[h,p]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(h){this.channel.call("log",[this.file,h])}}class i extends R.LogService{constructor(h,p){super(p);this.parent=h,this._register(h.onDidChangeLogLevel(u=>p.setLevel(u)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=i}),define(te[59],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[44],ne([0,1,17,4,34,15]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const P=(0,A.dirname)(D.FileAccess.asFileUri("",Y));k=Y.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const m=Y.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:m.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[80],ne([0,1,25,11,123,13,44]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(I,h,p,u,f,b){let S;try{await m(I,h,p,u,f,b)}catch(C){S=C}finally{S&&f.errorTransformer&&(S=f.errorTransformer(S)),typeof S!="undefined"&&p.error(S),p.end()}}e.readFileIntoStream=P;async function m(I,h,p,u,f,b){E(b);const S=await I.open(h,{create:!1});try{E(b);let C=0,v=0,o=f&&typeof f.length=="number"?f.length:void 0,s=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof o=="number"?o:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,a=0;do v=await I.read(S,t,s.buffer,a,s.byteLength-a),t+=v,a+=v,C+=v,typeof o=="number"&&(o-=v),a===s.byteLength&&(await p.write(u(s)),s=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof o=="number"?o:f.bufferSize)),a=0);while(v>0&&(typeof o!="number"||o>0)&&E(b)&&i(C,f));if(a>0){let n=a;typeof o=="number"&&(n=Math.min(a,o)),p.write(u(s.slice(0,n)))}}catch(C){throw(0,A.ensureFileSystemProviderError)(C)}finally{await I.close(S)}}function E(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function i(I,h){if(h?.limits){if(typeof h.limits.memory=="number"&&I>h.limits.memory)throw(0,A.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&I>h.limits.size)throw(0,A.createFileSystemProviderError)((0,R.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[168],ne([0,1,18,6,25,29,3,55,2,40,17,169,15,50,121,13,80,14]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class je extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new f.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new f.FileChangesEvent(s,!0)))),this.watchedResources=E.TernarySearchTree.forUris(s=>{const t=this.getProvider(s.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const t=new m.DisposableStore;return t.add(s.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(s)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return P.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new f.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)||(0,f.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw(0,f.toFileSystemProviderErrorCode)(t)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,f.ensureFileSystemProviderError)(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),a=this.isPathCaseSensitive(t),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,l=s?.resolveMetadata,c=await t.stat(o);let d;return this.toFileStat(t,o,c,void 0,!!l,(g,w)=>{if(!d&&(d=E.TernarySearchTree.forUris(()=>!a),d.set(o,!0),n))for(const T of n)d.set(T,!0);return d.get(g.resource)||d.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&r?w===1:!1})}async toFileStat(o,s,t,a,n,r){const{providerExtUri:l}=this.getExtUri(o),c={resource:s,name:l.basename(s),isFile:(t.type&f.FileType.File)!=0,isDirectory:(t.type&f.FileType.Directory)!=0,isSymbolicLink:(t.type&f.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&f.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,f.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&r(c,a)){try{const d=await o.readdir(s),g=await L.Promises.settled(d.map(async([w,T])=>{try{const O=l.joinPath(s,w),y=n?await o.stat(O):{type:T};return await this.toFileStat(o,O,y,d.length,n,r)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(g)}catch(d){this.logService.trace(d),c.children=[]}return c}return c}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(t){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new f.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const a=await this.writeFile(o,s);return this._onDidRunOperation.fire(new f.FileOperationEvent(o,0,a)),a}async writeFile(o,s,t){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,o,t)||await this.mkdirp(a,n.dirname(o));let l;if((0,f.hasReadWriteCapability)(a)&&!(s instanceof R.VSBuffer))if((0,p.isReadableStream)(s)){const c=await(0,p.peekStream)(s,3);c.ended?l=R.VSBuffer.concat(c.buffer):l=c}else l=(0,p.peekReadable)(s,c=>R.VSBuffer.concat(c),3);else l=s;!(0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasReadWriteCapability)(a)&&l instanceof R.VSBuffer?await this.doWriteUnbuffered(a,o,t,l):await this.doWriteBuffered(a,o,t,l instanceof R.VSBuffer?(0,R.bufferToReadable)(l):l)}catch(r){throw new f.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==f.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,f.etag)({mtime:t.mtime,size:n.size}))throw new f.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(o,s){const t=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(t,o,s):this.doReadFile(t,o,s)}async doReadFileAtomic(o,s,t){return new Promise((a,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,t);a(r)}catch(r){n(r)}})})}async doReadFile(o,s,t){const a=await this.doReadFileStream(o,s,{...t,preferUnbuffered:!0});return{...a,value:await(0,R.streamToBuffer)(a.value)}}async readFileStream(o,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,s)}async doReadFileStream(o,s,t){const a=new A.CancellationTokenSource,n=this.validateReadFile(s,t).then(l=>l,l=>{throw a.cancel(),l});let r;try{return typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&await n,!((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasFileReadStreamCapability)(o))||(0,f.hasReadWriteCapability)(o)&&t?.preferUnbuffered?r=this.readFileUnbuffered(o,s,t):(0,f.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,a.token,t):r=this.readFileBuffered(o,s,a.token,t),{...await n,value:r}}catch(l){r&&await(0,p.consumeStream)(r);const c=(0,u.localize)(8,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(l).toString());throw l instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(c,l.stat,t):new f.FileOperationError(c,(0,f.toFileOperationResult)(l),t)}}readFileStreamed(o,s,t,a=Object.create(null)){const n=o.readFileStream(s,a,t);return(0,p.transform)(n,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),a)},r=>R.VSBuffer.concat(r))}readFileBuffered(o,s,t,a=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,s,n,r=>r,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),a)},t),n}readFileUnbuffered(o,s,t){const a=(0,p.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(s,n.byteLength,t),a.end(R.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new f.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==f.ETAG_DISABLED&&s.etag===t.etag)throw new f.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(t?.limits){let a;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(a=9),typeof t.limits.size=="number"&&s>t.limits.size&&(a=7),typeof a=="number")throw new f.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,a){if(o.toString()!==s.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,t,a)}catch(n){return n}return!0}async move(o,s,t){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(a,o,n,s,"move",!!t),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,s,t){const a=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(a,o,n,s,"copy",!!t),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,s,t,a,n,r){if(s.toString()===a.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,s,t,a,n,r);if(l&&!c&&r&&await this.del(a,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(a)),n==="copy"){if(o===t&&(0,f.hasFileFolderCopyCapability)(o))await o.copy(s,a,{overwrite:r});else{const d=await this.resolve(s);d.isDirectory?await this.doCopyFolder(o,d,t,a):await this.doCopyFile(o,s,t,a)}return n}else return o===t?(await o.rename(s,a,{overwrite:r}),n):(await this.doMoveCopy(o,s,t,a,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,a){if((0,f.hasOpenReadWriteCloseCapability)(o)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,s,t,a);if((0,f.hasOpenReadWriteCloseCapability)(o)&&(0,f.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,s,t,a);if((0,f.hasReadWriteCapability)(o)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,s,t,a);if((0,f.hasReadWriteCapability)(o)&&(0,f.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,s,t,a)}async doCopyFolder(o,s,t,a){await t.mkdir(a),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,r):this.doCopyFile(o,n.resource,t,r)}))}async doValidateMoveCopy(o,s,t,a,n,r){let l=!1;if(o===t){const{providerExtUri:d,isPathCaseSensitive:g}=this.getExtUri(o);if(g||(l=d.isEqual(s,a)),l&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(a)));if(!l&&d.isEqualOrParent(a,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(a)))}const c=await this.exists(a);if(c&&!l){if(!r)throw new f.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(a)),4);if(o===t){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(s,a))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(a)))}}return{exists:c,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(s,a.dirname(s));)try{if(((await o.stat(s)).type&f.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,f.toFileSystemProviderErrorCode)(n)!==f.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(a.basename(s)),s=a.dirname(s)}for(let n=t.length-1;n>=0;n--){s=a.joinPath(s,t[n]);try{await o.mkdir(s)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(l){}if(n)this.throwIfFileIsReadonly(o,n);else throw new f.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s),a=!!s?.useTrash,n=!!s?.recursive;await t.delete(o,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new f.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let t,a;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(a||(a=[]),a.push(n));t&&this._onDidFilesChange.fire(new f.FileChangesEvent(t,!s))}if(a){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let a=!1,n=()=>{a=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{a?(0,m.dispose)(r):n=()=>(0,m.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),t}async doWatch(o,s){const t=await this.withProvider(o),a=this.toWatchKey(t,o,s),n=this.activeWatchers.get(a)||{count:0,disposable:t.watch(o,s)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,s,t){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,t,a){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,n,a):await this.doWriteReadableBufferedQueued(o,n,a)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,t){let a=0,n;if((0,p.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,a,0),a+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,l)=>{(0,p.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(o,s,c,c.byteLength,a,0)}catch(d){return l(d)}a+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>l(c),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,t){let a=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(o,s,t,a,n,r){let l=0;for(;l<a;)l+=await o.write(s,n+l,t.buffer,r+l,a-l)}async doWriteUnbuffered(o,s,t,a){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,a))}async doWriteUnbufferedQueued(o,s,t,a){let n;a instanceof R.VSBuffer?n=a:(0,p.isReadableStream)(a)?n=await(0,R.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?n=await(0,R.bufferedStreamToBuffer)(a):n=(0,R.readableToBuffer)(a),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,s,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,a))}async doPipeBufferedQueued(o,s,t,a){let n,r;try{n=await o.open(s,{create:!1}),r=await t.open(a,{create:!0,unlock:!1});const l=R.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,d=0,g=0;do g=await o.read(n,c,l.buffer,d,l.byteLength-d),await this.doWriteBuffer(t,r,l,g,c,d),c+=g,d+=g,d===l.byteLength&&(d=0);while(g>0)}catch(l){throw(0,f.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,a))}async doPipeUnbufferedQueued(o,s,t,a){return t.writeFile(a,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,a))}async doPipeUnbufferedToBufferedQueued(o,s,t,a){const n=await t.open(a,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,s,t,a){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,s,A.CancellationToken.None));await this.doWriteUnbuffered(t,a,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new f.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=fe([X(0,S.ILogService)],C),e.FileService=C}),define(te[170],ne([0,1,18,6,25,3,39,2,8,4,15,50,19,124,13,80,157,143,144,77,146,14]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(n,r){super();this.logService=n,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:l}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async c=>{try{let d;c.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(n,c.name))).type:d=this.toType(c),l.push([c.name,d])}catch(d){this.logService.trace(d)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let l;return r?.dangling?l=u.FileType.Unknown:n.isFile()?l=u.FileType.File:n.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,r&&(l|=u.FileType.SymbolicLink),l}async readFile(n){try{const r=this.toFilePath(n);return await h.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(n,r,l){const c=(0,I.newWriteableStream)(d=>R.VSBuffer.concat(d.map(g=>R.VSBuffer.wrap(g))).buffer);return(0,f.readFileIntoStream)(this,n,c,d=>d.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),c}async writeFile(n,r,l){let c;try{const d=this.toFilePath(n);if(!l.create||!l.overwrite){if(await h.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(n,d)}finally{typeof c=="number"&&await this.close(c)}}async open(n,r){try{const l=this.toFilePath(n);if((0,u.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:g}=await h.SymlinkSupport.stat(l);g.mode&128||await h.Promises.chmod(l,g.mode|128)}catch(g){this.logService.trace(g)}let c;if((0,u.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await h.Promises.truncate(l,0),c="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}c||(c="w")}else c="r";const d=await h.Promises.open(l,c);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(d,n),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await h.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}}async read(n,r,l,c,d){const g=this.normalizePos(n,r);let w=null;try{const T=await h.Promises.read(n,l,c,d,g);return typeof T=="number"?w=T:w=T.bytesRead,w}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,g,w)}}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,l){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,c+l):this.mapHandleToPos.delete(n)))}async write(n,r,l,c,d){return(0,L.retry)(()=>this.doWrite(n,r,l,c,d),100,3)}async doWrite(n,r,l,c,d){const g=this.normalizePos(n,r);let w=null;try{const T=await h.Promises.write(n,l,c,d,g);return typeof T=="number"?w=T:w=T.bytesWritten,w}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,g,w)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const l=this.toFilePath(n);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,r){r.recursive?await h.Promises.rm(n,h.RimRafMode.MOVE):await h.Promises.unlink(n)}async rename(n,r,l){const c=this.toFilePath(n),d=this.toFilePath(r);if(c!==d)try{await this.validateTargetDeleted(n,r,"move",l.overwrite),await h.Promises.move(c,d)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(n,r,l){const c=this.toFilePath(n),d=this.toFilePath(r);if(c!==d)try{await this.validateTargetDeleted(n,r,"copy",l.overwrite),await h.Promises.copy(c,d,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(n,r,l,c){const d=this.toFilePath(n),g=this.toFilePath(r);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.isEqual)(d,g,!0)),w&&l==="copy")throw(0,u.createFileSystemProviderError)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(g)){if(!c)throw(0,u.createFileSystemProviderError)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(n,r){return r.recursive?this.watchRecursive(n,r.excludes):this.watchNonRecursive(n)}watchRecursive(n,r){const l={path:this.toFilePath(n),excludes:r},c=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r;this.options?.watcher?.usePolling?(n=C.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?E.isWindows?n=o.FileWatcher:n=C.FileWatcher:n=S.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,v.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===s.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(n){const r=new b.FileWatcher(this.toFilePath(n),c=>this._onDidChangeFile.fire((0,v.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===s.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,P.combinedDisposable)(r,l)}toFilePath(n){return(0,m.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof u.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=u.FileSystemProviderErrorCode.NoPermissions;break;default:r=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let l=this.toFileSystemProviderError(r);if(n&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(l=(0,u.createFileSystemProviderError)(r,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(te[28],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[171],ne([0,1,6,11,2,8,19,14,28]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(I,h,p){super();this.productService=h,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),p=(0,A.dirname)(I),u=(0,A.basename)(I),f=await k.Promises.readdir(p);await Promise.all(f.map(async b=>{if(b===u)return;const S=(0,A.join)(p,b),C=await k.Promises.stat(S);if(C.isDirectory()&&h-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${b}.`),k.Promises.rm(S)}))}catch(h){(0,L.onUnexpectedError)(h)}}};E=fe([X(1,m.IProductService),X(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(te[172],ne([0,1,6,11,2,8,19,12,14,28]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(h,p,u){super();this.environmentService=h,this.logService=p,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),p=JSON.parse(await k.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(p)){const v=p[C];h[`${v.hash}.${C}`]=!0}const u=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(u))return;const b=await k.Promises.readdir(u);for(const C of b){if(h[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await k.Promises.rm((0,A.join)(u,C))}const S=Date.now();for(const C of Object.keys(h)){const v=(0,A.join)(u,C),o=await k.Promises.readdir(v);for(const s of o){if(s==="tcf.json")continue;const t=(0,A.join)(v,s),a=await k.Promises.stat(t);a.isDirectory()&&S-a.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(C,s)}`),await k.Promises.rm(t))}}}catch(h){(0,L.onUnexpectedError)(h)}}};i=fe([X(0,P.INativeEnvironmentService),X(1,m.ILogService),X(2,E.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[32],ne([0,1,90,16]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(L.isString(k)),D.ok(L.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(te[81],ne([0,1,3,32]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,E){this.schemasById[R(m)]=E,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new A;L.Registry.add(e.Extensions.JSONContribution,k)}),define(te[38],ne([0,1,3,16,111,81,32]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=k.Registry.as(A.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,v=!0){this.registerConfigurations([C],v)}registerConfigurations(C,v=!0){const o=[];C.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,v,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(C){const v=[],o=s=>{if(s.properties)for(const t in s.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t]);s.allOf&&s.allOf.forEach(t=>o(t))};for(const s of C){o(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(C){const v=[],o=[];for(const s of C)for(const t in s)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...s[t]};const a={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(h(t)),this.configurationProperties[t]=a,this.defaultLanguageConfigurationOverridesNode.properties[t]=a}else{this.defaultValues[t]=s[t];const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(C){const v=[];for(const o of C)for(const s in o)if(v.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const v of C)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,v=!0,o,s=3){s=L.isUndefinedOrNull(C.scope)?s:C.scope;let t=[],a=C.properties;if(a)for(let r in a){if(v&&f(r)){delete a[r];continue}const l=a[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(r):l.restricted),a[r].hasOwnProperty("included")&&!a[r].included){this.excludedConfigurationProperties[r]=a[r],delete a[r];continue}else this.configurationProperties[r]=a[r];!a[r].deprecationMessage&&a[r].markdownDeprecationMessage&&(a[r].deprecationMessage=a[r].markdownDeprecationMessage),t.push(r)}let n=C.allOf;if(n)for(let r of n)t.push(...this.validateAndRegisterProperties(r,v,o,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const v=o=>{let s=o.properties;if(s)for(const a in s)this.updateSchema(a,s[a]);let t=o.allOf;t&&t.forEach(v)};v(C)}updateSchema(C,v){switch(e.allSettings.properties[C]=v,v.scope){case 1:e.applicationSettings.properties[C]=v;break;case 2:e.machineSettings.properties[C]=v;break;case 6:e.machineOverridableSettings.properties[C]=v;break;case 3:e.windowSettings.properties[C]=v;break;case 4:e.resourceSettings.properties[C]=v;break;case 5:e.resourceSettings.properties[C]=v,this.resourceLanguageSettingsSchema.properties[C]=v;break}}removeFromSchema(C,v){switch(delete e.allSettings.properties[C],v.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const v=`[${C}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,o),e.allSettings.properties[v]=o,e.applicationSettings.properties[v]=o,e.machineSettings.properties[v]=o,e.machineOverridableSettings.properties[v]=o,e.windowSettings.properties[v]=o,e.resourceSettings.properties[v]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,v){let o=this.defaultValues[C];L.isUndefined(o)&&(o=v.default),L.isUndefined(o)&&(o=p(v.type)),v.default=o}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function h(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=h;function p(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const u=new i;k.Registry.add(e.Extensions.Configuration,u);function f(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?R.localize(5,null,S):u.getConfigurationProperties()[S]!==void 0?R.localize(6,null,S):null:R.localize(4,null)}e.validateProperty=f;function b(){const S=[],C=u.getConfigurationProperties();for(const v of Object.keys(C))S.push([v,C[v].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=b}),define(te[20],ne([0,1,26,16,5,38,7,32]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function m(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationOverrides=m;var E;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(a,n){const r=n?a?n.keys.filter(O=>a.keys.indexOf(O)===-1):[...n.keys]:[],l=a?n?a.keys.filter(O=>n.keys.indexOf(O)===-1):[...a.keys]:[],c=[];if(n&&a){for(const O of a.keys)if(n.keys.indexOf(O)!==-1){const y=S(a.contents,O),F=S(n.contents,O);D.equals(y,F)||c.push(O)}}const d=[],g=O=>{const y={};for(const F of O)for(const M of F.identifiers)y[s(M)]=F;return y},w=n?g(n.overrides):{},T=a?g(a.overrides):{};if(Object.keys(w).length)for(const O of r){const y=w[O];y&&d.push([(0,A.overrideIdentifierFromKey)(O),y.keys])}if(Object.keys(T).length)for(const O of l){const y=T[O];y&&d.push([(0,A.overrideIdentifierFromKey)(O),y.keys])}if(Object.keys(w).length&&Object.keys(T).length)for(const O of c){const y=T[O],F=w[O];if(y&&F){const M=I({contents:y.contents,keys:y.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,A.overrideIdentifierFromKey)(O),[...M.added,...M.removed,...M.updated]])}}return{added:r,removed:l,updated:c,overrides:d}}e.compare=I;function h(a,n){const r=[];for(const l of Object.keys(a))if(A.OVERRIDE_PROPERTY_PATTERN.test(l)){const c={};for(const d in a[l])c[d]=a[l][d];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(c),contents:p(c,n)})}return r}e.toOverrides=h;function p(a,n){const r=Object.create(null);for(let l in a)u(r,l,a[l],n);return r}e.toValuesTree=p;function u(a,n,r,l){const c=n.split("."),d=c.pop();let g=a;for(let w=0;w<c.length;w++){let T=c[w],O=g[T];switch(typeof O){case"undefined":O=g[T]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${c.slice(0,w+1).join(".")} is ${JSON.stringify(O)}`);return}g=O}if(typeof g=="object"&&g!==null)try{g[d]=r}catch(w){l(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(g)}`)}else l(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=u;function f(a,n){const r=n.split(".");b(a,r)}e.removeFromValueTree=f;function b(a,n){const r=n.shift();if(n.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const l=a[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,n),Object.keys(l).length===0&&delete a[r])}}function S(a,n,r){function l(g,w){let T=g;for(const O of w){if(typeof T!="object"||T===null)return;T=T[O]}return T}const c=n.split("."),d=l(a,c);return typeof d=="undefined"?r:d}e.getConfigurationValue=S;function C(a,n,r){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(n[l])?C(a[l],n[l],r):r&&(a[l]=n[l]):a[l]=n[l])})}e.merge=C;function v(){const a=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=v;function o(){const a=Object.create(null),n=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in n){let l=n[r].default;u(a,r,l,c=>console.error(`Conflict in default settings: ${c}`))}return a}e.getDefaultValues=o;function s(a){return`[${a}]`}e.keyFromOverrideIdentifier=s;function t(a,n,r){const l=a.inspect(n),c=a.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:l.defaultValue}e.getMigratedSettingValue=t}),define(te[173],ne([0,1,18,3,33,2,40,26,16,5,20,38,32]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},a=[],n=[]){this._contents=t,this._keys=a,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,a){const n=this.getContentsForOverrideIdentifer(a);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.keys;return[]}override(t){const a=this.getContentsForOverrideIdentifer(t);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let n={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[r],c=a[r];c&&(typeof l=="object"&&typeof c=="object"?(l=P.deepClone(l),this.mergeContents(l,c)):l=c),n[r]=l}return new p(n,this.keys,this.overrides)}merge(...t){const a=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(a,l.contents);for(const c of l.overrides){const[d]=n.filter(g=>D.equals(g.identifiers,c.identifiers));d?this.mergeContents(d.contents,c.contents):n.push(P.deepClone(c))}for(const c of l.keys)r.indexOf(c)===-1&&r.push(c)}return new p(a,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,a){for(const n of Object.keys(a)){if(n in t&&m.isObject(t[n])&&m.isObject(a[n])){this.mergeContents(t[n],a[n]);continue}t[n]=P.deepClone(a[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,a){this.addKey(t),(0,i.addToValueTree)(this.contents,t,a,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let a=this.keys.length;for(let n=0;n<a;n++)t.indexOf(this.keys[n])===0&&(a=n);this.keys.splice(a,1,t)}removeKey(t){let a=this.keys.indexOf(t);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class u extends p{constructor(){const t=(0,i.getDefaultValues)(),a=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,a,n)}}e.DefaultConfigurationModel=u;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,a){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,a)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,a){this._raw=t;const{contents:n,keys:r,overrides:l,restricted:c}=this.doParseRaw(t,a);this._configurationModel=new p(n,r,l),this._restrictedConfigurations=c||[]}doParseContent(t){let a={},n=null,r=[],l=[],c=[];function d(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}let g={onObjectBegin:()=>{let w={};d(w),l.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let w=[];d(w),l.push(r),r=w,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:d,onError:(w,T,O)=>{c.push({error:w,offset:T,length:O})}};if(t)try{R.visit(t,g),a=r[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return a}doParseRaw(t,a){const n=h.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,a);t=r.raw;const l=(0,i.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),c=Object.keys(t),d=(0,i.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:l,keys:c,overrides:d,restricted:r.restricted}}filter(t,a,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const l={},c=[];for(let d in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(d)&&n){const g=this.filter(t[d],a,!1,r);l[d]=g.raw,c.push(...g.restricted)}else{const g=a[d],w=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&c.push(d),(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&(r.skipRestricted&&g?.restricted||(l[d]=t[d]))}return{raw:l,restricted:c}}}e.ConfigurationModelParser=f;class b extends A.Disposable{constructor(t,a,n,r){super();this.userSettingsResource=t,this.scopes=a,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class S{constructor(t,a,n=new p,r=new p,l=new k.ResourceMap,c=new p,d=new k.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=a,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=c,this._memoryConfigurationByResource=d,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,a,n){return this.getConsolidateConfigurationModel(a,n).getValue(t)}updateValue(t,a,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new p,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,a===void 0?r.removeValue(t):r.setValue(t,a),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,a,n){const r=this.getConsolidateConfigurationModel(a,n),l=this.getFolderConfigurationModelForResource(a.resource,n),c=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,d=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,y=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,F=a.overrideIdentifier?c.override(a.overrideIdentifier).getValue(t):c.getValue(t),M=r.getValue(t),q=D.distinct(D.flatten(r.overrides.map(j=>j.identifiers))).filter(j=>r.getOverrideValue(t,j)!==void 0);return{defaultValue:d,userValue:g,userLocalValue:w,userRemoteValue:T,workspaceValue:O,workspaceFolderValue:y,memoryValue:F,value:M,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:l?.freeze().getValue(t),override:a.overrideIdentifier?l?.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:c.getValue(t),override:a.overrideIdentifier?c.getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const a=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,a){this._folderConfigurations.set(t,a),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,a){const n=a.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,I.overrideIdentifierFromKey)(r),c=this._defaultConfiguration.getKeysForOverrideIdentifier(l),d=t.getKeysForOverrideIdentifier(l),g=[...d.filter(w=>c.indexOf(w)===-1),...c.filter(w=>d.indexOf(w)===-1),...c.filter(w=>!P.equals(this._defaultConfiguration.override(l).getValue(w),t.override(l).getValue(w)))];return[l,g]});return this.updateDefaultConfiguration(t),{keys:a,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:a,updated:n,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,t),c=[...a,...n,...r];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:a,updated:n,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,t);let c=[...a,...n,...r];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:a,updated:n,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,t);let c=[...a,...n,...r];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:l}}compareAndUpdateFolderConfiguration(t,a){const n=this.folderConfigurations.get(t),{added:r,updated:l,removed:c,overrides:d}=(0,i.compare)(n,a);let g=[...r,...l,...c];return(g.length||!n)&&this.updateFolderConfiguration(t,a),{keys:g,overrides:d}}compareAndDeleteFolderConfiguration(t){const a=this.folderConfigurations.get(t);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:c}=(0,i.compare)(a,void 0);return{keys:[...n,...r,...l],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,a){let n=this.getConsolidatedConfigurationModelForResource(t,a);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},a){let n=this.getWorkspaceConsolidatedConfiguration();if(a&&t){const r=a.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const l=this._memoryConfigurationByResource.get(t);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let a=this._foldersConsolidatedConfigurations.get(t);if(!a){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(a=n.merge(r),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(t,a)):a=n}return a}getFolderConfigurationModelForResource(t,a){if(a&&t){const n=a.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,a)=>{const{contents:n,overrides:r,keys:l}=this._folderConfigurations.get(a);return t.push([a,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>t.add(a)),this.userConfiguration.freeze().keys.forEach(a=>t.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>t.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>a.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>a.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r))),[...a.values()]}static parse(t){const a=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((c,d)=>(c.set(E.URI.revive(d[0]),this.parseConfigurationModel(d[1])),c),new k.ResourceMap);return new S(a,n,new p,r,l,new p,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=S;function C(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,a=new Map;for(const r of s)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,c])=>{const d=(0,k.getOrSet)(a,l,new Set);c.forEach(g=>d.add(g))});const n=[];return a.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=C;class v{constructor(t,a,n,r){this.change=t,this.previous=a,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(d=>l.add(d)),t.overrides.forEach(([,d])=>d.forEach(g=>l.add(g))),this.affectedKeys=[...l.values()];const c=new p;this.affectedKeys.forEach(d=>c.setValue(d,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(a){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,a,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,a,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,a){let n=(0,i.toValuesTree)({[a]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=v;class o extends v{constructor(t,a,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,a);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(te[174],ne([0,1,6,3,2,15,20,173,38,32]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(h,p){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,p){const u=typeof h=="string"?h:void 0,f=(0,k.isConfigurationOverrides)(h)?h:(0,k.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(u,f,void 0)}updateValue(h,p,u,f){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const p=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(u,p,1)}onDidDefaultConfigurationChange(h){const p=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,h);this.trigger(u,p,6)}trigger(h,p,u){const f=new P.ConfigurationChangeEvent(h,{data:p},this.configuration);f.source=u,f.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[175],ne([0,1,105,20,14]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};A=fe([X(0,L.IConfigurationService),X(1,R.ILogService)],A),e.RequestService=A}),define(te[42],ne([0,1,25,125,38,7,32]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function m(u){return u.res.statusCode===204}async function E(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return m(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=E;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const b=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(b)}catch(S){throw S.message+=`:
`+b,S}}e.asJson=i;function I(u){p(u)}e.updateProxyConfigurationsScope=I;let h;function p(u){const f=k.Registry.as(R.Extensions.Configuration);h&&f.deregisterConfigurations([h]),h={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},f.registerConfiguration(h)}p(2)}),define(te[176],ne([0,1,29,17,13,42]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(m,E){this.requestService=m,this.fileService=E}async download(m,E,i=D.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,E);return}const I={type:"GET",url:m.toString()},h=await this.requestService.request(I,i);if(h.res.statusCode===200)await this.fileService.writeFile(E,h.stream);else{const p=await(0,A.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${p}`)}}};k=fe([X(0,A.IRequestService),X(1,R.IFileService)],k),e.DownloadService=k}),define(te[177],ne([0,1,18,29,63,2,15,139,13,14,28,42]),function(Y,e,D,L,R,A,k,P,m,E,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends A.Disposable{constructor(u,f,b,S){super();this.fileService=u,this.productService=f,this.requestService=b,this.logService=S,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const f=[];for(const[b,S]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,k.joinPath)(u,b)),v=new Map;(0,R.forEach)(S.recommendations,({key:s,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const a of t.remotes)v.set(a,{extensionId:s,extensionName:t.name,configName:S.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else f.push({extensionId:s,extensionName:t.name,configName:S.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(C.value.toString(),[...v.keys()]);for(const s of o){const t=v.get(s);t&&f.push(t)}}catch(C){}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(u.res.statusCode!==200)return[];const f=await(0,I.asJson)(u);return f?f.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};h=fe([X(0,m.IFileService),X(1,i.IProductService),X(2,I.IRequestService),X(3,E.ILogService)],h),e.ExtensionTipsService=h}),define(te[45],ne([0,1,25,30]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(A,k,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await k.readFile(A.serviceMachineIdResource)).value.toString();m=(0,L.isUUID)(i)?i:null}catch(E){m=null}if(!m){m=(0,L.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(E){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(te[21],ne([0,1,6,3,2,16,70,7]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var E;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class h extends R.Disposable{constructor(b={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,S){S===m?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:S,target:this.getKeyTargets(b)[S]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,S,C){return this.getStorage(S)?.get(b,C)}getBoolean(b,S,C){return this.getStorage(S)?.getBoolean(b,C)}getNumber(b,S,C){return this.getStorage(S)?.getNumber(b,C)}store(b,S,C,v){if((0,A.isUndefinedOrNull)(S)){this.remove(b,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,C,v),this.getStorage(C)?.set(b,S)})}remove(b,S){this.withPausedEmitters(()=>{this.updateKeyTarget(b,S,void 0),this.getStorage(S)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,S){const C=[],v=this.getKeyTargets(b);for(const o of Object.keys(v))v[o]===S&&C.push(o);return C}updateKeyTarget(b,S,C){const v=this.getKeyTargets(S);typeof C=="number"?v[b]!==C&&(v[b]=C,this.getStorage(S)?.set(m,JSON.stringify(v))):typeof v[b]=="number"&&(delete v[b],this.getStorage(S)?.set(m,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const S=this.get(m,b);if(S)try{return JSON.parse(S)}catch(C){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=E.NONE){this._onWillSaveState.fire({reason:b}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return u(b,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends h{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=p;async function u(f,b,S,C){const v=l=>{try{return JSON.parse(l)}catch(c){return l}},o=new Map,s=new Map;f.forEach((l,c)=>{o.set(c,l),s.set(c,v(l))});const t=new Map,a=new Map;b.forEach((l,c)=>{t.set(c,l),a.set(c,v(l))}),console.group(`Storage: Global (path: ${S})`);let n=[];o.forEach((l,c)=>{n.push({key:c,value:l})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${C})`);let r=[];t.forEach((l,c)=>{r.push({key:c,value:l})}),console.table(r),console.groupEnd(),console.log(a)}e.logStorage=u}),define(te[178],ne([0,1,3,2,16,27,31,21]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(I)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(I,h){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:h}),!0):!1}async disableExtension(I,h){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let h=this.getDisabledExtensions();return h.every(p=>!(0,k.areSameExtensions)(p,I))?(h.push(I),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(I){let h=this.getDisabledExtensions();for(let p=0;p<h.length;p++){const u=h[p];if((0,k.areSameExtensions)(u,I))return h.splice(p,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(I){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,h){this.storageManger.set(I,h,0)}};m=fe([X(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class E extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(I,h){let p;return h===0?((0,R.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,h)),p=this.storage[I]):p=this._get(I,h),JSON.parse(p)}set(I,h,p){let u=JSON.stringify(h.map(({id:b,uuid:S})=>({id:b,uuid:S})));this._get(I,p)!==u&&(p===0&&(h.length?this.storage[I]=u:delete this.storage[I]),this._set(I,h.length?u:void 0,p))}onDidStorageChange(I){if(I.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const p=this.get(I.key,I.scope);delete this.storage[I.key];const u=this.get(I.key,I.scope),f=p.filter(S=>!u.some(C=>(0,k.areSameExtensions)(S,C))),b=u.filter(S=>!p.some(C=>(0,k.areSameExtensions)(C,S)));(f.length||b.length)&&this._onDidChange.fire([...f,...b])}}_get(I,h){return this.storageService.get(I,h,"[]")}_set(I,h,p){h?this.storageService.store(I,h,p,1):this.storageService.remove(I,p)}}e.StorageManager=E}),define(te[179],ne([0,1,3,2]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i}async getItems(){const E={workspace:this.workspace},i=await this.channel.call("getItems",E);return new Map(i)}updateItems(E){const i={workspace:this.workspace};return E.insert&&(i.insert=Array.from(E.insert.entries())),E.delete&&(i.delete=Array.from(E.delete.values())),this.channel.call("updateItems",i)}}class A extends R{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(E,i){super(E,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class P extends L.Disposable{constructor(E,i){super();this.channel=E,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[180],ne([0,1,6,2,169,15,70,21,179]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends P.AbstractStorageService{constructor(I,h,p){super();this.mainProcessService=h,this.environmentService=p,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new k.Storage(I.globalStorage);return this._register(h.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),h}createWorkspaceStorage(I){const h=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(h.workspaceStorage){const p=new k.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=p.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=I?.id,p}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,A.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const h=this.workspaceStorage,p=h?.items??new Map;h&&(await h.close(),h.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[u,f]of p)this.workspaceStorage.set(u,f)}}e.NativeStorageService=E}),define(te[181],ne([0,1,4,34,5,30]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,i,I,h,p,u,f,b,S,C){const v=Object.create(null);v["common.machineId"]=f,v.sessionID=(0,A.generateUuid)()+Date.now(),v.commitHash=p,v.version=u,v["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=h,v["common.product"]=C||"desktop";const o=m(b||[]);o&&(v["common.msftInternal"]=o);let s=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const a=k(I);a&&(v["common.platformDetail"]=a);try{const n=await E.readFile(R.URI.file(S));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}e.resolveCommonProperties=P;function m(E){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return E.some(h=>I===h)}e.verifyMicrosoftInternalDomain=m}),define(te[22],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(te[182],ne([0,1,35,55,33,17,8,4,5,98,19,100,73,13,28,22]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(s,t){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,l=2e4;function c(w,T,O,y){const F=T.substring(w.length+1);return new Promise(async M=>{let q;try{q=await i.Promises.readdir(T,{withFileTypes:!0})}catch(z){M();return}if(y.count>=l){y.count+=q.length,y.maxReached=!0,M();return}let j=q.length;if(j===0){M();return}let U=q;y.count+q.length>l&&(y.maxReached=!0,j=l-y.count,U=q.slice(0,j)),y.count+=q.length;for(const z of U)if(z.isDirectory()){if(O.includes(z.name)||await c(w,(0,k.join)(T,z.name),O,y),--j==0){M();return}}else{const V=z.name.lastIndexOf(".");if(V>=0){const x=z.name.substring(V+1);x&&n.set(x,(n.get(x)??0)+1)}for(const x of a)x.relativePathPattern?.test(F)!==!1&&x.filePattern.test(z.name)&&r.set(x.tag,(r.get(x.tag)??0)+1);if(--j==0){M();return}}})}const d={count:0,maxReached:!1};await c(s,s,t,d);const g=await v(s);return{configFiles:S(r),fileTypes:S(n),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=b;function S(s){return[...L.Iterable.map(s.entries(),([t,a])=>({name:t,count:a}))].sort((t,a)=>a.count-t.count)}function C(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=C;async function v(s){try{const t=new Map,a=(0,k.join)(s,".vscode","launch.json"),n=await i.Promises.readFile(a),r=[],l=(0,R.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${a}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const c of l.configurations){const d=c.type;d&&(t.has(d)?t.set(d,t.get(d)+1):t.set(d,1))}return S(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let o=class{constructor(t,a){this.telemetryService=t,this.productService=a}formatMachineInfo(t){const a=[];return a.push(`OS Version:       ${t.os}`),a.push(`CPUs:             ${t.cpus}`),a.push(`Memory (System):  ${t.memory}`),a.push(`VM:               ${t.vmHint}`),a.join(`
`)}formatEnvironment(t){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&a.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),a.push(`Memory (System):  ${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||a.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),a.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${t.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(t,a){return Promise.all([(0,I.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,l]=n,c=this.formatProcessList(t,r);return a.forEach(d=>{if((0,h.isRemoteDiagnosticError)(d))c+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(c+=`

Remote: ${d.hostName}`,d.processes&&(c+=`
${this.formatProcessList(t,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const g of Object.keys(d.workspaceMetadata)){const w=d.workspaceMetadata[g];let T=`${w.fileCount} files`;w.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${g}): ${T}`,l+=this.formatWorkspaceStats(w)}}}),{processInfo:c,workspaceInfo:l}})}async getSystemInfo(t,a){const{memory:n,vmHint:r,os:l,cpus:c}=C(),d={os:l,memory:n,cpus:c,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:a};return P.isWindows||(d.load=`${D.loadavg().map(g=>Math.round(g)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(t,a){const n=[];return(0,I.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),a.forEach(l=>{if((0,h.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.formatMachineInfo(l.machineInfo)),l.processes&&n.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const c of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[c];let g=`${d.fileCount} files`;d.maxFilesReached&&(g=`more than ${g}`),n.push(`Folder (${c}): ${g}`),n.push(this.formatWorkspaceStats(d))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const a=[],n=60;let r=0;const l=(w,T)=>{const O=` ${w}(${T})`;r+O.length>n?(a.push(c),c="|                 ",r=c.length):r+=O.length,c+=O};let c="|      File types:";const d=10;let g=t.fileTypes.length>d?d:t.fileTypes.length;for(let w=0;w<g;w++){const T=t.fileTypes[w];l(T.name,T.count)}if(a.push(c),t.configFiles.length>=0&&(c="|      Conf files:",r=0,t.configFiles.forEach(w=>{l(w.name,w.count)}),a.push(c)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{w+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),a.push(w)}return a.join(`
`)}expandGPUFeatures(t){const a=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(a-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const a=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(a.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const c=m.URI.revive(l);if(c.scheme===A.Schemas.file){const d=c.fsPath;n.push(b(d,["node_modules",".git"]).then(g=>{let w=`${g.fileCount} files`;g.maxFilesReached&&(w=`more than ${w}`),a.push(`|    Folder (${(0,k.basename)(d)}): ${w}`),a.push(this.formatWorkspaceStats(g))}).catch(g=>{a.push(`|      Error: Unable to collect workspace stats for folder ${d} (${g.toString()})`)}))}else a.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>a.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,a){const n=new Map;t.windows.forEach(l=>n.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(t.mainPID,n,r,a,0),r.join(`
`)}formatProcessItem(t,a,n,r,l){const c=l===0;let d;c?d=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(d=`${d} (${a.get(r.pid)})`));const g=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(g/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(r.children)&&r.children.forEach(w=>this.formatProcessItem(t,a,n,w,l+1))}async reportWorkspaceStats(t){for(const{uri:a}of t.folders){const n=m.URI.revive(a);if(n.scheme!==A.Schemas.file)continue;const r=n.fsPath;try{const l=await b(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),l.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),l.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};o=fe([X(0,f.ITelemetryService),X(1,u.IProductService)],o),e.DiagnosticsService=o}),define(te[183],ne([0,1,18,6,29,11,3,2,4,5,114,27,31,14,44,22]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let b=class extends P.Disposable{constructor(s,t,a){super();this.galleryService=s,this.telemetryService=t,this.logService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s,!t.installGivenVersion)}catch(n){throw this.logService.error((0,A.getErrorMessage)(n)),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(!await this.canInstall(s)){const n=new I.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",s.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,n),n}const a=await this.galleryService.getManifest(s,R.CancellationToken.None);if(a===null){const n=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(a.version!==s.version){const n=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(a,s,t)}async uninstall(s,t={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,t)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1,null));const t=await this.findGalleryExtension(s);if(!t)throw new Error(i.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,t,a){if(!E.URI.isUri(t)){let d=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(d)return this.logService.info("Extensions is already requested to install",t.identifier.id),d.waitUntilTaskIsFinished();a={...a,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],l=this.createInstallExtensionTask(s,t,a);E.URI.isUri(t)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(l.identifier,s.version).key(),l),this._onInstallExtension.fire({identifier:l.identifier,source:t}),this.logService.info("Installing extension:",l.identifier.id),n.push({task:l,manifest:s});let c=!1;try{if(a.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,s,!!a.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:w,manifest:T}of g)if(c=c||!!T.extensionDependencies?.some(O=>(0,h.areSameExtensions)({id:O},l.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(w.identifier,w.version).key()))this.logService.info("Extension is already requested to install",w.identifier.id);else{const O=this.createInstallExtensionTask(T,w,{...a,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(O.identifier,T.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:w}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:T})}}catch(g){if(E.URI.isUri(l.source))(0,D.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,g.message),(0,D.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,g.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),this.logService.error(g),g}const d=n.reduce((g,{task:w,manifest:T})=>(g.set(w.identifier.id.toLowerCase(),{task:w,manifest:T}),g),new Map);for(;d.size;){let g;const w=[...d.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(O=>d.has(O.toLowerCase())));w.length?g=d.size===1?w:w.filter(({task:T})=>!(T===l&&!c)):(this.logService.info("Found extensions with circular dependencies",w.map(({task:T})=>T.identifier.id)),g=[...d.values()]),await this.joinAllSettled(g.map(async({task:T})=>{const O=new Date().getTime();try{const y=await T.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(y,T.source,a,R.CancellationToken.None))),!E.URI.isUri(T.source)&&(C(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,void 0),m.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(y.manifest.publisher,y.manifest.name,y.manifest.version,"install")}catch(F){}r.push({local:y,identifier:T.identifier,operation:T.operation,source:T.source})}catch(y){throw E.URI.isUri(T.source)||C(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,y),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(y),y}finally{d.delete(T.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:g})=>(0,h.areSameExtensions)(g,l.identifier))[0].local}catch(d){if(n.forEach(({task:g})=>g.cancel()),r.length)try{const g=await Promise.allSettled(r.map(({local:w})=>this.createUninstallExtensionTask(w,{versionOnly:!0}).run()));for(let w=0;w<g.length;w++){const T=g[w],{identifier:O}=r[w];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,A.getErrorMessage)(T.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(g),r.map(({identifier:w})=>w.id))}throw this.logService.error("Failed to install extension:",l.identifier.id,(0,A.getErrorMessage)(d)),this._onDidInstallExtensions.fire(n.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),d instanceof Error&&(d.name=d&&d.code?d.code:e.ERROR_UNKNOWN),d}finally{for(const{task:d,manifest:g}of n)if(!E.URI.isUri(d.source)){const w=new h.ExtensionIdentifierWithVersion(d.identifier,g.version).key();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(s){const t=[],a=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?t.push(r.value):a.push(r.reason);if(a.length)throw S(a);return t}async getAllDepsAndPackExtensionsToInstall(s,t,a){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(d=>d.identifier)],l=[],c=async(d,g)=>{const w=g.extensionDependencies||[],T=[...w];if(g.extensionPack){const O=a?n.find(y=>(0,h.areSameExtensions)(y.identifier,d)):void 0;for(const y of g.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(F=>(0,h.areSameExtensions)({id:F},{id:y}))||T.every(F=>!(0,h.areSameExtensions)({id:F},{id:y}))&&T.push(y)}if(T.length){const O=[...r,...l.map(F=>F.gallery.identifier)],y=T.filter(F=>O.every(M=>!(0,h.areSameExtensions)(M,{id:F})));if(y.length){const F=await this.galleryService.query({names:y,pageSize:T.length},R.CancellationToken.None);for(const M of F.firstPage){if(O.find(z=>(0,h.areSameExtensions)(z,M.identifier)))continue;if(!w.some(z=>(0,h.areSameExtensions)({id:z},M.identifier))&&!await this.canInstall(M)){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}const j=await this.checkAndGetCompatibleVersion(M,!0),U=await this.galleryService.getManifest(j,R.CancellationToken.None);if(U===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${j.identifier.id}`,e.INSTALL_ERROR_VALIDATING);l.push({gallery:j,manifest:U}),await c(j.identifier,U)}}}};return await c(s,t),n=await this.getInstalled(),l.filter(d=>!n.some(g=>(0,h.areSameExtensions)(g.identifier,d.gallery.identifier)))}async checkAndGetCompatibleVersion(s,t){if(await this.isMalicious(s))throw new I.ExtensionManagementError(i.localize(3,null,s.identifier.id),I.INSTALL_ERROR_MALICIOUS);let a=null;if(await this.galleryService.isExtensionCompatible(s,I.CURRENT_TARGET_PLATFORM)&&(a=s),!a&&t&&(a=await this.galleryService.getCompatibleExtension(s,I.CURRENT_TARGET_PLATFORM)),!a)throw new I.ExtensionManagementError(i.localize(4,null,s.identifier.id,u.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(s){const t=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(t).has(s.identifier.id)}async unininstallExtension(s,t){const a=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(a)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),a.waitUntilTaskIsFinished();const n=(d,g)=>{const w=this.createUninstallExtensionTask(d,g);return this.uninstallingExtensions.set(w.extension.identifier.id.toLowerCase(),w),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),w},r=(d,g)=>{g?this.logService.error("Failed to uninstall extension:",d.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),C(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(d),void 0,g),this._onDidUninstallExtension.fire({identifier:d.identifier,error:g?.code})},l=[],c=[];try{l.push(n(s,{}));const d=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(s,d);for(const w of g)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):l.push(n(w,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(l.map(g=>g.extension),d,s),await this.joinAllSettled(l.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(w=>w.postUninstall(g.extension,t,R.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(w){}r(g.extension)}catch(w){const T=w instanceof I.ExtensionManagementError?w:new I.ExtensionManagementError((0,A.getErrorMessage)(w),e.ERROR_UNKNOWN);throw r(g.extension,T),T}finally{c.push(g)}}))}catch(d){const g=d instanceof I.ExtensionManagementError?d:new I.ExtensionManagementError((0,A.getErrorMessage)(d),e.ERROR_UNKNOWN);for(const w of l){try{w.cancel()}catch(T){}c.includes(w)||r(w.extension,g)}throw g}finally{for(const d of l)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(s,t,a){for(const n of s){const r=this.getDependents(n,t);if(r.length){const l=r.filter(c=>!s.some(d=>(0,h.areSameExtensions)(d.identifier,c.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(n,l,a))}}}getDependentsErrorMessage(s,t,a){return a===s?t.length===1?i.localize(5,null,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(6,null,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(7,null,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(8,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(9,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(10,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(s,t,a=[]){if(a.indexOf(s)!==-1)return[];a.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=t.filter(c=>!c.isBuiltin&&n.some(d=>(0,h.areSameExtensions)({id:d},c.identifier))),l=[];for(const c of r)l.push(...this.getAllPackExtensionsToUninstall(c,t,a));return[...r,...l]}return[]}getDependents(s,t){return t.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(n=>(0,h.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const t=await this.findGalleryExtensionById(s.identifier.uuid);return t||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};b=fe([X(0,I.IExtensionGalleryService),X(1,f.ITelemetryService),X(2,p.ILogService)],b),e.AbstractExtensionManagementService=b;function S(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((t,a)=>new Error(`${t.message}${t.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=S;function C(o,s,t,a,n){const r=n?n instanceof I.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...t,success:!n,duration:a,errorcode:r})}e.reportTelemetry=C;class v{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(s=>new Promise((t,a)=>{const n=s.onCancellationRequested(()=>{n.dispose(),a((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=v}),define(te[184],ne([0,1,18,6,63,3,8,4,34,5,116,12,27,177,75,13,14,59,28,42,21,22]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(l,c,d,g,w,T,O,y,F,M){super(O,y,F,M);this.environmentService=l,this.telemetryService=c,this.extensionManagementService=d,this.storageService=g,this.nativeHostService=w,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,y.exeBasedExtensionTips&&(0,R.forEach)(y.exeBasedExtensionTips,({key:q,value:j})=>{const U=[],z=[],V=[];(0,R.forEach)(j.recommendations,({key:x,value:B})=>{B.important?j.important?U.push({extensionId:x,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):z.push({extensionId:x,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):V.push({extensionId:x,extensionName:B.name,isExtensionPack:!!B.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(q,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:U}),z.length&&this.mediumImportanceExecutableTips.set(q,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:z}),V.length&&this.allOtherExecutableTips.set(q,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:V})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...l,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),d=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(l,d),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,d)}groupImportantTipsByExe(l,c){const d=new Map;l.forEach(y=>d.set(y.extensionId.toLowerCase(),y));const{installed:g,uninstalled:w}=this.groupByInstalled([...d.keys()],c);for(const y of g){const F=d.get(y);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:y,exeName:F.exeName})}for(const y of w){const F=d.get(y);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:y,exeName:F.exeName})}const T=this.getPromptedExecutableTips(),O=new Map;for(const y of w){const F=d.get(y);if(F&&(!T[F.exeName]||!T[F.exeName].includes(F.extensionId))){let M=O.get(F.exeName);M||(M=[],O.set(F.exeName,M)),M.push(F)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[l,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(d=>{switch(d){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(l);break;case"incompatibleWindow":const g=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,L.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const l=this.getLastPromptedMediumExeTime(),c=Date.now()-l,d=7*24*60*60*1e3;if(c<d){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},d-c));return}const[g,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(w[0].exeName,w);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},d));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const y=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(y(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const F=this._register((0,L.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(l){const c=l.map(({extensionId:g})=>g.toLowerCase()),d=(0,i.localize)(0,null,l[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,d,`@exe:"${l[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let l=this.storageService.getNumber(a,0);return l||(l=Date.now(),this.updateLastPromptedMediumExeTime(l)),l}updateLastPromptedMediumExeTime(l){this.storageService.store(a,l,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(l,c){const d=this.getPromptedExecutableTips();d[l]=c.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(d),0,0)}groupByInstalled(l,c){const d=[],g=[],w=c.reduce((T,O)=>(T.add(O.identifier.id.toLowerCase()),T),new Set);return l.forEach(T=>{w.has(T.toLowerCase())?d.push(T):g.push(T)}),{installed:d,uninstalled:g}}async getValidExecutableBasedExtensionTips(l){const c=[],d=new Map;for(const g of l.keys()){const w=l.get(g);if(!w||!(0,D.isNonEmptyArray)(w.recommendations))continue;const T=[];P.isWindows?w.windowsPath&&T.push(w.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(T.push((0,k.join)("/usr/local/bin",g)),T.push((0,k.join)("/usr/bin",g)),T.push((0,k.join)(this.environmentService.userHome.fsPath,g)));for(const O of T){let y=d.get(O);if(y===void 0&&(y=await this.fileService.exists(E.URI.file(O)),d.set(O,y)),y)for(const{extensionId:F,extensionName:M,isExtensionPack:q}of w.recommendations)c.push({extensionId:F,extensionName:M,isExtensionPack:q,exeName:g,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return c}};n=fe([X(0,I.INativeEnvironmentService),X(1,s.ITelemetryService),X(2,h.IExtensionManagementService),X(3,o.IStorageService),X(4,S.INativeHostService),X(5,u.IExtensionRecommendationNotificationService),X(6,f.IFileService),X(7,C.IProductService),X(8,v.IRequestService),X(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(te[82],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appender=A}listen(A,k){throw new Error(`Event not found: ${k}`)}call(A,k,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(A){this.channel=A}log(A,k){return this.channel.call("log",{eventName:A,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[83],ne([0,1,2,26,24,126,20,38,44,32]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let i=class{constructor(p,u){this._configurationService=u,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=p.appender,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(f),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(f=>{const b=/^[a-f0-9]+$/i.test(f["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})})}setExperimentProperty(p,u){this._experimentProperties[p]=u}setEnabled(p){this._enabled=p}_updateUserOptIn(){const p=this._configurationService?.getValue(I);this._userOptIn=p?p.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const p=await this._commonProperties;let u=p.sessionID,f=p["common.instanceId"],b=p["common.machineId"],S=p["common.firstSessionDate"],C=p["common.msftInternal"];return{sessionId:u,instanceId:f,machineId:b,firstSessionDate:S,msftInternal:C}}dispose(){this._disposables.dispose()}publicLog(p,u,f){return this.isOptedIn?this._commonProperties.then(b=>{u=(0,L.mixin)(u,b),u=(0,L.mixin)(u,this._experimentProperties),u=(0,L.cloneAndChange)(u,S=>{if(typeof S=="string")return this._cleanupInfo(S,f)}),this._appender.log(p,u)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(p,u,f){return this.publicLog(p,u,f)}publicLogError(p,u){return this.sendErrorTelemetry?this.publicLog(p,u,!0):Promise.resolve(void 0)}publicLogError2(p,u){return this.publicLogError(p,u)}_cleanupInfo(p,u){let f=p;if(u){const b=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(p);if(!s)break;b.push([s.index,o.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(f="";;){const o=C.exec(p);if(!o)break;!S.test(o[0])&&b.every(([s,t])=>o.index<s||o.index>=t)&&(f+=p.substring(v,o.index)+"<REDACTED: user-file-path>",v=C.lastIndex)}v<p.length&&(f+=p.substr(v))}for(let b of this._cleanupPatterns)f=f.replace(b,"");return f}};i.IDLE_START_EVENT_NAME="UserIdleStart",i.IDLE_STOP_EVENT_NAME="UserIdleStop",i=fe([X(1,k.IConfigurationService)],i),e.TelemetryService=i;const I="telemetry";E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[46],ne([0,1,6,26,16,20]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.TelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(b,S){return Promise.resolve(void 0)}publicLog2(b,S){return this.publicLog(b,S)}publicLogError(b,S){return Promise.resolve(void 0)}publicLogError2(b,S){return this.publicLogError(b,S)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(S,C,v){}async publicLogError(S,C,v){}}e.NullEndpointTelemetryService=k;function P(...b){return{log:(S,C)=>b.forEach(v=>v.log(S,C)),flush:()=>D.Promises.settled(b.map(S=>S.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(b,S){return S.onDidChangeConfiguration(C=>{C.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(C.source),configurationKeys:u(C.sourceConfig)})})}e.configurationTelemetry=m;var E;(function(b){b[b.NONE=0]="NONE",b[b.LOG=1]="LOG",b[b.USER=2]="USER"})(E=e.TelemetryLevel||(e.TelemetryLevel={}));function i(b,S){return S.disableTelemetry||!b.enableTelemetry?0:S.isBuilt?2:1}e.getTelemetryLevel=i;function I(b){const S=Object.create(null),C=Object.create(null),v=Object.create(null);p(b,v);for(let o in v){o=o.length>150?o.substr(o.length-149):o;const s=v[o];typeof s=="number"?C[o]=s:typeof s=="boolean"?C[o]=s?1:0:typeof s=="string"?S[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(S[o]=s)}return{properties:S,measurements:C}}e.validateTelemetryData=I;function h(b){if(!b)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{b.indexOf(`${v}+`)===0&&(S=v)}),S}e.cleanRemoteAuthority=h;function p(b,S,C=0,v){if(!!b)for(let o of Object.getOwnPropertyNames(b)){const s=b[o],t=v?v+o:o;Array.isArray(s)?S[t]=(0,L.safeStringify)(s):s instanceof Date?S[t]=s.toISOString():(0,R.isObject)(s)?C<2?p(s,S,C+1,t+"."):S[t]=(0,L.safeStringify)(s):S[t]=s}}function u(b){if(!b)return[];const S=[];return f(S,"",b),S}function f(b,S,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(v=>f(b,S?`${S}.${v}`:v,C[v])):b.push(S)}}),define(te[185],ne([0,1,18,29,11,26,4,5,20,12,27,31,72,13,14,28,42,45,21,22,46]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0;var s;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(s||(s={}));function t(..._){return String(_.reduce((W,K)=>W|K,0))}var a;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class d{constructor(W=c){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,K=this.state.pageSize){return new d({...this.state,pageNumber:W,pageSize:K})}withFilter(W,...K){const Q=[...this.state.criteria,...K.length?K.map(Z=>({filterType:W,value:Z})):[{filterType:W}]];return new d({...this.state,criteria:Q})}withSortBy(W){return new d({...this.state,sortBy:W})}withSortOrder(W){return new d({...this.state,sortOrder:W})}withFlags(...W){return new d({...this.state,flags:W.reduce((K,Q)=>K|Q,0)})}withAssetTypes(...W){return new d({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:K,pageSize:Q,sortBy:Z,sortOrder:se,flags:le,assetTypes:ce}=this.state;return{filters:[{criteria:W,pageNumber:K,pageSize:Q,sortBy:Z,sortOrder:se}],assetTypes:ce,flags:le}}get searchText(){const W=this.state.criteria.filter(K=>K.filterType===a.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(_,W){const K=(_||[]).filter(Q=>Q.statisticName===W)[0];return K?K.value:0}function w(_){const W="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(Q=>Q.assetType.indexOf(W)===0).reduce((Q,Z)=>{const se=F(_,Z.assetType);return se&&Q.push([Z.assetType.substring(W.length),se]),Q},[])}function T(_){if(_.properties){const W=_.properties.filter(Z=>Z.key===n.Repository),K=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=W.filter(Z=>K.test(Z.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return F(_,n.Repository)}function O(_){return{uri:`${_.fallbackAssetUri}/${n.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${n.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function y(_){const W=F(_,n.Icon);if(W)return W;const K=i.DefaultIconPath;return{uri:K,fallbackUri:K}}function F(_,W){return _.files.filter(Q=>Q.assetType===W)[0]?{uri:`${_.assetUri}/${W}`,fallbackUri:`${_.fallbackAssetUri}/${W}`}:null}function M(_,W){const K=_.properties?_.properties.filter(Z=>Z.key===W):[],Q=K.length>0&&K[0].value;return Q?Q.split(",").map(Z=>(0,I.adoptToGalleryExtensionId)(Z)):[]}function q(_){const W=_.properties?_.properties.filter(K=>K.key===r.Engine):[];return W.length>0&&W[0].value||""}function j(_){const W=_.properties?_.properties.filter(Q=>Q.key===r.LocalizedLanguages):[],K=W.length>0&&W[0].value||"";return K?K.split(","):[]}function U(_){return _.indexOf("preview")!==-1}function z(_){return _.targetPlatform?(0,i.toTargetPlatform)(_.targetPlatform):"undefined"}function V(_){const W=(0,D.distinct)(_.versions.map(z)),K=!!_.tags?.includes(i.WEB_EXTENSION_TAG),Q=W.indexOf("web");return K?Q===-1&&W.push("web"):Q!==-1&&W.splice(Q,1),W}function x(_,W,K,Q){const Z=V(_);let se=_.versions[0];return se=_.versions.find(le=>le.version===se.version&&(0,i.isTargetPlatformCompatible)(z(le),Z,i.CURRENT_TARGET_PLATFORM))||se,B(_,se,Z,W,K,Q)}function B(_,W,K,Q,Z,se){const le={manifest:F(W,n.Manifest),readme:F(W,n.Details),changelog:F(W,n.Changelog),license:F(W,n.License),repository:T(W),download:O(W),icon:y(W),coreTranslations:w(W)};return{identifier:{id:(0,I.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:W.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:g(_.statistics,"install"),rating:g(_.statistics,"averagerating"),ratingCount:g(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:K,assets:le,properties:{dependencies:M(W,r.Dependency),extensionPack:M(W,r.ExtensionPack),engine:q(W),localizedLanguages:j(W),targetPlatform:z(W)},preview:U(_.flags),telemetryData:{index:(Z.pageNumber-1)*Z.pageSize+Q,querySource:se}}}let N=class{constructor(W,K,Q,Z,se,le,ce,ge){this.requestService=K,this.logService=Q,this.environmentService=Z,this.telemetryService=se,this.fileService=le,this.productService=ce,this.configurationService=ge;const we=ce.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=J(ce.version,ce,this.environmentService,this.configurationService,this.fileService,W)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,K){const Q=[];let Z=new d().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,W.length).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExtensionName,...W.map(({id:le})=>le.toLowerCase()));W.every(le=>!le.version)&&(Z=Z.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(Z,L.CancellationToken.None);for(let le=0;le<se.length;le++){const ce=se[le];if(!ce.versions.length)continue;const ge=(0,I.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),we=W.find(Se=>(0,I.areSameExtensions)(Se,{id:ge}))?.version;if(we){const Se=ce.versions.find(ke=>ke.version===we);Se&&Q.push(B(ce,Se,V(ce),le,Z))}else Q.push(x(ce,le,Z))}return Q}async getCompatibleExtension(W,K){const Q=(0,i.isIExtensionIdentifier)(W)?null:W;if(Q){if((0,i.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(Q,K))return Q}const{id:Z,uuid:se}=Q?Q.identifier:W;let le=new d().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");se?le=le.withFilter(a.ExtensionId,se):le=le.withFilter(a.ExtensionName,Z);const{galleryExtensions:ce}=await this.queryGallery(le,L.CancellationToken.None),[ge]=ce;if(!ge||!ge.versions.length)return null;const we=V(ge);if((0,i.isNotWebExtensionInWebTargetPlatform)(we,K))return null;for(let Se of ge.versions){if(!q(Se)){const ke=await this.getEngine(Se);Se={...Se,properties:[...Se.properties||[],{key:r.Engine,value:ke}]}}if(await this.isRawExtensionVersionCompatible(Se,we,K))return B(ge,Se,we,0,le)}return null}async isExtensionCompatible(W,K){if(!(0,i.isTargetPlatformCompatible)(W.properties.targetPlatform,W.allTargetPlatforms,K))return!1;let Q=W.properties.engine;if(!Q){const Z=await this.getManifest(W,L.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");Q=Z.engines.vscode}return(0,h.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(W,K,Q){if(!(0,i.isTargetPlatformCompatible)(z(W),K,Q))return!1;const Z=await this.getEngine(W);return(0,h.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(W,K){const Q=L.CancellationToken.isCancellationToken(W)?{}:W,Z=L.CancellationToken.isCancellationToken(W)?W:K;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=Q.text||"";const le=(0,A.getOrDefault)(Q,Re=>Re.pageSize,50);let ce=new d().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,le).withFilter(a.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Pe,Fe)=>(ce=ce.withFilter(a.Category,Fe||Pe),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Pe,Fe)=>(ce=ce.withFilter(a.Tag,Fe||Pe),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(a.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),ce=ce.withFilter(a.SearchText,se)),ce=ce.withSortBy(0)):Q.ids?ce=ce.withFilter(a.ExtensionId,...Q.ids):Q.names?ce=ce.withFilter(a.ExtensionName,...Q.names):ce=ce.withSortBy(4),typeof Q.sortBy=="number"&&(ce=ce.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(ce=ce.withSortOrder(Q.sortOrder));const{galleryExtensions:ge,total:we}=await this.queryGallery(ce,Z),Se=ge.map((Re,Pe)=>x(Re,Pe,ce,Q.source)),ke=async(Re,Pe)=>{if(Pe.isCancellationRequested)throw(0,R.canceled)();const Fe=ce.withPage(Re+1),{galleryExtensions:De}=await this.queryGallery(Fe,Pe);return De.map((Ae,We)=>x(Ae,We,Fe,Q.source))};return{firstPage:Se,total:we,pageSize:ce.pageSize,getPage:ke}}async queryGallery(W,K){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,s.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,t(s.Unpublished));const Q=await this.commonHeadersPromise,Z=JSON.stringify(W.raw),se={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new Date().getTime();let ce,ge,we=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:se},K),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:we};const Se=await(0,b.asJson)(ce);if(Se){const ke=Se.results[0],Re=ke.extensions,Pe=ke.resultMetadata&&ke.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return we=Pe&&Pe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:we}}return{galleryExtensions:[],total:we}}catch(Se){throw ge=Se,Se}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-le,success:!!ce&&(0,b.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ge?(0,R.isPromiseCanceledError)(ge)?"canceled":(0,R.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(W,K,Q,Z){if(!this.isEnabled())return;const se=k.isWeb?this.api(`/itemName/${W}.${K}/version/${Q}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${K}/${Q}/stats?statType=${Z}`),le=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:se,headers:ge},L.CancellationToken.None)}catch(we){}}async download(W,K,Q){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const Z=(0,I.getGalleryExtensionTelemetryData)(W),se=new Date().getTime(),le=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:Se}),ce=Q===1?"install":Q===2?"update":"",ge=ce?{uri:`${W.assets.download.uri}${P.URI.parse(W.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${W.assets.download.fallbackUri}${P.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:W.assets.download,we=await this.getAsset(ge);await this.fileService.writeFile(K,we.stream),le(new Date().getTime()-se)}async getReadme(W,K){if(W.assets.readme){const Q=await this.getAsset(W.assets.readme,{},K);return await(0,b.asText)(Q)||""}return""}async getManifest(W,K){if(W.assets.manifest){const Q=await this.getAsset(W.assets.manifest,{},K),Z=await(0,b.asText)(Q);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(W,K){const Q=F(W,n.Manifest);if(!Q)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},se=await this.getAsset(Q,{headers:Z});return await(0,b.asJson)(se)}async getCoreTranslation(W,K){const Q=W.assets.coreTranslations.filter(Z=>Z[0]===K.toUpperCase())[0];if(Q){const Z=await this.getAsset(Q[1]),se=await(0,b.asText)(Z);return se?JSON.parse(se):null}return null}async getChangelog(W,K){if(W.assets.changelog){const Q=await this.getAsset(W.assets.changelog,{},K);return await(0,b.asText)(Q)||""}return""}async getAllCompatibleVersions(W,K){let Q=new d().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?Q=Q.withFilter(a.ExtensionId,W.identifier.uuid):Q=Q.withFilter(a.ExtensionName,W.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(Q,L.CancellationToken.None);if(!Z.length)return[];const se=V(Z[0]);if((0,i.isNotWebExtensionInWebTargetPlatform)(se,K))return[];const le=[];for(const ce of Z[0].versions)try{await this.isRawExtensionVersionCompatible(ce,se,K)&&le.push({version:ce.version,date:ce.lastUpdated})}catch(ge){}return le}async getAsset(W,K={},Q=L.CancellationToken.None){const Z=await this.commonHeadersPromise,se={type:"GET"},le={...Z,...K.headers||{}};K={...K,...se,headers:le};const ce=W.uri,ge=W.fallbackUri,we={...K,url:ce};try{const Se=await this.requestService.request(we,Q);if(Se.res.statusCode===200)return Se;const ke=await(0,b.asText)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${ke}`)}catch(Se){if((0,R.isPromiseCanceledError)(Se))throw Se;const ke=(0,R.getErrorMessage)(Se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:ke});const Re={...K,url:ge};return this.requestService.request(Re,Q)}}async getEngine(W){let K=q(W);if(!K){const Q=await this.getManifestFromRawExtensionVersion(W,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");K=Q.engines.vscode}return K}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const K=await(0,b.asJson)(W),Q=new Map;if(K)for(const Z of K.malicious){const se=Q.get(Z)||{id:{id:Z},malicious:!0,slow:!1};se.malicious=!0,Q.set(Z,se)}return[...Q.values()]}};N=fe([X(1,b.IRequestService),X(2,u.ILogService),X(3,E.IEnvironmentService),X(4,v.ITelemetryService),X(5,p.IFileService),X(6,f.IProductService),X(7,m.IConfigurationService)],N);let G=class extends N{constructor(W,K,Q,Z,se,le,ce,ge){super(W,K,Q,Z,se,le,ce,ge)}};G=fe([X(0,C.IStorageService),X(1,b.IRequestService),X(2,u.ILogService),X(3,E.IEnvironmentService),X(4,v.ITelemetryService),X(5,p.IFileService),X(6,f.IProductService),X(7,m.IConfigurationService)],G),e.ExtensionGalleryService=G;let $=class extends N{constructor(W,K,Q,Z,se,le,ce){super(void 0,W,K,Q,Z,se,le,ce)}};$=fe([X(0,b.IRequestService),X(1,u.ILogService),X(2,E.IEnvironmentService),X(3,v.ITelemetryService),X(4,p.IFileService),X(5,f.IProductService),X(6,m.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$;async function J(_,W,K,Q,Z,se){const le={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},ce=await(0,S.getServiceMachineId)(K,Z,se);return(0,o.getTelemetryLevel)(W,K)>=2&&Q.getValue("telemetry.enableTelemetry")===!0&&(le["X-Market-User-Id"]=ce),le}e.resolveMarketplaceHeaders=J}),define(te[84],ne([0,1,2,12,14,46]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(m,E,i=""){super();this.prefix=i;const I=m.getLogger(E.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(m.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,E){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,A.validateTelemetryData)(E))}};k=fe([X(0,R.ILoggerService),X(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[186],ne([0,1,11,26,46]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(P){const m=await new Promise((i,I)=>{Y(["applicationinsights"],i,I)});let E;return m.defaultClient?(E=new m.TelemetryClient(P),E.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=m.defaultClient),P.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class k{constructor(m,E,i){this._eventPrefix=m,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(E=>{m(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(m,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,R.validateTelemetryData)(E),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[187],ne([0,1,17,52,20,12,14,22,82,84,83,46]),function(Y,e,D,L,R,A,k,P,m,E,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(u,f,b,S){this.configurationService=u,this.telemetryService=f,this.loggerService=b,this.environmentService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:f,sessionId:b}=await this.telemetryService.getTelemetryInfo(),S=Object.create(null);S["common.vscodemachineid"]=f,S["common.vscodesessionid"]=b;const C=[u.id,JSON.stringify(S),u.aiKey],o=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),s=(0,I.combinedAppender)(new m.TelemetryAppenderClient(o),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new i.TelemetryService({appender:s,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,f,b){await(await this.getCustomTelemetryService(u)).publicLog(f,b)}async publicLogError(u,f,b){await(await this.getCustomTelemetryService(u)).publicLogError(f,b)}};h=fe([X(0,R.IConfigurationService),X(1,P.ITelemetryService),X(2,k.ILoggerService),X(3,A.IEnvironmentService)],h),e.CustomEndpointTelemetryService=h}),define(te[188],ne([0,1,6,29,3,2,14]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(E,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((i,I)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,i),this._onCreateRequest.fire({requestId:h,...E});const p=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,p.token).then(()=>I(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,A.toDisposable)(()=>p.cancel())])})}acceptReply(E,i){const I=this._pendingRequests.get(E);I?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),I(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=fe([X(1,k.ILogService)],P),e.RequestStore=P}),define(te[85],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.TerminalPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.TitleMode="terminal.integrated.titleMode",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(f){f[f.cwd=0]="cwd",f[f.initialCwd=1]="initialCwd"})(m=e.TerminalPropertyType||(e.TerminalPropertyType={}));var E;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(f){f.TerminalView="view",f.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}))}),define(te[189],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[190],ne([0,1,35,26,8,4,34,16,19]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let h=0;return I&&I.length===4&&(h=parseInt(I[3])),h}e.getWindowsBuildNumber=E;async function i(I,h,p,u=k.env,f=m.Promises.exists){if(R.isAbsolute(I))return await f(I)?I:void 0;if(h===void 0&&(h=k.cwd()),R.dirname(I)!=="."){const v=R.join(h,I);return await f(v)?v:void 0}const S=(0,L.getCaseInsensitive)(u,"PATH");if(p===void 0&&(0,P.isString)(S)&&(p=S.split(R.delimiter)),p===void 0||p.length===0){const v=R.join(h,I);return await f(v)?v:void 0}for(let v of p){let o;if(R.isAbsolute(v)?o=R.join(v,I):o=R.join(h,v,I),await f(o))return o;if(A.isWindows){let s=o+".com";if(await f(s)||(s=o+".exe",await f(s)))return s}}const C=R.join(h,I);return await f(C)?C:void 0}e.findExecutable=i}),define(te[191],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[86],ne([0,1,49,3,2,7,32,191]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var m;(function(b){function S(C){return C&&typeof C=="object"&&typeof C.id=="string"}b.isThemeColor=S})(m=e.ThemeColor||(e.ThemeColor={}));function E(b){return{id:b}}e.themeColorFromId=E;var i;(function(b){function S(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||m.isThemeColor(a.color))}b.isThemeIcon=S;const C=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(a){const n=C.exec(a);if(!n)return;let[,r]=n;return{id:r}}b.fromString=v;function o(a,n){let r=a.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),n&&(r=`${r}~${n}`),{id:r}}b.modify=o;function s(a,n){return a.id===n.id&&a.color?.id===n.color?.id}b.isEqual=s;function t(a,n){return{id:a.id,color:n?E(n):void 0}}b.asThemeIcon=t,b.asClassNameArray=D.CSSIcon.asClassNameArray,b.asClassName=D.CSSIcon.asClassName,b.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(b){switch(b){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,R.toDisposable)(()=>{const C=this.themingParticipants.indexOf(S);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new h;k.Registry.add(e.Extensions.ThemingContribution,p);function u(b){return p.onColorThemeChange(b)}e.registerThemingParticipant=u;class f extends R.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,C){let v=this.theme.getColor(S);return v&&C&&(v=C(v,this.theme)),v?v.toString():null}}e.Themable=f}),define(te[192],ne([0,1,49,86]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const E=P.map(i=>({name:i.profileName,description:A(i)}));return m&&E.push(...m.map(i=>({name:i.title,description:k(i)}))),{values:E.map(i=>i.name),markdownDescriptions:E.map(i=>i.description)}}e.createProfileSchemaEnums=R;function A(P){let m=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function k(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[193],ne([0,1,49,127,38,32,192]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function p(){A.Registry.as(R.Extensions.Configuration).registerConfiguration(h),f()}e.registerTerminalPlatformConfiguration=p;let u;function f(b,S){const C=A.Registry.as(R.Extensions.Configuration);u&&C.deregisterConfigurations([u]);let v;b&&(v=(0,k.createProfileSchemaEnums)(b?.profiles,S)),u={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?v?.values:void 0,markdownEnumDescriptions:b?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?v?.values:void 0,markdownEnumDescriptions:b?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?v?.values:void 0,markdownEnumDescriptions:b?.os===1?v?.markdownDescriptions:void 0}}},C.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=f}),define(te[194],ne([0,1,41,49,8,4,19,69,190,86]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function I(t,a,n,r,l=process.env,c,d,g,w){return c=c||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},A.isWindows?h(n,c,l,d,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:r.getValue("terminal.integrated.defaultProfile.windows"),w,g):v(c,d,n,t&&typeof t=="object"?{...t}:r.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:r.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),w,g,l)}e.detectAvailableProfiles=I;async function h(t,a,n,r,l,c,d,g,w){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let y=!1;(0,m.getWindowsBuildNumber)()>=16299&&(y=!0),await f(g);const F=new Map;t&&(F.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(c,F);const M=await p(F.entries(),d,a,n,r,w);if(t||!t&&l)try{const q=await S(`${O}\\${y?"wsl":"bash"}.exe`,d);for(const j of q)(!c||!(j.profileName in c))&&M.push(j)}catch(q){r?.info("WSL is not installed, so could not detect WSL profiles")}return M}async function p(t,a,n,r=process.env,l,c){const d=[];for(const[g,w]of t){if(w===null)continue;let T,O,y;if("source"in w){const q=i?.get(w.source);if(!q)continue;T=q.paths,O=w.args||q.args,w.icon?y=u(w.icon):q.icon&&(y=q.icon)}else T=Array.isArray(w.path)?w.path:[w.path],O=A.isWindows||Array.isArray(w.args)?w.args:void 0,y=u(w.icon)||void 0;const F=await c?.(T)||T.slice(),M=await s(g,a,F,n,r,O,w.env,w.overrideName,w.isAutoDetected,l);M?(M.isAutoDetected=w.isAutoDetected,M.icon=y,M.color=w.color,d.push(M)):l?.trace("profile not validated",g,T)}return d}function u(t){return typeof t=="string"?{id:t}:t}async function f(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await b(),icon:E.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function b(){const t=[];for await(const a of(0,P.enumeratePowerShellInstallations)())t.push(a.exePath);return t}async function S(t,a){const n=[],r=await new Promise((d,g)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(w,T)=>{if(w)return g("Problem occurred when getting wsl distros");d(T)})});if(!r)return[];const l=new RegExp(/[\r?\n]/),c=r.split(l).filter(d=>d.trim().length>0&&d!=="");for(const d of c){if(d===""||d.startsWith("docker-desktop"))continue;const g=`${d} (WSL)`,w={profileName:g,path:t,args:["-d",`${d}`],isDefault:g===a,icon:C(d)};n.push(w)}return n}function C(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,a,n,r,l,c,d,g){const w=new Map;if(n){const T=(await t.readFile("/etc/shells")).toString(),O=c||T.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),y=new Map;for(const F of O){let M=(0,R.basename)(F),q=y.get(M)||0;q++,q>1&&(M=`${M} (${q})`),y.set(M,q),w.set(M,{path:F,isAutoDetected:!0})}}return o(r,w),await p(w.entries(),l,t,g,a,d)}function o(t,a){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?a.delete(n):a.set(n,r)}async function s(t,a,n,r,l,c,d,g,w,T){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return s(t,a,n,r,l,c,d,g,w);const y={profileName:t,path:O,args:c,env:d,overrideName:g,isAutoDetected:w,isDefault:t===a};if((0,R.basename)(O)===O){const M=l.PATH?l.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,M,void 0,r.existsFile)?y:s(t,a,n,r,l,c)}return await r.existsFile((0,R.normalize)(O))?y:s(t,a,n,r,l,c,d,g,w)}}),define(te[195],ne([0,1,3,2,17,4,36,52,20,156,14,79,22,188,85,193,194]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let C=0,v=class extends L.Disposable{constructor(s,t,a,n){super();this._reconnectConstants=s,this._configurationService=t,this._logService=a,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=A.isWindows?Promise.resolve(process.env):(0,E.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const s=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),k.ProxyChannel.toService(s.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(s.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const a=s.getChannel(u.TerminalIpcChannels.Log);I.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{I.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const n=k.ProxyChannel.toService(s.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(r=>this._onProcessData.fire(r))),this._register(n.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(n.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(n.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(n.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(n.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(n.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(n.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(n.onDidChangeProperty(r=>this._onDidChangeProperty.fire(r))),this._register(n.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(n.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(n.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[s,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,t,a,n,r,l,c,d,g,w,T){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),y=await this._proxy.createProcess(s,t,a,n,r,l,c,d,g,w,T);return clearTimeout(O),C=Math.max(C,y),y}updateTitle(s,t,a){return this._proxy.updateTitle(s,t,a)}updateIcon(s,t,a){return this._proxy.updateIcon(s,t,a)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,t){return this._proxy.shutdown(s,t)}input(s,t){return this._proxy.input(s,t)}processBinary(s,t){return this._proxy.processBinary(s,t)}resize(s,t,a){return this._proxy.resize(s,t,a)}acknowledgeDataEvent(s,t){return this._proxy.acknowledgeDataEvent(s,t)}setUnicodeVersion(s,t){return this._proxy.setUnicodeVersion(s,t)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,t,a,n=!1){const r=await this._shellEnv;return(0,b.detectAvailableProfiles)(t,a,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,t){return this._proxy.requestDetachInstance(s,t)}async acceptDetachInstanceReply(s,t){return this._proxy.acceptDetachInstanceReply(s,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:t})}async acceptPtyHostResolvedVariables(s,t){this._resolveVariablesRequestStore.acceptReply(s,t)}};v=fe([X(1,m.IConfigurationService),X(2,i.ILogService),X(3,h.ITelemetryService)],v),e.PtyHostService=v}),define(te[54],ne([0,1,43]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,P,m,E){const i=(0,D.setProperty)(k,P,m,E)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=L;function R(k,P,m){let E=m;for(;E>=0;){if(k.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&k.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function A(k,P,m){let E=m;for(;E>=0;)if(k.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&k.charAt(E)===P.charAt(1)))return E;return k.length-1}e.getLineEndOffset=A}),define(te[196],ne([0,1,26,58]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(I,h,p,u,f){const b=[],S=[],C=[];if(!h){const O=I.filter(({identifier:y})=>f.every(F=>F.toLowerCase()!==y.id.toLowerCase()));return{local:{added:b,removed:S,updated:C},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}I=I.map(E),h=h.map(E),p=p?p.map(E):null;const v=new Map,o=O=>{O.uuid&&v.set(O.id.toLowerCase(),O.uuid)};I.forEach(({identifier:O})=>o(O)),h.forEach(({identifier:O})=>o(O)),p&&p.forEach(({identifier:O})=>o(O));const s=O=>{const y=O.identifier.uuid||v.get(O.identifier.id.toLowerCase());return y?`uuid:${y}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,y)=>(O.set(s(y),y),O),a=I.reduce(t,new Map),n=h.reduce(t,new Map),r=h.reduce((O,y)=>{const F=s(y);y=(0,D.deepClone)(y);const M=a.get(F);return M&&(M.installed&&(y.installed=!0),y.version||(y.version=M.version)),t(O,y)},new Map),l=p?p.reduce(t,new Map):null,c=u.reduce(t,new Map),d=f.reduce((O,y)=>{const F=v.get(y.toLowerCase());return O.add(F?`uuid:${F}`:`id:${y.toLowerCase()}`)},new Set),g=A(a,n,d);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const O=A(l,a,d),y=A(l,n,d),F=(M,q)=>{const j=a.get(M);if(j){const U=n.get(M);return{...q?U:j,version:(U.version&&L.gt(U.version,j.version),j.version),state:k(j,U,l?.get(M))}}};for(const M of y.removed.values()){const q=a.get(M);q&&S.push(q.identifier)}for(const M of y.added.values())if(O.added.has(M)){if(g.updated.has(M)){const q=F(M,!0);q&&(C.push(i(q,M)),r.set(M,q))}}else{const q=n.get(M);q.installed&&b.push(i(q,M))}for(const M of y.updated.values()){const q=F(M,!0);q&&(C.push(i(q,M)),r.set(M,q))}for(const M of O.added.values())y.added.has(M)||r.set(M,a.get(M));for(const M of O.updated.values())if(!y.removed.has(M)&&!y.updated.has(M)){const q=F(M,!1);q&&(r.get(M)?.installed&&(q.installed=!0),r.set(M,q))}for(const M of O.removed.values())!c.has(M)&&!y.updated.has(M)&&l?.get(M)?.installed&&r.delete(M)}const w=[],T=A(n,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&r.forEach((O,y)=>w.push(i(O,y))),{local:{added:b,removed:S,updated:C},remote:w.length?{added:[...T.added].map(O=>r.get(O)),updated:[...T.updated].map(O=>r.get(O)),removed:[...T.removed].map(O=>n.get(O)),all:w}:null}}e.merge=R;function A(I,h,p,{checkInstalledProperty:u,checkVersionProperty:f}={checkInstalledProperty:!1,checkVersionProperty:!1}){const b=I?[...I.keys()].filter(s=>!p.has(s)):[],S=[...h.keys()].filter(s=>!p.has(s)),C=S.filter(s=>b.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),v=b.filter(s=>S.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),o=new Set;for(const s of b){if(v.has(s))continue;const t=I.get(s),a=h.get(s);(!a||t.disabled!==a.disabled||!m(t.state,a.state)||f&&t.version!==a.version||u&&t.installed!==a.installed)&&o.add(s)}return{added:C,removed:v,updated:o}}function k(I,h,p){const u=I.state,f=h.state,b=p?.state;if(!h.version||u&&L.gt(I.version,h.version))return u;if(f&&L.gt(h.version,I.version)||!u)return f;if(!f)return u;const S=(0,D.deepClone)(u),C=b?P(b,f):{added:Object.keys(f).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set},v=b?P(b,u):{added:Object.keys(u).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set};for(const o of[...C.added.values(),...C.updated.values()])S[o]=f[o];for(const o of C.removed.values())v.updated.has(o)||delete S[o];return S}function P(I,h){const p=Object.keys(I),u=Object.keys(h),f=u.filter(C=>p.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),b=p.filter(C=>u.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),S=new Set;for(const C of p){if(b.has(C))continue;const v=I[C],o=h[C];(0,D.equals)(v,o)||S.add(C)}return{added:f,removed:b,updated:S}}function m(I={},h={}){const{added:p,removed:u,updated:f}=P(I,h);return p.size===0&&u.size===0&&f.size===0}function E(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function i(I,h){const p={identifier:{id:I.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return I.version&&(p.version=I.version),I.disabled&&(p.disabled=!0),I.installed&&(p.installed=!0),I.state&&(p.state=I.state),p}}),define(te[87],ne([0,1,18,3,2,31,7,28,21]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(h,p){super();this.storageService=h,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const p=E.exec(h);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const h=this.storageService.keys(0,1);for(const p of h){const u=Ze.fromKey(p);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=Ze.fromKey(h.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,p){this.storageService.store(Ze.toKey(h),JSON.stringify(p),0,1)}getKeysForSync(h){const p=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],u=this.storageService.get(Ze.toKey(h),0),f=u?JSON.parse(u):void 0;return f&&p?(0,D.distinct)([...f,...p]):f||p}};i=fe([X(0,m.IStorageService),X(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[88],ne([0,1,18,20,7]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(P,m){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return E=E.filter(i=>i!==P&&i!==`-${P}`),m&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(P){const m=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),i=[],I=[];if(Array.isArray(E))for(const h of E)h.startsWith("-")?I.push(h.substring(1)):i.push(h);return(0,D.distinct)([...m,...i].filter(h=>I.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};A=fe([X(0,L.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(te[197],ne([0,1,18,33,26,150,54]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function m(o,s,t,a,n){const r=P(o),l=P(s),c=t?P(t):null,d=[...r,...l,...c||[]].map(z=>z.key),g=await n.resolveUserBindings(d);let w=i(r,l,c,g);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const T=h(r),O=h(l),y=c?h(c):null,F=u(T,O,g),M=y?u(y,T,g):{added:[...T.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set},q=y?u(y,O,g):{added:[...O.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set},j=E(F,M,q);let U=o;for(const z of j.removed.values())j.conflicts.has(z)||(U=C(U,z,a));for(const z of j.added.values()){if(j.conflicts.has(z))continue;const V=O.get(z);if(V.some(x=>x.command!==`-${z}`&&w.conflicts.has(g[x.key]))){j.conflicts.add(z);continue}U=S(U,V,a)}for(const z of j.updated.values()){if(j.conflicts.has(z))continue;const V=O.get(z);if(V.some(x=>x.command!==`-${z}`&&w.conflicts.has(g[x.key]))){j.conflicts.add(z);continue}U=v(U,z,V,a)}return{mergeContent:U,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=m;function E(o,s,t){const a=new Set,n=new Set,r=new Set,l=new Set;for(const c of s.removed.values())t.updated.has(c)&&l.add(c);for(const c of t.removed.values())l.has(c)||(s.updated.has(c)?l.add(c):n.add(c));for(const c of s.added.values())l.has(c)||t.added.has(c)&&o.updated.has(c)&&l.add(c);for(const c of t.added.values())l.has(c)||(s.added.has(c)?o.updated.has(c)&&l.add(c):a.add(c));for(const c of s.updated.values())l.has(c)||t.updated.has(c)&&o.updated.has(c)&&l.add(c);for(const c of t.updated.values())l.has(c)||(s.updated.has(c)?o.updated.has(c)&&l.add(c):r.add(c));return{added:a,removed:n,updated:r,conflicts:l}}function i(o,s,t,a){const n=new Set,r=I(o,a),l=I(s,a),c=t?I(t,a):null,d=p(r,l);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const g=c?p(c,r):{added:[...r.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=c?p(c,l):{added:[...l.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:T,removed:O,updated:y,conflicts:F}=E(d,g,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:O,updated:y,conflicts:F}}function I(o,s){const t=new Map;for(const a of o){const n=s[a.key];let r=t.get(n);r||(r=[],t.set(n,r)),r.push(a)}return t}function h(o){const s=new Map;for(const t of o){const a=t.command[0]==="-"?t.command.substring(1):t.command;let n=s.get(a);n||(n=[],s.set(a,n)),n.push(t)}return s}function p(o,s){const t=[...o.keys()],a=[...s.keys()],n=a.filter(c=>t.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),r=t.filter(c=>a.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),l=new Set;for(const c of t){if(r.has(c))continue;const d=o.get(c).map(w=>({...w,key:c})),g=s.get(c).map(w=>({...w,key:c}));(0,D.equals)(d,g,(w,T)=>b(w,T))||l.add(c)}return{added:n,removed:r,updated:l}}function u(o,s,t){const a=[...o.keys()],n=[...s.keys()],r=n.filter(d=>a.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),l=a.filter(d=>n.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),c=new Set;for(const d of a){if(l.has(d))continue;const g=o.get(d).map(T=>({...T,key:t[T.key]})),w=s.get(d).map(T=>({...T,key:t[T.key]}));f(g,w)||c.add(d)}return{added:r,removed:l,updated:c}}function f(o,s){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,a)=>b(t,a))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,a)=>b(t,a)))}function b(o,s){if(o.command!==s.command||o.key!==s.key)return!1;const t=A.ContextKeyExpr.deserialize(o.when),a=A.ContextKeyExpr.deserialize(s.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!R.equals(o.args,s.args))}function S(o,s,t){for(const a of s)o=k.edit(o,[-1],a,t);return o}function C(o,s,t){const a=P(o);for(let n=a.length-1;n>=0;n--)(a[n].command===s||a[n].command===`-${s}`)&&(o=k.edit(o,[n],void 0,t));return o}function v(o,s,t,a){const n=P(o),r=n.findIndex(l=>l.command===s||l.command===`-${s}`);for(let l=n.length-1;l>=0;l--)(n[l].command===s||n[l].command===`-${s}`)&&(o=k.edit(o,[l],void 0,a));for(let l=t.length-1;l>=0;l--)o=k.edit(o,[r],t[l],a);return o}}),define(te[198],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,k,P){const m={},E={},i=new Set;if(!k)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const I=L(A,k);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:m,updated:E,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=L(P,A),p=L(P,k),u={},f={},b=new Set,S=new Set;for(const C of h.removed.values())p.updated.has(C)?m[C]=k[C]:b.add(C);for(const C of p.removed.values())S.has(C)||(h.updated.has(C)?S.add(C):i.add(C));for(const C of h.updated.values())S.has(C)||(p.updated.has(C)?I.updated.has(C)&&S.add(C):f[C]=A[C]);for(const C of p.updated.values())S.has(C)||(h.updated.has(C)?I.updated.has(C)&&S.add(C):A[C]!==void 0&&(E[C]=k[C]));for(const C of h.added.values())S.has(C)||(p.added.has(C)?I.updated.has(C)&&S.add(C):u[C]=A[C]);for(const C of p.added.values())S.has(C)||(h.added.has(C)?I.updated.has(C)&&S.add(C):m[C]=k[C]);return{local:{added:m,removed:[...i.values()],updated:E},remote:{added:u,removed:[...b.values()],updated:f},conflicts:[...S.values()]}}e.merge=D;function L(A,k){const P=A?Object.keys(A):[],m=k?Object.keys(k):[],E=m.filter(h=>P.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),i=P.filter(h=>m.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),I=new Set;for(const h of P){if(i.has(h))continue;const p=A[h],u=k[h];p!==u&&I.add(h)}return{added:E,removed:i,updated:I}}function R(A,k){const{added:P,removed:m,updated:E}=L(A,k);return P.size===0&&m.size===0&&E.size===0}e.areSame=R}),define(te[23],ne([0,1,18,15,16,132,38,27,7,81,32]),function(Y,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const c=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(d=>!!c[d].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function h(){const c=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(c).filter(T=>!!c[T].ignoreSync),g=Object.keys(c).filter(T=>c[T].scope===2||c[T].scope===6),w=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...d,...g,...w])}e.getDefaultIgnoredSettings=h;function p(){const c="vscode://schemas/ignoredSettings",d=i.Registry.as(k.Extensions.Configuration);d.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=i.Registry.as(E.Extensions.JSONContribution),w=()=>{const T=I(),O=h().filter(q=>q!==e.CONFIGURATION_SYNC_STORE_KEY),y=Object.keys(k.allSettings.properties).filter(q=>O.indexOf(q)===-1),F=O.filter(q=>T.indexOf(q)===-1),M={items:{type:"string",enum:[...y,...F.map(q=>`-${q}`)]}};g.registerSchema(c,M)};return d.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=p;function u(c){return c&&(0,R.isObject)(c)&&(0,R.isString)(c.id)&&(0,R.isArray)(c.scopes)}e.isAuthenticationProvider=u;var f;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function b(c,d,g){return g.joinPath(d.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=b,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function S(c){const d={};return d[e.HEADER_EXECUTION_ID]=c,d}e.createSyncHeaders=S;var C;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(d,g,w,T){super(d);this.code=g,this.resource=w,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class o extends v{constructor(d,g,w,T,O){super(d,w,void 0,O);this.url=g,this.serverCode=T}}e.UserDataSyncStoreError=o;class s extends v{constructor(d,g){super(d,g)}}e.UserDataAutoSyncError=s,function(c){function d(g){if(g instanceof c)return g;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(w&&w[1]){const T=w[2]==="unknown"?void 0:w[2],O=w[3]==="unknown"?void 0:w[3];return new c(g.message,w[1],T,O)}return new c(g.message,"Unknown")}c.toUserDataSyncError=d}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var a;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(c){return`sync.enable.${c}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function l(c,d){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:d.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(d.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=l}),define(te[47],ne([0,1,18,6,25,29,3,33,2,15,24,16,5,128,20,12,13,45,21,22,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=s;let t=class extends m.Disposable{constructor(c,d,g,w,T,O,y,F,M,q){super();this.resource=c,this.fileService=d,this.environmentService=g,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=y,this.telemetryService=F,this.logService=M,this.configurationService=q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(c,g,this.extUri),this.currentMachineIdPromise=(0,S.getServiceMachineId)(g,d,w)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,A.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const d=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,d={}){await this._sync(c,!0,d)}async preview(c,d={}){return this._sync(c,!1,d)}async apply(c,d={}){try{this.syncHeaders={...d};const g=await this.doApply(c);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,d,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let w="idle";try{const T=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(c,T);return w=await this.performSync(O,T,d),w==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):w==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(w)}}finally{this.syncHeaders={}}}async replace(c){const d=await this.resolveContent(c);if(!d)return!1;const g=this.parseSyncData(d);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const w=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,w),O=await this.isRemoteDataFromCurrentMachine(T),y=await this.generateSyncPreview({ref:T.ref,syncData:g},w,O,A.CancellationToken.None),F=[];for(const M of y){const q=await this.getAcceptResult(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,A.CancellationToken.None);F.push([M,{...q,remoteChange:j!==0?j:2}])}await this.applyResult(T,w,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const d=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===d}async getLatestRemoteUserData(c,d){if(d){const g=c&&c.latest?c.latest[this.resource]:void 0;if(d.ref===g||g===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(c,d,g){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,d,g)}catch(w){if(w instanceof o.UserDataSyncError)switch(w.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,d,g);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(c,d,g)}throw w}}async doSync(c,d,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(T=>this.doGenerateSyncResourcePreview(c,d,g,T)));const w=await this.syncPreviewPromise;return this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(w){throw this.syncPreviewPromise=null,w}}async merge(c){return await this.updateSyncResourcePreview(c,async d=>{const g=await this.getMergeResult(d,A.CancellationToken.None);await this.fileService.writeFile(d.previewResource,R.VSBuffer.fromString(g?.content||""));const w=g&&!g.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,A.CancellationToken.None):void 0;return d.acceptResult=w,d.mergeState=g.hasConflicts?"conflict":w?"accepted":"preview",d.localChange=w?w.localChange:g.localChange,d.remoteChange=w?w.remoteChange:g.remoteChange,d}),this.syncPreviewPromise}async accept(c,d){return await this.updateSyncResourcePreview(c,async g=>{const w=await this.getAcceptResult(g,c,d,A.CancellationToken.None);return g.acceptResult=w,g.mergeState="accepted",g.localChange=w.localChange,g.remoteChange=w.remoteChange,g}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async d=>{const g=await this.getMergeResult(d,A.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,R.VSBuffer.fromString(g.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=g.localChange,d.remoteChange=g.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(c,d){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const w=g.resourcePreviews.findIndex(({localResource:T,remoteResource:O,previewResource:y})=>this.extUri.isEqual(T,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(y,c));w!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async T=>{const O=[...g.resourcePreviews];return O[w]=await d(O[w]),{...g,resourcePreviews:O}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(g=>[g,g.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const d=c.filter(({mergeState:g})=>g==="conflict");(0,D.equals)(this._conflicts,d,(g,w)=>this.extUri.isEqual(g.previewResource,w.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:g})=>({created:d,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:g})=>({created:d,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(c){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const d=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(d))){const{content:g}=await this.getUserData(d);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(c){const d=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(d))){const{content:g}=await this.getUserData(d);return g}return this.extUri.isEqual(c,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(c){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const g of d.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,c))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,c))return g.remoteContent;if(this.extUri.isEqual(g.localResource,c))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,d,g,w){const T=await this.isRemoteDataFromCurrentMachine(c),O=await this.generateSyncPreview(c,d,T,w),y=[];for(const F of O){const M=F.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)y.push({...F,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const q=g?await this.getMergeResult(F,w):void 0;if(w.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,R.VSBuffer.fromString(q?.content||""));const j=q&&!q.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,w):void 0;y.push({...F,acceptResult:j,mergeState:q?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:q?q.localChange:F.localChange,remoteChange:j?j.remoteChange:q?q.remoteChange:F.remoteChange})}}return{remoteUserData:c,lastSyncUserData:d,resourcePreviews:y,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(c.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&g&&d.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const w=d;if(w.content===null)return{ref:d.ref,syncData:null};const T=JSON.parse(w.content);if(s(T))return{...d,syncData:T,content:void 0}}catch(c){c instanceof b.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),w={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:g,...d};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(w)))}async getRemoteUserData(c){const{ref:d,content:g}=await this.getUserData(c);let w=null;return g!==null&&(w=this.parseSyncData(g)),{ref:d,syncData:w}}parseSyncData(c){try{const d=JSON.parse(c);if(s(d))return d}catch(d){this.logService.error(d)}throw new o.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:d}}else{const d=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(c,d){const g=await this.currentMachineIdPromise,w={version:this.version,machineId:g,content:c};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(w),d,this.syncHeaders),{ref:d,syncData:w}}async backupLocal(c){const d={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([X(1,b.IFileService),X(2,f.IEnvironmentService),X(3,C.IStorageService),X(4,o.IUserDataSyncStoreService),X(5,o.IUserDataSyncBackupStoreService),X(6,o.IUserDataSyncResourceEnablementService),X(7,v.ITelemetryService),X(8,o.IUserDataSyncLogService),X(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let a=class extends t{constructor(c,d,g,w,T,O,y,F,M,q,j){super(d,g,w,T,O,y,F,M,q,j);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,d,g){try{d?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(c),g?void 0:d):await this.fileService.createFile(this.file,R.VSBuffer.fromString(c),{overwrite:g})}catch(w){throw w instanceof b.FileOperationError&&w.fileOperationResult===1||w instanceof b.FileOperationError&&w.fileOperationResult===3?new o.UserDataSyncError(w.message,"LocalPreconditionFailed"):w}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};a=fe([X(2,b.IFileService),X(3,f.IEnvironmentService),X(4,C.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,u.IConfigurationService)],a),e.AbstractFileSynchroniser=a;let n=class extends a{constructor(c,d,g,w,T,O,y,F,M,q,j,U){super(c,d,g,w,T,O,y,F,M,q,U);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(c){const d=[];return(0,P.parse)(c,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=fe([X(2,b.IFileService),X(3,f.IEnvironmentService),X(4,C.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,o.IUserDataSyncUtilService),X(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let r=class{constructor(c,d,g,w){this.resource=c,this.environmentService=d,this.logService=g,this.fileService=w,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,d,E.extUri)}async initialize({ref:c,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(d);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:g})}catch(T){this.logService.error(T)}}parseSyncData(c){try{const d=JSON.parse(c);if(s(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,d={}){const g={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...d};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(g)))}};r=fe([X(1,f.IEnvironmentService),X(2,o.IUserDataSyncLogService),X(3,b.IFileService)],r),e.AbstractInitializer=r}),define(te[199],ne([0,1,6,11,3,43,48,24,5,20,12,27,31,13,21,22,47,196,87,88,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(l,c){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const g=(await c.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of d)l.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),l.version===2&&g.every(T=>!(0,h.areSameExtensions)(T.identifier,w.identifier))&&(w.installed=!0)}return d}function t(l,c,d){const g=d.get((0,h.getExtensionId)(l,c),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function a(l,c,d,g){g.store((0,h.getExtensionId)(l,c),JSON.stringify(d),0,1)}e.storeExtensionStorageState=a;let n=class at extends b.AbstractSynchroniser{constructor(c,d,g,w,T,O,y,F,M,q,j,U,z,V){super("extensions",d,c,g,w,T,U,z,M,j);this.storageService=g,this.extensionManagementService=O,this.extensionEnablementService=y,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=q,this.extensionsStorageSyncService=V,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:B})=>!!B)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,d){const g=c.syncData?await s(c.syncData,this.extensionManagementService):null,w=d?.skippedExtensions||[],T=d?.syncData?await s(d.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(),y=this.getLocalExtensions(O),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:q}=(0,S.merge)(y,g,T,w,F),j={local:M,remote:q,content:this.getPreviewContent(y,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:q!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(y),localExtensions:y,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,d,g,w){const T=[...d,...g],O=new Set,y=F=>{O.add(F.id.toLowerCase()),F.uuid&&O.add(F.uuid)};T.forEach(({identifier:F})=>y(F)),w.forEach(y);for(const F of c)O.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&O.has(F.identifier.uuid)||T.push(F);return this.format(T)}async getMergeResult(c,d){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,d,g,w){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(d,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(c){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),w=(0,S.merge)(c.localExtensions,null,null,c.skippedExtensions,g),{local:T,remote:O}=w;return{content:c.localContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(c){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),w=c.remoteContent?JSON.parse(c.remoteContent):null;if(w!==null){const T=(0,S.merge)(c.localExtensions,w,c.localExtensions,[],g),{local:O,remote:y}=T;return{content:c.remoteContent,local:O,remote:y,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:y!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,d,g,w){let{skippedExtensions:T,localExtensions:O}=g[0][0],{local:y,remote:F,localChange:M,remoteChange:q}=g[0][1];if(M===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(O)),T=await this.updateLocalExtensions(y.added,y.removed,y.updated,T)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const j=JSON.stringify(F.all);c=await this.updateRemoteUserData(j,w?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(U=>U.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(U=>U.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(U=>U.identifier.id))}.`:""}`)}d?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:T}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${T.length?` Skipped: ${JSON.stringify(T.map(j=>j.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),T=this.getLocalExtensions(g).filter(O=>!w.some(y=>(0,h.areSameExtensions)({id:y},O.identifier)));return this.format(T)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let d=await super.resolveContent(c);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(c)),d){const g=this.parseSyncData(d);if(g)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(c){c.sort((w,T)=>!w.identifier.uuid&&T.identifier.uuid?-1:w.identifier.uuid&&!T.identifier.uuid?1:(0,P.compare)(w.identifier.id,T.identifier.id));const d=JSON.stringify(c),g=(0,k.format)(d,void 0,{});return(0,A.applyEdits)(d,g)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(g=>g.installed||g.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,d,g,w){const T=[],O=[],y=await this.extensionManagementService.getInstalled();if(d.length){const M=y.filter(({identifier:q,isBuiltin:j})=>!j&&d.some(U=>(0,h.areSameExtensions)(q,U)));await D.Promises.settled(M.map(async q=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,q.identifier.id),await this.extensionManagementService.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,q.identifier.id),T.push(q.identifier)}))}(c.length||g.length)&&await D.Promises.settled([...c,...g].map(async M=>{const q=y.find(U=>(0,h.areSameExtensions)(U.identifier,M.identifier));if(q&&q.isBuiltin){M.state&&q.manifest.version===M.version&&this.updateExtensionState(M.state,q.manifest.publisher,q.manifest.name,q.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),T.push(M.identifier);return}const j=await this.extensionGalleryService.getCompatibleExtension(M.identifier,I.CURRENT_TARGET_PLATFORM);if(M.state&&(q?q.manifest.version===M.version:!!j)){const U=q?q.manifest.publisher:j.publisher,z=q?q.manifest.name:j.name;this.updateExtensionState(M.state,U,z,q?.manifest.version)}if(j)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,j.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,j.version)),q||(await this.extensionManagementService.canInstall(j)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,j.version),await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,j.version),T.push(j.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),O.push(M)))}catch(U){O.push(M),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.identifier.id),O.push(M)}));const F=[];for(const M of w)T.some(q=>(0,h.areSameExtensions)(q,M.identifier))||F.push(M);for(const M of O)F.some(q=>(0,h.areSameExtensions)(q.identifier,M.identifier))||F.push(M);return F}updateExtensionState(c,d,g,w){const T=t(d,g,this.storageService),O=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,h.getGalleryExtensionId)(d,g),version:w}):void 0;O?O.forEach(y=>{T[y]=c[y]}):Object.keys(c).forEach(y=>T[y]=c[y]),a(d,g,T,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const d=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:g,isBuiltin:w,manifest:T})=>{const O={identifier:g,version:T.version};d.some(y=>(0,h.areSameExtensions)(y,g))&&(O.disabled=!0),w||(O.installed=!0);try{const y=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:T.version});if(y){const F=t(T.publisher,T.name,this.storageService);O.state=Object.keys(F).reduce((M,q)=>(y.includes(q)&&(M[q]=F[q]),M),{})}}catch(y){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(y))}return O})}};n.EXTENSIONS_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=fe([X(0,i.IEnvironmentService),X(1,p.IFileService),X(2,u.IStorageService),X(3,o.IUserDataSyncStoreService),X(4,o.IUserDataSyncBackupStoreService),X(5,I.IExtensionManagementService),X(6,I.IGlobalExtensionEnablementService),X(7,v.IIgnoredExtensionsManagementService),X(8,o.IUserDataSyncLogService),X(9,I.IExtensionGalleryService),X(10,E.IConfigurationService),X(11,o.IUserDataSyncResourceEnablementService),X(12,f.ITelemetryService),X(13,C.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let r=class extends b.AbstractInitializer{constructor(c,d,g,w,T){super("extensions",w,T,g);this.extensionManagementService=c,this.ignoredExtensionsManagementService=d}async parseExtensions(c){return c.syncData?await s(c.syncData,this.extensionManagementService):null}generatePreview(c,d){const g=[],w=[],T=[];for(const O of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const y=d.find(F=>(0,h.areSameExtensions)(F.identifier,O.identifier));y?(g.push(y),O.disabled&&T.push(O.identifier)):O.installed&&(w.push(O.identifier),O.disabled&&T.push(O.identifier))}return{installedExtensions:g,newExtensions:w,disabledExtensions:T,remoteExtensions:c}}};r=fe([X(0,I.IExtensionManagementService),X(1,v.IIgnoredExtensionsManagementService),X(2,p.IFileService),X(3,i.IEnvironmentService),X(4,o.IUserDataSyncLogService)],r),e.AbstractExtensionsInitializer=r}),define(te[200],ne([0,1,26,23]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,E,i,I){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=A(P,m);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=E?A(E,m):{added:Object.keys(m).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},u=E?A(E,P):{added:Object.keys(P).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},b=D.deepClone(m),S=!E;for(const C of u.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&S&&p.added.has(C)||(b[C]=P[C]);for(const C of u.updated.values())b[C]=P[C];for(const C of u.removed.values())i.unregistered.includes(C)||delete b[C];for(const C of p.added.values()){const v=m[C];if(i.machine.includes(C)){I.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(E&&u.added.has(C))continue;const o=P[C];o&&o.value===v.value||C===L.SYNC_SERVICE_URL_TYPE&&S&&u.added.has(C)||(o?f.updated[C]=v:f.added[C]=v)}for(const C of p.updated.values()){const v=m[C];if(i.machine.includes(C)){I.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(C)||u.removed.has(C))continue;const o=P[C];o&&o.value===v.value||(f.updated[C]=v)}for(const C of p.removed.values()){if(i.machine.includes(C)){I.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}u.updated.has(C)||u.removed.has(C)||f.removed.push(C)}return{local:f,remote:k(b,m)?null:b}}e.merge=R;function A(P,m){const E=Object.keys(P),i=Object.keys(m),I=i.filter(u=>E.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),h=E.filter(u=>i.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),p=new Set;for(const u of E){if(h.has(u))continue;const f=P[u],b=m[u];D.equals(f,b)||p.add(u)}return{added:I,removed:h,updated:p}}function k(P,m){const{added:E,removed:i,updated:I}=A(P,m);return E.size===0&&i.size===0&&I.size===0}}),define(te[201],ne([0,1,25,3,33,43,48,4,5,30,20,12,13,14,45,21,22,47,54,200,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function a(d){const g=d.storage?Object.keys(d.storage).sort():[],w={};g.forEach(y=>w[y]=d.storage[y]),d.storage=w;const T=JSON.stringify(d),O=(0,k.format)(T,void 0,{});return(0,A.applyEdits)(T,O)}const n=1;let r=class ot extends S.AbstractSynchroniser{constructor(g,w,T,O,y,F,M,q,j){super("globalState",g,y,j,w,T,F,M,O,q);this.storageService=j,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(g.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:j.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,T,O){const y=g.syncData?JSON.parse(g.syncData.content):null;w=w===null&&T?g:w;const F=w&&w.syncData?JSON.parse(w.syncData.content):null,M=await this.getLocalGlobalState();y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=this.getStorageKeys(F),{local:j,remote:U}=(0,v.merge)(M.storage,y?y.storage:null,F?F.storage:null,q,this.logService),z={content:null,local:j,remote:U,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:a(M),localUserData:M,remoteResource:this.remoteResource,remoteContent:y?a(y):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async getMergeResult(g,w){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,w,T,O){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(w,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const w=JSON.parse(g.remoteContent),{local:T,remote:O}=(0,v.merge)(g.localUserData.storage,w.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:T,remote:O,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,w,T,O){let{localUserData:y}=T[0][0],{local:F,remote:M,localChange:q,remoteChange:j}=T[0][1];if(q===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(y)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:M});g=await this.updateRemoteUserData(U,O?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const T=await this.getLocalGlobalState();return a(T)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const T=this.parseSyncData(w);if(T)switch(this.extUri.basename(g)){case"globalState.json":return a(JSON.parse(T.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${s}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},w=await this.getLocalArgvContent(),T=(0,R.parse)(w);for(const O of t)T[O]!==void 0&&(g[`${s}${O}`]={version:1,value:T[O]});for(const O of this.storageService.keys(0,0)){const y=this.storageService.get(O,0);y&&(g[O]={version:1,value:y})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:w,updated:T}){const O={},y={},F=(q,j)=>{for(const U of q){if(U.startsWith(s)){O[U.substring(s.length)]=j?j[U].value:void 0;continue}if(j){const z=j[U];z.value!==String(this.storageService.get(U,0))&&(y[U]=z.value)}else this.storageService.get(U,0)!==void 0&&(y[U]=void 0)}};if(F(Object.keys(g),g),F(Object.keys(T),T),F(w),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(y).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const q of Object.keys(y))this.storageService.store(q,y[q],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(y))}}async updateArgv(g){const w=await this.getLocalArgvContent();let T=w;for(const O of Object.keys(g))T=(0,C.edit)(T,[O],g[O],{});w!==T&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(T)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const w=this.storageService.keys(0,0),T=this.storageService.keys(0,1),O=[...w,...T],y=g?.storage?Object.keys(g.storage).filter(F=>!F.startsWith(s)&&!O.includes(F)&&this.storageService.get(F,0)!==void 0):[];if(!P.isWeb){const F=[...o.ALL_SYNC_RESOURCES.map(M=>(0,o.getEnablementKey)(M)),o.SYNC_SERVICE_URL_TYPE];y.push(...F),T.push(...F)}return{user:w,machine:T,unregistered:y}}};r.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=fe([X(0,h.IFileService),X(1,o.IUserDataSyncStoreService),X(2,o.IUserDataSyncBackupStoreService),X(3,o.IUserDataSyncLogService),X(4,I.IEnvironmentService),X(5,o.IUserDataSyncResourceEnablementService),X(6,b.ITelemetryService),X(7,i.IConfigurationService),X(8,f.IStorageService)],r),e.GlobalStateSynchroniser=r;let l=class extends S.AbstractInitializer{constructor(g,w,T,O){super("globalState",T,O,w);this.storageService=g}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const T={},O={};for(const y of Object.keys(w.storage))y.startsWith(s)?T[y.substring(s.length)]=w.storage[y].value:this.storageService.get(y,0)===void 0&&(O[y]=w.storage[y].value);if(Object.keys(T).length){let y="{}";try{y=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(F){}for(const F of Object.keys(T))y=(0,C.edit)(y,[F],T[F],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(y))}if(Object.keys(O).length)for(const y of Object.keys(O))this.storageService.store(y,O[y],0,0)}};l=fe([X(0,f.IStorageService),X(1,h.IFileService),X(2,I.IEnvironmentService),X(3,o.IUserDataSyncLogService)],l),e.GlobalStateInitializer=l;let c=class{constructor(g,w,T,O,y){this.userDataSyncStoreClient=g,this.storageService=w,this.environmentService=T,this.fileService=O,this.logService=y}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const w=(0,o.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(g,w)}catch(T){if(T instanceof o.UserDataSyncError)switch(T.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,w)}throw T}}async doSync(g,w){const T=await this.userDataSyncStoreClient.read("globalState",null,w),O=this.parseGlobalState(T)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:g,version:n};const y=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:n,machineId:y,content:a(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(F),T.ref,w)}parseGlobalState({content:g}){if(!g)return null;const w=JSON.parse(g);if((0,S.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};c=fe([X(1,f.IStorageService),X(2,I.IEnvironmentService),X(3,h.IFileService),X(4,p.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(te[202],ne([0,1,18,25,3,33,4,16,129,20,12,13,21,22,47,197,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(o,s){const t=JSON.parse(o);if(!s)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=S;let C=class extends u.AbstractJsonFileSynchroniser{constructor(s,t,a,n,r,l,c,d,g,w){super(c.keybindingsResource,"keybindings",l,c,d,s,t,r,w,a,g,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,a,n){const r=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;t=t===null&&a?s:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),d=await this.getFormattingOptions();let g=null,w=!1,T=!1,O=!1;if(r){let F=c?c.value.toString():"[]";if(F=F||"[]",this.hasErrors(F))throw new b.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==F||l!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const M=await(0,f.merge)(F,r,l,d,this.userDataSyncUtilService);M.hasChanges&&(g=M.mergeContent,O=M.hasConflicts,w=O||M.mergeContent!==F,T=O||M.mergeContent!==r)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=c.value.toString(),T=!0);const y={content:g,localChange:w?c?2:1:0,remoteChange:T?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:y.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:y.remoteChange,previewResource:this.previewResource,previewResult:y,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,a,n){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return a===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,a,n){const{fileContent:r}=a[0][0];let{content:l,localChange:c,remoteChange:d}=a[0][1];if(c===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new b.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(l||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(l||"[]",s.syncData?.content);s=await this.updateRemoteUserData(g,n?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,A.parse)(s.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const a=this.parseSyncData(t);if(a)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(a.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return S(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let a={};try{a=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete a.all:a.all=s,k.OS){case 2:a.mac=s;break;case 3:a.linux=s;break;case 1:a.windows=s;break}return JSON.stringify(a)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=fe([X(0,b.IUserDataSyncStoreService),X(1,b.IUserDataSyncBackupStoreService),X(2,b.IUserDataSyncLogService),X(3,E.IConfigurationService),X(4,b.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,i.IEnvironmentService),X(7,h.IStorageService),X(8,b.IUserDataSyncUtilService),X(9,p.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let v=class extends u.AbstractInitializer{constructor(s,t,a){super("keybindings",t,a,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,A.parse)(s.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return S(s,!0)}catch(t){return this.logService.error(t),null}}};v=fe([X(0,I.IFileService),X(1,i.IEnvironmentService),X(2,b.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(te[203],ne([0,1,18,33,43,48,26,54,23]),function(Y,e,D,L,R,A,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(c,d,g){let w=[];g?w=I(g):w=i(d);const T=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const y of w)y.startsWith("-")?O.push(y.substring(1)):T.push(y);return(0,D.distinct)([...c,...T].filter(y=>O.indexOf(y)===-1))}e.getIgnoredSettings=E;function i(c){let d=c.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=c.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:c.getValue("settingsSync.ignoredSettings")||[]}function I(c){const d=(0,L.parse)(c);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function h(c,d,g,w){if(g.length){const T=l(d),O=(0,L.parse)(d),y=(0,L.parse)(c),F=[];for(const M of g){const q=O[M],j=y[M];q===void 0?c=P.edit(c,[M],void 0,w):j!==void 0?c=P.edit(c,[M],q,w):F.push(s(M,T))}F.sort((M,q)=>M.startOffset-q.startOffset),F.forEach(M=>c=S(M.setting.key,d,c,w))}return c}e.updateIgnoredSettings=h;function p(c,d,g,w,T,O){const y=h(c,d,w,O),F=g!==y,M=g!==d;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:y,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:h(d,c,w,O),remoteContent:null,hasConflicts:!1};if(g===null&&f(c)){const Z=u(c,d,w)?null:h(d,c,w,O);return{conflictsSettings:[],localContent:Z,remoteContent:null,hasConflicts:!1}}let q=c,j=d;const U=(0,L.parse)(c),z=(0,L.parse)(d),V=g?(0,L.parse)(g):null,x=w.reduce((Z,se)=>(Z.add(se),Z),new Set),B=b(U,z,x),N=b(V,U,x),G=b(V,z,x),$=new Map,J=new Set,_=Z=>{J.add(Z);const se=T.filter(({key:le})=>le===Z)[0];se?(q=P.edit(q,[Z],se.value,O),j=P.edit(j,[Z],se.value,O)):$.set(Z,{key:Z,localValue:U[Z],remoteValue:z[Z]})};for(const Z of N.removed.values())G.updated.has(Z)?_(Z):j=P.edit(j,[Z],void 0,O);for(const Z of G.removed.values())J.has(Z)||(N.updated.has(Z)?_(Z):q=P.edit(q,[Z],void 0,O));for(const Z of N.updated.values())J.has(Z)||(G.updated.has(Z)?B.updated.has(Z)&&_(Z):j=P.edit(j,[Z],U[Z],O));for(const Z of G.updated.values())J.has(Z)||(N.updated.has(Z)?B.updated.has(Z)&&_(Z):q=P.edit(q,[Z],z[Z],O));for(const Z of N.added.values())J.has(Z)||(G.added.has(Z)?B.updated.has(Z)&&_(Z):j=S(Z,q,j,O));for(const Z of G.added.values())J.has(Z)||(N.added.has(Z)?B.updated.has(Z)&&_(Z):q=S(Z,j,q,O));const W=$.size>0||!u(q,j,w),K=W||!u(q,c,[]),Q=W||!u(j,d,[]);return{localContent:K?q:null,remoteContent:Q?j:null,conflictsSettings:[...$.values()],hasConflicts:W}}e.merge=p;function u(c,d,g){if(c===d)return!0;const w=(0,L.parse)(c),T=(0,L.parse)(d),O=g.reduce((M,q)=>(M.add(q),M),new Set),y=l(c).filter(M=>!(M.setting&&O.has(M.setting.key))),F=l(d).filter(M=>!(M.setting&&O.has(M.setting.key)));if(y.length!==F.length)return!1;for(let M=0;M<y.length;M++){const q=y[M],j=F[M];if(q.setting&&j.setting){if(q.setting.key!==j.setting.key||!k.equals(w[q.setting.key],T[q.setting.key]))return!1}else if(!q.setting&&!j.setting){if(q.value!==j.value)return!1}else return!1}return!0}e.areSame=u;function f(c){return c?l(c).length===0:!0}e.isEmpty=f;function b(c,d,g){const w=c?Object.keys(c).filter(M=>!g.has(M)):[],T=Object.keys(d).filter(M=>!g.has(M)),O=T.filter(M=>w.indexOf(M)===-1).reduce((M,q)=>(M.add(q),M),new Set),y=w.filter(M=>T.indexOf(M)===-1).reduce((M,q)=>(M.add(q),M),new Set),F=new Set;if(c)for(const M of w){if(y.has(M))continue;const q=c[M],j=d[M];k.equals(q,j)||F.add(M)}return{added:O,removed:y,updated:F}}function S(c,d,g,w){const T=(0,L.parse)(d),O=l(d),y=l(g),F=C(c,O,y);return v(g,c,T[c],F,y,w)}e.addSetting=S;function C(c,d,g){const w=d.findIndex(O=>O.setting?.key===c),T=d[w-1];if(T){if(T.setting){const y=s(T.setting.key,g);if(y)return{index:g.indexOf(y),insertAfter:!0}}else{const y=t(w,d);if(y){const F=s(y.setting.key,g);if(F){const M=a(g.indexOf(F),g),q=n(d,y,d[w]);if(M){const j=n(g,F,M),U=r(q,j);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.indexOf(M),insertAfter:!1}}else{const j=n(g,F,g[g.length-1]),U=r(q,j);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const O=d[w+1];if(O)if(O.setting){const y=s(O.setting.key,g);if(y)return{index:g.indexOf(y),insertAfter:!1}}else{const y=a(w,d);if(y){const F=s(y.setting.key,g);if(F){const M=t(g.indexOf(F),g),q=n(d,d[w],y);if(M){const j=n(g,M,F),U=r(q.reverse(),j.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:g.indexOf(M),insertAfter:!0}}else{const j=n(g,g[0],F),U=r(q.reverse(),j.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function v(c,d,g,w,T,O){let y;return w.index===-1?y=(0,R.setProperty)(c,[d],g,O):y=o(c,d,g,w,T,O).map(F=>(0,R.withFormatting)(c,F,O)[0]),(0,R.applyEdits)(c,y)}function o(c,d,g,w,T,O){const y=`${JSON.stringify(d)}: ${JSON.stringify(g)}`,F=(0,A.getEOL)(O,c),M=T[w.index];if(w.insertAfter){const q=[];if(M.setting)q.push({offset:M.endOffset,length:0,content:","+y});else{const j=a(w.index,T),U=t(w.index,T),z=U?.setting?.commaOffset;U&&z===void 0&&q.push({offset:U.endOffset,length:0,content:","});const V=z!==void 0&&z>M.endOffset;q.push({offset:V?z+1:M.endOffset,length:0,content:j?F+y+",":F+y})}return q}else{if(M.setting)return[{offset:M.startOffset,length:0,content:y+","}];const q=(T[w.index-1]&&!T[w.index-1].setting?F:"")+y+(a(w.index,T)?",":"")+F;return[{offset:M.startOffset,length:0,content:q}]}}function s(c,d){return d.filter(g=>g.setting?.key===c)[0]}function t(c,d){for(let g=c-1;g>=0;g--)if(d[g].setting)return d[g]}function a(c,d){for(let g=c+1;g<d.length;g++)if(d[g].setting)return d[g]}function n(c,d,g){const w=c.indexOf(d),T=c.indexOf(g);return c.filter((O,y)=>w<y&&y<T)}function r(c,d){if(c.length&&d.length){let g=0;for(;g<d.length&&g<c.length;g++)if(c[g].value!==d[g].value)return d[g-1];return d[g-1]}}function l(c){const d=[];let g=-1,w,T;const O={onObjectBegin:y=>{g++},onObjectProperty:(y,F,M)=>{g===0&&(w=F,T=y)},onObjectEnd:(y,F)=>{g--,g===0&&d.push({startOffset:w,endOffset:y+F,value:c.substring(w,y+F),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(y,F)=>{g++},onArrayEnd:(y,F)=>{g--,g===0&&d.push({startOffset:w,endOffset:y+F,value:c.substring(w,y+F),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(y,F,M)=>{g===0&&d.push({startOffset:w,endOffset:F+M,value:c.substring(w,F+M),setting:{key:T,commaOffset:void 0}})},onSeparator:(y,F,M)=>{if(g===0&&y===","){let q=d.length-1;for(;q>=0&&!d[q].setting;q--);const j=d[q];j&&d.splice(q,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:F}})}},onComment:(y,F)=>{g===0&&d.push({startOffset:y,endOffset:y+F,value:c.substring(y,y+F)})}};return(0,L.visit)(c,O),d}}),define(te[204],ne([0,1,25,3,43,130,20,12,27,13,21,22,47,54,203,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function b(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function S(s){const t=JSON.parse(s);return b(t)?t:{settings:s}}e.parseSettingsSyncContent=S;let C=class extends h.AbstractJsonFileSynchroniser{constructor(t,a,n,r,l,c,d,g,w,T,O){super(a.settingsResource,"settings",t,a,n,r,l,w,T,c,d,g);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,a,n,r){const l=await this.getLocalFileContent(),c=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t);a=a===null&&n?t:a;const g=a?this.getSettingsSyncContent(a):null,w=await this.getIgnoredSettings();let T=null,O=!1,y=!1,F=!1;if(d){let q=l?l.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,u.merge)(q,d.settings,g?g.settings:null,w,[],c);T=j.localContent||j.remoteContent,O=j.localContent!==null,y=j.remoteContent!==null,F=j.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),T=l.value.toString(),y=!0);const M={content:T,localChange:O?2:0,remoteChange:y?2:0,hasConflicts:F};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:d?d.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async getMergeResult(t,a){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",r,n):null}}async getAcceptResult(t,a,n,r){const l=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",c,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(t,a,n,r){const{fileContent:l}=n[0][0];let{content:c,localChange:d,remoteChange:g}=n[0][1];if(d===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(c,l,r),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const w=await this.getFormattingOptions(),T=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(c);c=(0,u.updateIgnoredSettings)(c,T?T.settings:"{}",O,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),r?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}a?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const a=await this.getFormattingOptions(),n=(0,p.edit)(t.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:a}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let a=await super.resolveContent(t);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(t)),a){const n=this.parseSyncData(a);if(n){const r=this.parseSettingsSyncContent(n.content);if(r)switch(this.extUri.basename(t)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(t){let a=await super.resolvePreviewContent(t);if(a){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();a=(0,u.updateIgnoredSettings)(a,"{}",r,n)}return a}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return S(t)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:l})=>!!l)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(a,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new f.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const a=JSON.parse(t.value.toString());if(!o(a))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(a.content);if(!n||!n.settings)return;let r=n.settings;const l=await this.getFormattingOptions();for(const c in a)if(["version","content","machineId"].indexOf(c)===-1&&a[c]!==void 0){const d=(0,R.setProperty)(r,[c],a[c],l);d.length&&(r=(0,R.applyEdits)(r,d))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(r))}catch(t){}}};C=fe([X(0,E.IFileService),X(1,P.IEnvironmentService),X(2,i.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,f.IUserDataSyncUtilService),X(7,k.IConfigurationService),X(8,f.IUserDataSyncResourceEnablementService),X(9,I.ITelemetryService),X(10,m.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let v=class extends h.AbstractInitializer{constructor(t,a,n){super("settings",a,n,t)}async doInitialize(t){const a=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return S(t)}catch(a){this.logService.error(a)}return null}};v=fe([X(0,E.IFileService),X(1,P.IEnvironmentService),X(2,f.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function o(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(te[205],ne([0,1,25,3,26,20,12,13,21,22,47,198,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let p=class extends i.AbstractSynchroniser{constructor(b,S,C,v,o,s,t,a,n){super("snippets",S,b,C,v,o,a,n,s,t);this.version=1,this.snippetsFolder=b.snippetsHome,this._register(this.fileService.watch(b.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(b,S,C,v){const o=await this.getSnippetsFileContents(),s=this.toSnippetsContents(o),t=b.syncData?this.parseSnippets(b.syncData):null;S=S===null&&C?b:S;const a=S&&S.syncData?this.parseSnippets(S.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,I.merge)(s,t,a);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(b,S){return b.previewResult}async getAcceptResult(b,S,C,v){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return C===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:C,localChange:C===null?b.fileContent!==null?3:0:2,remoteChange:C===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(b,S,C,v){const o=C.map(([s,t])=>({...s,acceptResult:t}));o.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,v)),o.some(({remoteChange:s})=>s!==0)&&(b=await this.updateRemoteSnippets(o,b,v)),S?.ref!==b.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(b),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(b,S,C){const v=new Map;for(const o of Object.keys(b.local.added)){const s={content:b.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};v.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.local.updated)){const s={content:b.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o],localContent:S[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o],localContent:S[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.added)){const s={content:b.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o],localContent:S[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b.remote.updated)){const s={content:b.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o],localContent:S[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of b.conflicts){const s={content:S[o]?S[o].value.toString():null,hasConflicts:!0,localChange:S[o]?2:1,remoteChange:C[o]?2:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o]||null,localContent:S[o]?S[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S))if(!v.has(o)){const s={content:S[o]?S[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[o]||null,localContent:S[o]?S[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:b}){let S=await super.resolveContent(b);if(S){const C=this.parseSyncData(S);if(C){const v=this.parseSnippets(C),o=[];for(const s of Object.keys(v)){const t=this.extUri.joinPath(b,s),a=this.extUri.joinPath(this.snippetsFolder,s),n=await this.fileService.exists(a);o.push({resource:t,comparableResource:n?a:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(b){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(b);let S=await super.resolveContent(b);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(b)),S){const C=this.parseSyncData(S);if(C)return this.parseSnippets(C)[this.extUri.basename(b)]||null}return null}async hasLocalData(){try{const b=await this.getSnippetsFileContents();if(Object.keys(b).length)return!0}catch(b){}return!1}async updateLocalBackup(b){const S={};for(const C of b)C.fileContent&&(S[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(b,S){for(const{fileContent:C,acceptResult:v,localResource:o,remoteResource:s,localChange:t}of b)if(t!==0){const a=s?this.extUri.basename(s):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,a);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(v.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(v.content),S?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(b,S,C){const v=S.syncData?this.parseSnippets(S.syncData):{},o=(0,R.deepClone)(v);for(const{acceptResult:s,localResource:t,remoteResource:a,remoteChange:n}of b)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(a);n===3?delete o[r]:o[r]=s.content}return(0,I.areSame)(v,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(o),C?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(b){return JSON.parse(b.content)}toSnippetsContents(b){const S={};for(const C of Object.keys(b))S[C]=b[C].value.toString();return S}async getSnippetsFileContents(){const b={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof P.FileOperationError&&C.fileOperationResult===1)return b;throw C}for(const C of S.children||[]){const v=C.resource,o=this.extUri.extname(v);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);b[s]=t}}return b}};p=fe([X(0,k.IEnvironmentService),X(1,P.IFileService),X(2,m.IStorageService),X(3,h.IUserDataSyncStoreService),X(4,h.IUserDataSyncBackupStoreService),X(5,h.IUserDataSyncLogService),X(6,A.IConfigurationService),X(7,h.IUserDataSyncResourceEnablementService),X(8,E.ITelemetryService)],p),e.SnippetsSynchroniser=p;let u=class extends i.AbstractInitializer{constructor(b,S,C){super("snippets",S,C,b)}async doInitialize(b){const S=b.syncData?JSON.parse(b.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(S)){const o=S[v];if(o){const s=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(s,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(b)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(b){return b.fileOperationResult===1}}};u=fe([X(0,P.IFileService),X(1,k.IEnvironmentService),X(2,h.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(te[60],ne([0,1,3,2,7,23]),function(Y,e,D,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};k=fe([X(0,A.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(te[206],ne([0,1,6,25,56,2,15,20,12,13,23]),function(Y,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends A.Disposable{constructor(p,u,f,b){super();this.environmentService=p,this.fileService=u,this.configurationService=f,this.logService=b,i.ALL_SYNC_RESOURCES.forEach(S=>this.cleanUpBackup(S))}async getAllRefs(p){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,p),f=await this.fileService.resolve(u);return f.children?f.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort().reverse().map(S=>({ref:S.name,created:this.getCreationTime(S)})):[]}async resolveContent(p,u){if(!u){const f=await this.getAllRefs(p);f.length&&(u=f[f.length-1].ref)}if(u){const f=(0,k.joinPath)(this.environmentService.userDataSyncHome,p,u);return(await this.fileService.readFile(f)).value.toString()}return null}async backup(p,u){const f=(0,k.joinPath)(this.environmentService.userDataSyncHome,p),b=(0,k.joinPath)(f,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(b,L.VSBuffer.fromString(u))}catch(S){this.logService.error(S)}try{this.cleanUpBackup(p)}catch(S){}}async cleanUpBackup(p){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(u))return}catch(b){return}const f=await this.fileService.resolve(u);if(f.children){const b=f.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),S=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=b.filter(o=>Date.now()-this.getCreationTime(o)>S);const v=b.length-C.length;v<10&&(C=C.slice(10-v)),await D.Promises.settled(C.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(f){this.logService.error(f)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};I=fe([X(0,m.IEnvironmentService),X(1,E.IFileService),X(2,P.IConfigurationService),X(3,i.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[207],ne([0,1,2,5]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(h){this.service=h}listen(h,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(h,p,u){switch(p){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class A{constructor(h){this.service=h}listen(h,p){throw new Error(`Event not found: ${p}`)}call(h,p,u){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class k{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(h){this.service=h}listen(h,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(h,p,u){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(h){this.service=h}listen(h,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(h,p,u){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class E{constructor(h){this.service=h}listen(h,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(h,p,u){switch(p){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class i extends D.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:L.URI.revive(h.url),type:h.type,defaultUrl:L.URI.revive(h.defaultUrl),insidersUrl:L.URI.revive(h.insidersUrl),stableUrl:L.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[208],ne([0,1,12,14]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=fe([X(0,L.ILoggerService),X(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[61],ne([0,1,3,2,4,24,133,12,13,7,28,45,21,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let f=class Ye extends L.Disposable{constructor(S,C,v,o,s,t){super();this.storageService=v,this.userDataSyncStoreService=o,this.logService=s,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(S,C,v)}async getMachines(S){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(S)).machines.map(o=>({...o,isCurrent:o.id===C}))}async addCurrentMachine(S){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(S);v.machines.some(({id:o})=>o===C)||(v.machines.push({id:C,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(S){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(S),o=v.machines.filter(({id:s})=>s!==C);o.length!==v.machines.length&&(v.machines=o,await this.writeMachinesData(v))}async renameMachine(S,C,v){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(v),t=s.machines.find(({id:a})=>a===S);t&&(t.name=C,await this.writeMachinesData(s),s.machines.some(({id:a})=>a===o)&&this.storageService.store(u,C,0,1))}async setEnablement(S,C){const v=await this.readMachinesData(),o=v.machines.find(({id:s})=>s===S);o&&(o.disabled=C?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(S){const C=this.storageService.get(u,0);if(C)return C;const v=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,A.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let s=0;for(const t of S){const a=o.exec(t.name),n=a?parseInt(a[1]):0;s=n>s?n:s}return`${v} #${s+1}`}async readMachinesData(S){this.userData=await this.readUserData(S);const C=this.parse(this.userData);if(C.version!==Ye.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(S){const C=JSON.stringify(S),v=await this.userDataSyncStoreService.write(Ye.RESOURCE,C,this.userData?.ref||null);this.userData={ref:v,content:C},this._onDidChange.fire()}async readUserData(S){if(this.userData){const C=S&&S.latest?S.latest[Ye.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ye.RESOURCE,this.userData)}parse(S){if(S.content!==null)try{return JSON.parse(S.content)}catch(C){this.logService.error(C)}return{version:Ye.VERSION,machines:[]}}};f.VERSION=1,f.RESOURCE="machines",f=fe([X(0,P.IEnvironmentService),X(1,m.IFileService),X(2,h.IStorageService),X(3,p.IUserDataSyncStoreService),X(4,p.IUserDataSyncLogService),X(5,i.IProductService)],f),e.UserDataSyncMachinesService=f}),define(te[89],ne([0,1,6,56,37,11,3,2,4,15,5,131,12,28,21,22,23,60,61]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",o="sync.disableMachineEventually",s="sync.sessionId",t="sync.storeUrl",a="sync.productQuality";let n=class extends P.Disposable{constructor(d,g,w){super();this.storageService=d,this.environmentService=g,this.userDataSyncStoreManagementService=w,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(d.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||this.storageService.store(v,d,0,1)}onDidStorageChange(d){if(d.scope===0&&v===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=fe([X(0,u.IStorageService),X(1,h.IEnvironmentService),X(2,b.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends P.Disposable{constructor(d,g,w,T,O,y,F,M,q,j,U){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=w,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=O,this.logService=y,this.userDataSyncAccountService=F,this.telemetryService=M,this.userDataSyncMachinesService=q,this.storageService=j,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=d.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(w.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(z,V)=>z?[...z,V]:[V],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const d=this.storageService.get(t,0);return d?i.URI.parse(d):void 0}set syncUrl(d){d?this.storageService.store(t,d.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(a,0)}set productQuality(d){d?this.storageService.store(a,d,0,1):this.storageService.remove(a,0)}updateAutoSync(){const{enabled:d,message:g}=this.isAutoSyncEnabled();d?this.autoSync.value===void 0&&(this.autoSync.value=new l(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(w=>this.onDidFinishSync(w))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(d,g,w){try{this.userDataSyncAccountService.account&&!w&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),d?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(g)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(d){this.userDataAutoSyncEnablementService.isEnabled()!==d&&(this.telemetryService.publicLog2(v,{enabled:d}),this.userDataAutoSyncEnablementService.setEnablement(d),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(d){if(!d){this.successiveFailures=0;return}const g=b.UserDataSyncError.toUserDataSyncError(d);g instanceof b.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?m.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(d,g,w){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...d),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",w)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=fe([X(0,p.IProductService),X(1,b.IUserDataSyncStoreManagementService),X(2,b.IUserDataSyncStoreService),X(3,b.IUserDataSyncResourceEnablementService),X(4,b.IUserDataSyncService),X(5,b.IUserDataSyncLogService),X(6,S.IUserDataSyncAccountService),X(7,f.ITelemetryService),X(8,C.IUserDataSyncMachinesService),X(9,u.IStorageService),X(10,b.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class l extends P.Disposable{constructor(d,g,w,T,O,y,F,M){super();this.lastSyncUrl=d,this.interval=g,this.userDataSyncStoreManagementService=w,this.userDataSyncStoreService=T,this.userDataSyncService=O,this.userDataSyncMachinesService=y,this.logService=F,this.storageService=M,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(l.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(l.INTERVAL_SYNCING,!1),this.interval)}sync(d,g){const w=(0,D.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,A.isPromiseCanceledError)(O))return}return this.doSync(d,g,T)});return this.syncPromise=w,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const d=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!d&&(!(0,E.isEqual)(g.defaultUrl,d.defaultUrl)||!(0,E.isEqual)(g.insidersUrl,d.insidersUrl)||!(0,E.isEqual)(g.stableUrl,d.stableUrl))}async doSync(d,g,w){this.logService.info(`Auto Sync: Triggered by ${d}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),w.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const O=this.storageService.get(s,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new b.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new b.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new b.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const y=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(w.isCancellationRequested)return;const F=y.find(M=>M.isCurrent);if(F?.disabled)throw new b.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new b.UserDataAutoSyncError((0,R.toErrorMessage)(M),M instanceof b.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(s,this.manifest.session,0,1),w.isCancellationRequested)return;F||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),T=O}this._onDidFinishSync.fire(T)}register(d){return super._register(d)}}l.INTERVAL_SYNCING="Interval"}),define(te[209],ne([0,1,3,2,4,21,22,23]),function(Y,e,D,L,R,A,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends L.Disposable{constructor(i,I){super();this.storageService=i,this.telemetryService=I,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,I){if(this.isResourceEnabled(i)!==I){const h=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(h,{enabled:I}),this.storeResourceEnablement(h,I)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,I){this.storageService.store(i,I,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const I=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===i.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};m=fe([X(0,A.IStorageService),X(1,k.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(te[210],ne([0,1,18,6,37,11,3,2,15,30,7,21,22,199,201,202,204,205,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,r,l,c,d,g){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=r,this.instantiationService=l,this.logService=c,this.telemetryService=d,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(S.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(p.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,r){await this.checkEnablement();const l=(0,E.generateUuid)();try{const w=(0,C.createSyncHeaders)(l);r&&(w["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,w)}catch(w){const T=C.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(T,l),T}let c=!1;const d=this;let g;return{manifest:n,run(){if(c)throw new Error("Can run a task only once");return g=(0,L.createCancelablePromise)(w=>d.sync(n,l,w)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,E.generateUuid)(),r=(0,C.createSyncHeaders)(n);let l;try{l=await this.userDataSyncStoreService.manifest(null,r)}catch(c){const d=C.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(d,n),d}return new s(n,l,r,this.synchronisers,this.logService)}async sync(n,r,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,C.createSyncHeaders)(r);for(const g of this.synchronisers){if(l.isCancellationRequested)return;try{await g.sync(n,d)}catch(w){let T=!1;if(w instanceof C.UserDataSyncError)switch(w.code){case"TooLarge":w=new C.UserDataSyncError(w.message,w.code,g.resource),T=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":T=!0;break}const O=C.UserDataSyncError.toUserDataSyncError(w);if(this.reportUserDataSyncError(O,r),T)throw O;this.logService.error(w),this.logService.error(`${g.resource}: ${(0,R.toErrorMessage)(w)}`),this._syncErrors.push([g.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(d){const g=C.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(g,r),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(r){this.logService.error(r)}}async replace(n){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(n))return}async accept(n,r,l,c){await this.checkEnablement();const d=this.getSynchroniser(n);await d.accept(r,l),c&&await d.apply(!1,(0,C.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(n){for(const r of this.synchronisers){const l=await r.resolveContent(n);if(l)return l}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,r){return this.getSynchroniser(n).getAssociatedResources(r)}getMachineId(n,r){return this.getSynchroniser(n).getMachineId(r)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of n)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(r){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const r=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([r,l],[c,d])=>r===r&&(0,D.equals)(l,d,(g,w)=>(0,m.isEqual)(g.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,r){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof C.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof C.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(r=>r.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=fe([X(0,C.IUserDataSyncStoreService),X(1,C.IUserDataSyncStoreManagementService),X(2,i.IInstantiationService),X(3,C.IUserDataSyncLogService),X(4,h.ITelemetryService),X(5,I.IStorageService)],o),e.UserDataSyncService=o;class s extends P.Disposable{constructor(n,r,l,c,d){super();this.id=n,this.manifest=r,this.syncHeaders=l,this.synchronisers=c,this.logService=d,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,r){try{return await this.performAction(n,l=>l.accept(n,r))}catch(l){throw this.logService.error(l),l}}async merge(n){try{return n?await this.performAction(n,r=>r.merge(n)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(n){try{return await this.performAction(n,r=>r.discard(n))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,r]of this.previews)for(const l of r.resourcePreviews)l.mergeState==="conflict"&&n.push(l.previewResource);for(const r of n)await this.discard(r);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[r,l]of this.previews){this.synchronizingResources.push([r,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(g=>g.resource===r);for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await c.merge(g.previewResource);const d=await c.apply(!1,this.syncHeaders);d&&n.push(this.toSyncResourcePreview(c.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(c=>c.resource===n);for(const c of r.resourcePreviews)await l.accept(c.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(c=>c.resource===n);for(const c of r.resourcePreviews)await l.accept(c.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(r){(0,A.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(n,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,F])=>F.resourcePreviews.some(({localResource:M,previewResource:q,remoteResource:j})=>(0,m.isEqual)(n,M)||(0,m.isEqual)(n,q)||(0,m.isEqual)(n,j)));if(l===-1)return this.previews;const[c,d]=this.previews[l],g=d.resourcePreviews.find(({localResource:F,remoteResource:M,previewResource:q})=>(0,m.isEqual)(F,n)||(0,m.isEqual)(M,n)||(0,m.isEqual)(q,n));if(!g)return this.previews;let w=this.synchronizingResources.find(F=>F[0]===c);w||(w=[c,[]],this.synchronizingResources.push(w)),w[1].some(F=>(0,m.isEqual)(F,g.localResource))||(w[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const T=this.synchronisers.find(F=>F.resource===this.previews[l][0]),O=await r(T);O?this.previews.splice(l,1,this.toSyncResourcePreview(T.resource,O)):this.previews.splice(l,1);const y=this.synchronizingResources.findIndex(F=>F[0]===c);return this.synchronizingResources[y][1].splice(w[1].findIndex(F=>(0,m.isEqual)(F,g.localResource)),1),w[1].length||(this.synchronizingResources.splice(y,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[r,l]of this.previews){this.synchronizingResources.push([r,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(g=>g.resource===r);let d=l;for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(d=await c.merge(g.previewResource));d&&n.push(this.toSyncResourcePreview(c.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const r=[];for(const l of this.synchronisers){if(n.isCancellationRequested)return[];const c=await l.preview(this.manifest,this.syncHeaders);c&&r.push(this.toSyncResourcePreview(l.resource,c))}return r}toSyncResourcePreview(n,r){return[n,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(a){return{localResource:a.localResource,previewResource:a.previewResource,remoteResource:a.remoteResource,acceptedResource:a.acceptedResource,localChange:a.localChange,remoteChange:a.remoteChange,mergeState:a.mergeState}}}),define(te[211],ne([0,1,3,2,16,5,23]),function(Y,e,D,L,R,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(I,h){this.service=I,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(I,h,p){try{return await this._call(I,h,p)}catch(u){throw this.logService.error(u),u}}async _call(I,h,p){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],A.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:A.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:A.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const u=h.substring("manualSync/".length),f=p[0],b=this.getManualSyncTask(f);switch(p=p.slice(1),u){case"preview":return b.preview();case"accept":return b.accept(A.URI.revive(p[0]),p[1]);case"merge":return b.merge(A.URI.revive(p[0]));case"discard":return b.discard(A.URI.revive(p[0]));case"discardConflicts":return b.discardConflicts();case"apply":return b.apply();case"pull":return b.pull();case"push":return b.push();case"stop":return b.stop();case"_getStatus":return b.status;case"dispose":return this.disposeManualSyncTask(b)}}throw new Error("Invalid call")}getManualSyncTask(I){const h=this.manualSyncTasks.get(this.createKey(I));if(!h)throw new Error(`Manual sync taks not found: ${I}`);return h.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,h=I.add(await this.service.createManualSyncTask());return I.add(h.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:p}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:I}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(I){I.dispose();const h=this.createKey(I.id);this.manualSyncTasks.get(h)?.disposables.dispose(),this.manualSyncTasks.delete(h)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=P;class m extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,p,u){return I.call(h,p,u).then(null,f=>{throw k.UserDataSyncError.toUserDataSyncError(f)})},listen(h,p){return I.listen(h,p)}},this.channel.call("_getInitialData").then(([h,p,u])=>{this.updateStatus(h),this.updateConflicts(p),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(f=>this.updateStatus(f))),this._register(this.channel.listen("onDidChangeLastSyncTime")(f=>this.updateLastSyncTime(f)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([p,u])=>[p,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:h,status:p}=await this.channel.call("createManualSyncTask"),u=this,f=new E(I,h,p,{async call(b,S,C){return u.channel.call(`manualSync/${b}`,[I,...(0,R.isArray)(S)?S:[S]],C)},listen(b,S){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${b}`,S),C=>!f.isDiposed()&&C.manualSyncTaskId===I),C=>C.data)}});return f}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,h,p,u){return this.channel.call("accept",[I,h,p,u])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:p,uri:u})=>({created:p,uri:A.URI.revive(u)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:p,uri:u})=>({created:p,uri:A.URI.revive(u)}))}async getAssociatedResources(I,h){return(await this.channel.call("getAssociatedResources",[I,h])).map(({resource:u,comparableResource:f})=>({resource:A.URI.revive(u),comparableResource:A.URI.revive(f)}))}async getMachineId(I,h){return this.channel.call("getMachineId",[I,h])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([h,p])=>[h,p.map(u=>({...u,localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=m;class E extends L.Disposable{constructor(I,h,p,u){super();this.id=I,this.manifest=h,this._disposed=!1,this._status=p;const f=this;this.channel={async call(b,S,C){try{const v=await u.call(b,S,C);return f.isDiposed()||(f._status=await u.call("_getStatus")),v}catch(v){throw k.UserDataSyncError.toUserDataSyncError(v)}},listen(b,S){return u.listen(b,S)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,h){const p=await this.channel.call("accept",[I,h]);return this.deserializePreviews(p)}async merge(I){const h=await this.channel.call("merge",[I]);return this.deserializePreviews(h)}async discard(I){const h=await this.channel.call("discard",[I]);return this.deserializePreviews(h)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([h,p])=>[h,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(u=>({...u,localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource),acceptedResource:A.URI.revive(u.acceptedResource)}))}])}}}),define(te[212],ne([0,1,6,29,11,3,2,95,4,15,16,5,30,20,12,13,28,42,45,21,23]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",r=100,l=1e3*60*5;let c=class extends k.Disposable{constructor(y,F,M){super();this.productService=y,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(M.onDidChangeValue,q=>q.key===o.SYNC_SERVICE_URL_TYPE&&q.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(y){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,y,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(y,F){y=m.isWeb&&y?.web?{...y,...y.web}:y;const M={...y||{},...F||{}};if(M&&(0,i.isString)(M.url)&&(0,i.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(q=>(0,i.isArray)(M.authenticationProviders[q].scopes))){const q=M,j=!!q.canSwitch&&!F?.url,U=q.url===q.insidersUrl?"insiders":"stable",z=(j?this.userDataSyncStoreType:void 0)||U,V=F?.url||(z==="insiders"?q.insidersUrl:z==="stable"?q.stableUrl:q.url);return{url:I.URI.parse(V),type:z,defaultType:U,defaultUrl:I.URI.parse(q.url),stableUrl:I.URI.parse(q.stableUrl),insidersUrl:I.URI.parse(q.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(q.authenticationProviders).reduce((x,B)=>(x.push({id:B,scopes:q.authenticationProviders[B].scopes}),x),[])}}}};c=fe([X(0,b.IProductService),X(1,p.IConfigurationService),X(2,v.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let d=class extends c{constructor(y,F,M){super(y,F,M);const q=this.storageService.get(s,0);q&&(this.previousConfigurationSyncStore=JSON.parse(q));const j=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];j?this.storageService.store(s,JSON.stringify(j),0,1):this.storageService.remove(s,0)}async switch(y){y!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=y,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};d=fe([X(0,b.IProductService),X(1,p.IConfigurationService),X(2,v.IStorageService)],d),e.UserDataSyncStoreManagementService=d;let g=class extends k.Disposable{constructor(y,F,M,q,j,U,z){super();this.requestService=M,this.logService=q,this.storageService=z,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(y),this.commonHeadersPromise=(0,C.getServiceMachineId)(j,U,z).then(V=>{const x={"X-Client-Name":`${F.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(x["X-Client-Commit"]=F.commit),x}),this.session=new T(r,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(y,F){this.authToken={token:y,type:F}}updateUserDataSyncStoreUrl(y){this.userDataSyncStoreUrl=y?(0,E.joinPath)(y,"v1"):void 0}initDonotMakeRequestsUntil(){const y=this.storageService.getNumber(t,0);y&&Date.now()<y&&this.setDonotMakeRequestsUntil(new Date(y))}setDonotMakeRequestsUntil(y){this._donotMakeRequestsUntil?.getTime()!==y?.getTime()&&(this._donotMakeRequestsUntil=y,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(y){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y),M={},q=await this.request(F.toString(),{type:"GET",headers:M},[],L.CancellationToken.None);return(await(0,S.asJson)(q)||[]).map(({url:U,created:z})=>({ref:(0,E.relativePath)(F,F.with({path:U})),created:z*1e3}))}async resolveContent(y,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y,F).toString(),q={};q["Cache-Control"]="no-cache";const j=await this.request(M,{type:"GET",headers:q},[],L.CancellationToken.None);return await(0,S.asText)(j)}async delete(y){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y).toString(),M={};await this.request(F,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async read(y,F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y,"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const j=await this.request(q,{type:"GET",headers:M},[304],L.CancellationToken.None);let U=null;if(j.res.statusCode===304&&(U=F),U===null){const z=j.res.headers.etag;if(!z)throw new o.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);const V=await(0,S.asText)(j);if(!V&&j.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",q,"EmptyResponse",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);U={ref:z,content:V}}return U}async write(y,F,M,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",y).toString();q={...q},q["Content-Type"]=P.Mimes.text,M&&(q["If-Match"]=M);const U=await this.request(j,{type:"POST",data:F,headers:q},[],L.CancellationToken.None),z=U.res.headers.etag;if(!z)throw new o.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",U.res.statusCode,U.res.headers[o.HEADER_OPERATION_ID]);return z}async manifest(y,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",y&&(F["If-None-Match"]=y.ref);const q=await this.request(M,{type:"GET",headers:F},[304],L.CancellationToken.None);let j=null;if(q.res.statusCode===304&&(j=y),!j){const z=q.res.headers.etag;if(!z)throw new o.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",q.res.statusCode,q.res.headers[o.HEADER_OPERATION_ID]);const V=await(0,S.asText)(q);if(!V&&q.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",M,"EmptyResponse",q.res.statusCode,q.res.headers[o.HEADER_OPERATION_ID]);V&&(j={...JSON.parse(V),ref:z})}const U=this.storageService.get(a,0);return U&&j&&U!==j.session&&this.clearSession(),j===null&&U&&this.clearSession(),j&&this.storageService.store(a,j.session,0,1),j}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const y=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.request(y,{type:"DELETE",headers:F},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(y,F,M,q){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",y,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of too many requests (429).`,y,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const j=await this.commonHeadersPromise;F.headers={...F.headers||{},...j,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:y,type:F.type,headers:{...F.headers,authorization:void 0}});let U;try{U=await this.session.request(y,F,q)}catch(B){if(!(B instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const G=(0,R.getErrorMessage)(B).toLowerCase();G.includes("xhr timeout")?N="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?N="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":G.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(B)&&(N="RequestCanceled"),B=new o.UserDataSyncStoreError(`Connection refused for the request '${y}'.`,y,N,void 0,void 0)}throw this.logService.info("Request failed",y),B}const z=U.res.headers[o.HEADER_OPERATION_ID],V={url:y,status:U.res.statusCode,"execution-id":F.headers[o.HEADER_EXECUTION_ID],"operation-id":z},x=(0,S.isSuccess)(U)||U.res.statusCode&&M.indexOf(U.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",V):this.logService.info("Request failed",V),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${y}' failed because of Unauthorized (401).`,y,"Unauthorized",U.res.statusCode,z);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,y,"Conflict",U.res.statusCode,z);if(U.res.statusCode===410)throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because the requested resource is not longer available (410).`,y,"Gone",U.res.statusCode,z);if(U.res.statusCode===412)throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,y,"PreconditionFailed",U.res.statusCode,z);if(U.res.statusCode===413)throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of too large payload (413).`,y,"TooLarge",U.res.statusCode,z);if(U.res.statusCode===426)throw new o.UserDataSyncStoreError(`${F.type} request '${y}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,y,"UpgradeRequired",U.res.statusCode,z);if(U.res.statusCode===429){const B=U.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of too many requests (429).`,y,"TooManyRequestsAndRetryAfter",U.res.statusCode,z)):new o.UserDataSyncStoreError(`${F.type} request '${y}' failed because of too many requests (429).`,y,"RemoteTooManyRequests",U.res.statusCode,z)}if(!x)throw new o.UserDataSyncStoreError("Server returned "+U.res.statusCode,y,"Unknown",U.res.statusCode,z);return U}addSessionHeaders(y){let F=this.storageService.get(n,0);F===void 0&&(F=(0,h.generateUuid)(),this.storageService.store(n,F,0,1)),y["X-Machine-Session-Id"]=F;const M=this.storageService.get(a,0);M!==void 0&&(y["X-User-Session-Id"]=M)}};g=fe([X(1,b.IProductService),X(2,S.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,f.IFileService),X(6,v.IStorageService)],g),e.UserDataSyncStoreClient=g;let w=class extends g{constructor(y,F,M,q,j,U,z){super(y.userDataSyncStore?.url,F,M,q,j,U,z);this._register(y.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(y.userDataSyncStore?.url)))}};w=fe([X(0,o.IUserDataSyncStoreManagementService),X(1,b.IProductService),X(2,S.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,f.IFileService),X(6,v.IStorageService)],w),e.UserDataSyncStoreService=w;class T{constructor(y,F,M,q){this.limit=y,this.interval=F,this.requestService=M,this.logService=q,this.requests=[],this.startTime=void 0}request(y,F,M){if(this.isExpired()&&this.reset(),F.url=y,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,y,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(y),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[213],ne([0,1,3,59,28,21,22,89,23,60,61]),function(Y,e,D,L,R,A,k,P,m,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends P.UserDataAutoSyncService{constructor(p,u,f,b,S,C,v,o,s,t,a,n){super(p,u,f,b,S,v,o,s,t,a,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(C.onDidFocusWindow,()=>"windowFocus"),D.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(r,l)=>r?[...r,l]:[l],1e3)(r=>this.triggerSync(r,!0,!1)))}};I=fe([X(0,R.IProductService),X(1,m.IUserDataSyncStoreManagementService),X(2,m.IUserDataSyncStoreService),X(3,m.IUserDataSyncResourceEnablementService),X(4,m.IUserDataSyncService),X(5,L.INativeHostService),X(6,m.IUserDataSyncLogService),X(7,E.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,A.IStorageService),X(11,m.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[214],ne([0,1,6,3,2]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(te[62],ne([0,1,51,6,8,16,19,110,222,223]),function(Y,e,D,L,R,A,k,P,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,a){let n=a.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=a}}e.ExtractError=i;function I(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(a=>t&a).reduce((a,n)=>a+n,t&61440)}function h(s){if(s instanceof i)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new i(t,s)}function p(s,t,a,n,r,l){const c=R.dirname(t),d=R.join(n,c);if(!d.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const g=R.join(n,t);let w;return l.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(k.Promises.mkdir(d,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!l.isCancellationRequested)try{w=(0,D.createWriteStream)(g,{mode:a}),w.once("close",()=>T()),w.once("error",O),s.once("error",O),s.pipe(w)}catch(y){O(y)}}))}function u(s,t,a,n){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,d)=>{const g=new L.Sequencer,w=T=>{T.isCancellationRequested||(l++,s.readEntry())};s.once("error",d),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===l?c():d(new i("Incomplete",new Error(P.localize(1,null,l,s.entryCount))))},d)),s.readEntry(),s.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){w(n);return}const O=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const M=R.join(t,O);r=(0,L.createCancelablePromise)(q=>k.Promises.mkdir(M,{recursive:!0}).then(()=>w(q)).then(void 0,d));return}const y=b(s,T),F=I(T);r=(0,L.createCancelablePromise)(M=>g.queue(()=>y.then(q=>p(q,O,F,t,a,M).then(()=>w(M)))).then(null,d))})})}function f(s,t=!1){return new Promise((a,n)=>{(0,m.open)(s,t?{lazyEntries:!0}:void 0,(r,l)=>{r?n(h(r)):a((0,A.assertIsDefined)(l))})})}function b(s,t){return new Promise((a,n)=>{s.openReadStream(t,(r,l)=>{r?n(h(r)):a((0,A.assertIsDefined)(l))})})}function S(s,t){return new Promise((a,n)=>{const r=new E.ZipFile;t.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const l=(0,D.createWriteStream)(s);r.outputStream.pipe(l),r.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>a(s))})}e.zip=S;function C(s,t,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let l=f(s,!0);return a.overwrite&&(l=l.then(c=>k.Promises.rm(t).then(()=>c))),l.then(c=>u(c,t,{sourcePathRegex:r},n))}e.extract=C;function v(s,t){return f(s).then(a=>new Promise((n,r)=>{a.on("entry",l=>{l.fileName===t&&b(a,l).then(c=>n(c),c=>r(c))}),a.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function o(s,t){return v(s,t).then(a=>new Promise((n,r)=>{const l=[];a.once("error",r),a.on("data",c=>l.push(c)),a.on("end",()=>n(Buffer.concat(l)))}))}e.buffer=o}),define(te[215],ne([0,1,62,118]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(A){return(0,D.buffer)(A,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[216],ne([0,1,18,6,11,2,17,8,4,15,58,5,30,19,62,119,12,27,31,141,13,14,28]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const a="scanningSystem",n="scanningUser",r="extracting",l="deleting",c="renaming";let d=class extends A.Disposable{constructor(w,T,O,y,F){super();this.beforeRemovingExtension=w,this.fileService=T,this.logService=O,this.environmentService=y,this.productService=F,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const T=[];(w===null||w===0)&&T.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(O).message,a)))),(w===null||w===1)&&T.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(T);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[T,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(y=>!T[new C.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),w&&(O=(0,C.groupByExtension)(O,F=>F.identifier).map(F=>F.sort((M,q)=>i.rcompare(M.manifest.version,q.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,T,O,y){const F=w.key(),M=P.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),q=P.join(this.extensionsPath,F);try{await p.Promises.rm(q)}catch(U){try{await p.Promises.rm(q)}catch(z){}throw new S.ExtensionManagementError((0,f.localize)(0,null,q,w.id),l)}await this.extractAtLocation(w,T,M,y);let j=await this.scanExtension(I.URI.file(M),1);if(!j)throw new Error((0,f.localize)(1,null,M));await this.storeMetadata(j,{...O,installedTimestamp:Date.now()});try{await this.rename(w,M,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(U){try{await p.Promises.rm(M)}catch(z){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(U)}. Deleted from extracted location`,M),U}try{j=await this.scanExtension(I.URI.file(q),1)}catch(U){}if(j)return j;throw new Error((0,f.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,T){return this.setMetadata(w,T),await this.storeMetadata(w,{...T,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const O=P.join(w.location.fsPath,"package.json"),y=await p.Promises.readFile(O,"utf8"),{manifest:F}=await this.parseManifest(y);return F.__metadata=T,await p.Promises.writeFile(O,JSON.stringify(F,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const T=w.map(O=>new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{T.forEach(y=>O[y.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(y=>delete y[w.key()]);const O=(await this.scanExtensions(1)).find(y=>new C.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(w))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let O={};if(T)try{O=JSON.parse(T)}catch(y){}return w&&(w(O),Object.keys(O).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await p.Promises.rm(this.uninstalledPath)),O})}async removeExtension(w,T){this.logService.trace(`Deleting ${T} extension from disk`,w.identifier.id,w.location.fsPath),await p.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new C.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,T,O,y){this.logService.trace(`Started extracting the extension from ${T} to ${O}`);try{await p.Promises.rm(O)}catch(F){throw new S.ExtensionManagementError(this.joinErrors(F).message,l)}try{await(0,u.extract)(T,O,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${O}:`,w.id)}catch(F){try{await p.Promises.rm(O)}catch(M){}throw new S.ExtensionManagementError(F.message,F instanceof u.ExtractError&&F.type?F.type:r)}}async rename(w,T,O,y){try{await p.Promises.rename(T,O)}catch(F){if(m.isWindows&&F&&F.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${T} to ${O} with 'EPERM' error. Trying again...`,w.id),this.rename(w,T,O,y);throw new S.ExtensionManagementError(F.message||(0,f.localize)(3,null,T,O),F.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const T=this.scanDevSystemExtensions(),[O,y]=await Promise.all([w,T]);return[...O,...y]}async scanExtensionsInDir(w,T){const O=new L.Limiter(10),y=await this.fileService.resolve(I.URI.file(w));return y.children?(await Promise.all(y.children.filter(M=>M.isDirectory).map(M=>O.queue(async()=>T===1&&(0,E.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,T))))).filter(M=>M&&M.identifier):[]}async scanExtension(w,T){try{const O=await this.fileService.resolve(w);if(O.children){const{manifest:y,metadata:F}=await this.readManifest(w.fsPath),M=O.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,q=O.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource,j={id:(0,C.getGalleryExtensionId)(y.publisher,y.name)},U={type:T,identifier:j,manifest:y,location:w,readmeUrl:M,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return F&&(this.setMetadata(U,F),U.installedTimestamp=F.installedTimestamp),U}}catch(O){T!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(O=>w.some(y=>(0,C.areSameExtensions)(O.identifier,{id:y})))}else return[]}setMetadata(w,T){w.publisherDisplayName=T.publisherDisplayName||null,w.publisherId=T.publisherId||null,w.identifier.uuid=T.id,w.isMachineScoped=!!T.isMachineScoped,w.isBuiltin=w.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),O=new Set;for(const M of T)w[new C.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||O.add(M.identifier.id.toLowerCase());const y=(0,C.groupByExtension)(T,M=>M.identifier);await L.Promises.settled(y.map(async M=>{const q=M.sort((j,U)=>i.rcompare(j.manifest.version,U.manifest.version))[0];O.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(q)}));const F=T.filter(M=>w[new C.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await L.Promises.settled(F.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),T=[],O=(0,C.groupByExtension)(w,y=>y.identifier);T.push(...(0,D.flatten)(O.map(y=>y.sort((F,M)=>i.rcompare(F.manifest.version,M.manifest.version)).slice(1)))),await L.Promises.settled(T.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const T=Array.isArray(w)?w:[w];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((O,y)=>new Error(`${O.message}${O.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const T=[p.Promises.readFile(P.join(w,"package.json"),"utf8").then(M=>this.parseManifest(M)),p.Promises.readFile(P.join(w,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:O,metadata:y},F]=await Promise.all(T);return{manifest:(0,v.localizeManifest)(O,F),metadata:y}}parseManifest(w){return new Promise((T,O)=>{try{const y=JSON.parse(w),F=y.__metadata||null;T({manifest:y,metadata:F})}catch(y){O(new Error((0,f.localize)(4,null)))}})}};d=fe([X(1,o.IFileService),X(2,s.ILogService),X(3,b.INativeEnvironmentService),X(4,t.IProductService)],d),e.ExtensionsScanner=d}),define(te[217],ne([0,1,37,17,8,4,15,58,5,30,19,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,7,14,44,22]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o,s,t,a,n,r,l,c,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const w="unsetUninstalled",T="downloading";let O=class extends f.AbstractExtensionManagementService{constructor(U,z,V,x,B,N,G){super(U,z,V);this.environmentService=x,this.downloadService=B;const $=this._register(N.createInstance(v.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(t.ExtensionsScanner,_=>$.postUninstall(_))),this.manifestCache=this._register(new s.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(N.createInstance(C.ExtensionsDownloader));const J=this._register(new a.ExtensionsWatcher(this,G,x,V));this._register(J.onDidChangeExtensionsByAnotherSource(({added:_,removed:W})=>{_.length&&this._onDidInstallExtensions.fire(_.map(K=>({identifier:K.identifier,operation:0,local:K}))),W.forEach(K=>this._onDidUninstallExtension.fire({identifier:K}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const z=await this.collectFiles(U),V=await(0,I.zip)((0,k.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,z);return m.URI.file(V)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const z=await this.downloadVsix(U),V=R.resolve(z.fsPath);return(0,o.getManifest)(V)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,z={}){this.logService.trace("ExtensionManagementService#install",U.toString());const V=await this.downloadVsix(U),x=await(0,o.getManifest)(R.resolve(V.fsPath));if(x.engines&&x.engines.vscode&&!(0,n.isEngineValid)(x.engines.vscode,d.default.version,d.default.date))throw new Error(h.localize(0,null,(0,S.getGalleryExtensionId)(x.publisher,x.name),d.default.version));return this.installExtension(x,V,z)}async updateMetadata(U,z){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...z}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:z}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;const z=(0,k.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,z),z}createInstallExtensionTask(U,z,V){return m.URI.isUri(z)?new M(U,z,V,this.galleryService,this.extensionsScanner,this.logService):new F(z,V,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,z){return new q(U,z,this.extensionsScanner)}async collectFiles(U){const z=async x=>{let B=await i.Promises.readdir(x);B=B.map($=>R.join(x,$));const N=await Promise.all(B.map($=>i.Promises.stat($)));let G=Promise.resolve([]);return N.forEach(($,J)=>{const _=B[J];$.isFile()&&(G=G.then(W=>[...W,_])),$.isDirectory()&&(G=G.then(W=>z(_).then(K=>[...W,...K])))}),G};return(await z(U.location.fsPath)).map(x=>({path:`extension/${R.relative(U.location.fsPath,x)}`,localPath:x}))}};O=fe([X(0,b.IExtensionGalleryService),X(1,g.ITelemetryService),X(2,c.ILogService),X(3,u.INativeEnvironmentService),X(4,p.IDownloadService),X(5,l.IInstantiationService),X(6,r.IFileService)],O),e.ExtensionManagementService=O;class y extends f.AbstractExtensionTask{constructor(U,z,V,x){super();this.identifier=U,this.source=z,this.extensionsScanner=V,this.logService=x,this._operation=1}get operation(){return this._operation}async installExtension(U,z){try{const V=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(V)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(V,U.metadata):V}catch(V){throw A.isMacintosh?new b.ExtensionManagementError(h.localize(1,null),w):new b.ExtensionManagementError(h.localize(2,null),w)}return this.extract(U,z)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const V=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),V}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:z,metadata:V},x){let B=await this.extensionsScanner.extractUserExtension(z,U,V,x);return this.logService.info("Extracting completed.",z.id),B}}class F extends y{constructor(U,z,V,x,B){super(U.identifier,U,x,B);this.gallery=U,this.options=z,this.extensionsDownloader=V}async doRun(U){const V=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,S.areSameExtensions)(N.identifier,this.gallery.identifier));V&&(this._operation=2);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||V?.isBuiltin;const B=await this.installExtension(x,U);V&&P.neq(V.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(V);try{await this.extensionsDownloader.delete(m.URI.file(x.zipPath))}catch(N){}return B}async downloadInstallableExtension(U,z){const V={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",U.identifier.id),x=(await this.extensionsDownloader.downloadExtension(U,z)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,x)}catch(B){throw new b.ExtensionManagementError((0,f.joinErrors)(B).message,T)}try{const B=await(0,o.getManifest)(x);return{zipPath:x,identifierWithVersion:new S.ExtensionIdentifierWithVersion(U.identifier,B.version),metadata:V}}catch(B){throw new b.ExtensionManagementError((0,f.joinErrors)(B).message,f.INSTALL_ERROR_VALIDATING)}}}class M extends y{constructor(U,z,V,x,B,N){super({id:(0,S.getGalleryExtensionId)(U.publisher,U.name)},z,B,N);this.manifest=U,this.location=z,this.options=V,this.galleryService=x}async doRun(U){const z=new S.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(N=>(0,S.areSameExtensions)(this.identifier,N.identifier)),B=await this.getMetadata(this.identifier.id,U);if(B.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,B.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=2,z.equals(new S.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch(N){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const N=await this.unsetUninstalledAndGetLocal(z);if(N)try{await this.extensionsScanner.removeExtension(N,"existing")}catch(G){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:z,metadata:B},U)}async getMetadata(U,z){try{const V=(await this.galleryService.query({names:[U],pageSize:1},z)).firstPage[0];if(V)return{id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId}}catch(V){}return{}}}class q extends f.AbstractExtensionTask{constructor(U,z,V){super();this.extension=U,this.options=z,this.extensionsScanner=V}async doRun(U){const z=[],V=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new S.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);z.push(...V.filter(B=>x.equals(new S.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version))))}else z.push(...V.filter(x=>(0,S.areSameExtensions)(x.identifier,this.extension.identifier)));if(!z.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...z),this.options.remove)for(const x of z)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(B){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(B)))}}}}),define(te[224],ne([0,1,104,51,225,35,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,20,174,73,182,74,176,12,138,178,185,27,140,184,217,75,142,13,168,170,53,7,158,78,159,160,57,167,14,79,59,44,28,175,42,21,180,181,22,82,84,83,46,186,187,85,189,195,87,88,89,23,60,206,207,208,61,209,210,211,212,213,214]),function(Y,e,D,L,R,A,k,P,m,E,i,I,h,p,u,f,b,S,C,v,o,s,t,a,n,r,l,c,d,g,w,T,O,y,F,M,q,j,U,z,V,x,B,N,G,$,J,_,W,K,Q,Z,se,le,ce,ge,we,Se,ke,Re,Pe,Fe,De,Ae,We,Je,xe,qe,ee,re,ae,ye,ve,Te,Ce,Oe,Le,H,ie,oe,ue,de,Ee,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends m.Disposable{constructor(he){super();this.configuration=he,this.server=this._register(new p.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const he=()=>this.dispose();process.once("exit",he),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",he)}async open(){const he=await this.initServices();(0,ve.registerConfiguration)(),he.invokeFunction(Ue=>{const Me=Ue.get(K.ILogService);Me.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(Me)}),this._register((0,m.combinedDisposable)(he.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),he.createInstance(b.LanguagePackCachedDataCleaner),he.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),he.createInstance(C.LogsDataCleaner),he.createInstance(S.LocalizationsUpdater),he.createInstance(f.DeprecatedExtensionsCleaner)))}async initServices(){const he=new G.ServiceCollection,Ue={_serviceBrand:void 0,...se.default};he.set(le.IProductService,Ue);const Me=new h.StaticRouter(Be=>Be==="main"),Ne=new $.MessagePortMainProcessService(this.server,Me);he.set(J.IMainProcessService,Ne);const _e=new g.NativeEnvironmentService(this.configuration.args,Ue);he.set(d.INativeEnvironmentService,_e);const et=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",Me)),Ve=new Q.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Ne.getChannel("logger"));he.set(K.ILoggerService,Ve);const nt=this._register(new K.MultiplexLogService([this._register(new K.ConsoleLogger(this.configuration.logLevel)),this._register(Ve.createLogger((0,i.joinPath)(I.URI.file(_e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),He=this._register(new Q.FollowerLogService(et,nt));he.set(K.ILogService,He);const Ge=this._register(new z.FileService(He));he.set(U.IFileService,Ge);const it=this._register(new V.DiskFileSystemProvider(He));Ge.registerProvider(E.Schemas.file,it);const $e=this._register(new a.ConfigurationService(_e.settingsResource,Ge));he.set(t.IConfigurationService,$e),await $e.initialize();const Xe=new Se.NativeStorageService(void 0,Ne,_e);he.set(we.IStorageService,Xe),await Xe.initialize(),this._register((0,m.toDisposable)(()=>Xe.flush())),he.set(ge.IRequestService,new x.SyncDescriptor(ce.RequestService)),he.set(o.IChecksumService,new x.SyncDescriptor(s.ChecksumService));const tt=h.ProxyChannel.toService(Ne.getChannel("nativeHost"),{context:this.configuration.windowId});he.set(Z.INativeHostService,tt),he.set(l.IDownloadService,new x.SyncDescriptor(c.DownloadService));const rt=this._register(new me.ActiveWindowManager(tt)),ft=new h.StaticRouter(Be=>rt.getActiveClientId().then(st=>Be===st));he.set(q.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ft)));let Qe,Ke,ct=(0,Ae.getTelemetryLevel)(Ue,_e);if(ct>=1){Ke=new Fe.TelemetryLogAppender(Ve,_e);const{appRoot:Be,extensionsPath:st,installSourcePath:gt}=_e;if(Ue.aiConfig&&Ue.aiConfig.asimovKey&&ct>=2){const lt=new We.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>lt.flush())),Ke=(0,Ae.combinedAppender)(lt,Ke)}Qe=new De.TelemetryService({appender:Ke,commonProperties:(0,ke.resolveCommonProperties)(Ge,(0,A.release)(),(0,A.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Be,st]},$e)}else Qe=Ae.NullTelemetryService,Ke=Ae.NullAppender;this.server.registerChannel("telemetryAppender",new Pe.TelemetryAppenderChannel(Ke)),he.set(Re.ITelemetryService,Qe);const dt=new Je.CustomEndpointTelemetryService($e,Qe,Ve,_e);return he.set(Re.ICustomEndpointTelemetryService,dt),he.set(O.IExtensionManagementService,new x.SyncDescriptor(M.ExtensionManagementService)),he.set(O.IExtensionGalleryService,new x.SyncDescriptor(T.ExtensionGalleryService)),he.set(O.IExtensionTipsService,new x.SyncDescriptor(F.ExtensionTipsService)),he.set(_.ILocalizationsService,new x.SyncDescriptor(W.LocalizationsService)),he.set(n.IDiagnosticsService,new x.SyncDescriptor(r.DiagnosticsService)),he.set(Te.IUserDataSyncAccountService,new x.SyncDescriptor(Te.UserDataSyncAccountService)),he.set(ve.IUserDataSyncLogService,new x.SyncDescriptor(Le.UserDataSyncLogService)),he.set(ve.IUserDataSyncUtilService,new Oe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),he.set(O.IGlobalExtensionEnablementService,new x.SyncDescriptor(w.GlobalExtensionEnablementService)),he.set(ae.IIgnoredExtensionsManagementService,new x.SyncDescriptor(ae.IgnoredExtensionsManagementService)),he.set(re.IExtensionsStorageSyncService,new x.SyncDescriptor(re.ExtensionsStorageSyncService)),he.set(ve.IUserDataSyncStoreManagementService,new x.SyncDescriptor(de.UserDataSyncStoreManagementService)),he.set(ve.IUserDataSyncStoreService,new x.SyncDescriptor(de.UserDataSyncStoreService)),he.set(H.IUserDataSyncMachinesService,new x.SyncDescriptor(H.UserDataSyncMachinesService)),he.set(ve.IUserDataSyncBackupStoreService,new x.SyncDescriptor(Ce.UserDataSyncBackupStoreService)),he.set(ve.IUserDataAutoSyncEnablementService,new x.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),he.set(ve.IUserDataSyncResourceEnablementService,new x.SyncDescriptor(ie.UserDataSyncResourceEnablementService)),he.set(ve.IUserDataSyncService,new x.SyncDescriptor(oe.UserDataSyncService)),he.set(qe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:$e.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:$e.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0},$e,He,Qe))),new N.InstantiationService(he)}initChannels(he){const Ue=new y.ExtensionManagementChannel(he.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const Me=h.ProxyChannel.fromService(he.get(_.ILocalizationsService));this.server.registerChannel("localizations",Me);const Ne=h.ProxyChannel.fromService(he.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ne);const _e=new y.ExtensionTipsChannel(he.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",_e);const et=h.ProxyChannel.fromService(he.get(o.IChecksumService));this.server.registerChannel("checksum",et);const Ve=new Oe.UserDataSyncMachinesServiceChannel(he.get(H.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ve);const nt=h.ProxyChannel.fromService(he.get(Re.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const He=new Oe.UserDataSyncAccountServiceChannel(he.get(Te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ge=new Oe.UserDataSyncStoreManagementServiceChannel(he.get(ve.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ge);const it=new ue.UserDataSyncChannel(he.get(ve.IUserDataSyncService),he.get(K.ILogService));this.server.registerChannel("userDataSync",it);const $e=this._register(he.get(B.IInstantiationService).createInstance(Ee.UserDataAutoSyncService)),Xe=new Oe.UserDataAutoSyncChannel($e);this.server.registerChannel("userDataAutoSync",Xe);const tt=he.get(qe.ILocalPtyService),rt=h.ProxyChannel.fromService(tt);this.server.registerChannel(xe.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(he){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const Me=(0,k.toErrorMessage)(Ue,!0);!Me||he.error(`[uncaught exception in sharedProcess]: ${Me}`)})}}async function be(Ie){const he=new pe(Ie);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await he.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=be})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0884da1650baa24994d23d2a3742823c1186e526/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
